ChatHandler = class(Turbine.UI.Control)
function ChatHandler:Constructor()
    Turbine.UI.Control.Constructor(self)

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.playerName = self.player:GetName()
end

function ChatHandler:SetParseFunction(dpsHandler)

    self.dpsHandler = dpsHandler
    Turbine.Chat.Received = function(sender, args)
        if args.ChatType == Turbine.ChatType.PlayerCombat then

            -- Remove all colour 
            local removedColours = string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1")
            --ChatOutput(removedColours)

            -- Damage case
            local Source, HitType, SkillName, Target, damage, damageType = string.match(removedColours,"^(.*) scored a (.*)hit with (.*) on (.*) for (.-) (.*)%.$")
            --local damage, damageType = string.match(string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"),"for (.-) (.*)%.$")
            --ChatOutput()
            
            --ChatOutput(HitType)
    
            if damage and self.playerName == Source then
                --ChatOutput("Name: " .. Source .. " Type: " .. HitType .. " Skill Type: " .. SkillName .. " Target: " .. Target .. " Damage: " .. damage .. " Damage Type: " .. damageType)
                self:ParseDamageString(string.gsub(Source,"^[Tt]he ",""), HitType, SkillName, string.gsub(Target,"^[Tt]he ",""), damage, damageType)
                --hatOutput(string.gsub(damage, ",", ""))-- .. damageType)
    
            end
        end
    end
end

function ChatHandler:ParseDamageString(Source, HitType, SkillName, Target, damage, damageType)

    -- Handle hit type 
    --local ParsedType = self.HitTypeData[HitType]

    local Type, MP = string.match(damageType, "(.*)%sdamage to (.*)$")

    --ChatOutput(HitType .. "a")
    --ChatOutput(Type .. "a")
    --ChatOutput(self.DamagetTypeData[Type])
    --ChatOutput(MP)

    if MP ~= "Morale" or self.playerName ~= Source then return end

    local cleanedDamage = tonumber(damage:gsub(",", ""), 10)
    self.dpsHandler:HandleDamage(cleanedDamage, Type, HitType, SkillName, Target)
end



