AuraOptions = class(Turbine.UI.Control)
function AuraOptions:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10 - 2, 10 - 2)
    SingleBackground:SetSize(730 + 4, 450 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10, 10)
    SingleBackground:SetSize(730, 450)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    if not(Auras) then return end

    local data = Auras:GetData()
    local base = Auras:GetBase()

    local container = Turbine.UI.ListBox()
    container:SetParent(SingleBackground)
    container:SetSize(700, 400)
    container:SetPosition(10, 30)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)
    --container:SetBackColor(GetRandomColour())

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( SingleBackground )
    containerScrollbar:SetPosition( 710 - 10, 30 )
    containerScrollbar:SetSize( 10, 400 )
    container:SetVerticalScrollBar( containerScrollbar )

    for key, value in spairs(base,
    function(t,a,b)
        if a < b then return true end
    end) do container:AddItem(self:createSkillBar(key, data[key])) end

end


function AuraOptions:createSkillBar(name, load)
    local pluginBar = Turbine.UI.Control()
    pluginBar:SetSize(800, 40)
    pluginBar:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local backgroundBar = Turbine.UI.Control()
    backgroundBar:SetSize(800, 38)
    backgroundBar:SetPosition(0, 1)
    backgroundBar:SetParent(pluginBar)
    backgroundBar:SetMouseVisible(false)
    backgroundBar:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    --pluginBar:SetBackColor(GetRandomColour())

    local nameLabel = Turbine.UI.Label()
    nameLabel:SetParent(pluginBar)
    nameLabel:SetSize(150, 30)
    nameLabel:SetPosition(0, 5)
    nameLabel:SetMouseVisible(false)
    nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    nameLabel:SetMultiline(true)
    nameLabel:SetText(name)

    local EffectBox = Turbine.UI.Lotro.CheckBox()
    EffectBox:SetParent(pluginBar)
    EffectBox:SetPosition(160, 10)
    EffectBox:SetSize(120,20)
    EffectBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    EffectBox:SetChecked(load == 0)
    EffectBox:SetText("Never load")
    EffectBox:SetVisible(true)

    
    local EffectBox2 = Turbine.UI.Lotro.CheckBox()
    EffectBox2:SetParent(pluginBar)
    EffectBox2:SetPosition(260, 10)
    EffectBox2:SetSize(120,20)
    EffectBox2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    EffectBox2:SetChecked(load == 1)
    EffectBox2:SetText("Always load")
    EffectBox2:SetVisible(true)

    
    local EffectBox3 = Turbine.UI.Lotro.CheckBox()
    EffectBox3:SetParent(pluginBar)
    EffectBox3:SetPosition(370, 10)
    EffectBox3:SetSize(120,20)
    EffectBox3:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    EffectBox3:SetChecked(load == 2)
    EffectBox3:SetText("Instance load")
    EffectBox3:SetVisible(true)

    
    local EffectBox4 = Turbine.UI.Lotro.CheckBox()
    EffectBox4:SetParent(pluginBar)
    EffectBox4:SetPosition(490, 10)
    EffectBox4:SetSize(120,20)
    EffectBox4:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    EffectBox4:SetChecked(load == 3)
    EffectBox4:SetText("Pvp load")
    EffectBox4:SetVisible(true)

    local Button2 = Turbine.UI.Lotro.Button()
    Button2:SetParent(pluginBar)
    Button2:SetSize(80, 20)
    Button2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    Button2:SetMouseVisible(true)
    Button2:SetVisible(false)
    Button2:SetPosition(620, 10)
    Button2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    Button2:SetText("Save")

    EffectBox.CheckedChanged = function()
        if EffectBox:IsChecked() then
            EffectBox2:SetChecked(false)
            EffectBox3:SetChecked(false)
            EffectBox4:SetChecked(false)
            Auras:ChangeData(name, 0)
            ChatOutput("Changed loading of " .. name .. " to Never load")
        end
    end

    EffectBox2.CheckedChanged = function()
        if EffectBox2:IsChecked() then
            EffectBox:SetChecked(false)
            EffectBox3:SetChecked(false)
            EffectBox4:SetChecked(false)
            Auras:ChangeData(name, 1)
            ChatOutput("Changed loading of " .. name .. " to Always load")
        end
    end

    EffectBox3.CheckedChanged = function()
        if EffectBox3:IsChecked() then
            EffectBox:SetChecked(false)
            EffectBox2:SetChecked(false)
            EffectBox4:SetChecked(false)
            Auras:ChangeData(name, 2)
            ChatOutput("Changed loading of " .. name .. " to Instance load")
        end
    end

    EffectBox4.CheckedChanged = function()
        if EffectBox4:IsChecked() then
            EffectBox:SetChecked(false)
            EffectBox2:SetChecked(false)
            EffectBox3:SetChecked(false)
            Auras:ChangeData(name, 3)
            ChatOutput("Changed loading of " .. name .. " to Pvp load")
        end
    end

    Button2.Click = function()
    end

    return pluginBar
end

AuraHandler = class(Turbine.UI.Control)
function AuraHandler:Constructor()
    Turbine.UI.Control.Constructor(self)

    self.data = LoadTable(Turbine.DataScope.Character, "PrimeAuras")

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.ItemTools = AuraCollection.ItemToolHandler()



    -- 0 = never load | 1 = always load | 2 = instance load | 3 = pvp load

    self.auras = {
        ["Portents"] = 1,
        ["Revive Tracker"] = 2,
        ["Captain Pet Tracker"] = Turbine.Gameplay.Class.Captain == self.player:GetClass() and 2 or 0,
        ["Captain Motivating Speech Tracker"] = Turbine.Gameplay.Class.Captain == self.player:GetClass() and 1 or 0,
        ["Loremaster Pet Debuff Tracker"] = Turbine.Gameplay.Class.LoreMaster == self.player:GetClass() and 2 or 0,
        ["Loremaster Air Lore Tracker"] = Turbine.Gameplay.Class.LoreMaster == self.player:GetClass() and 2 or 0,
        ["Bear Blue Mark Tracker"] = Turbine.Gameplay.Class.Beorning == self.player:GetClass() and 1 or 0,
        ["Bear Red Mark Tracker"] = Turbine.Gameplay.Class.Beorning == self.player:GetClass() and 1 or 0,
        ["Scrope status"] = 2,
        ["Shadow Zone Tracker"] = 2,
        ["Burglar Trick Tracker"] = Turbine.Gameplay.Class.Burglar == self.player:GetClass() and 2 or 0,
    }

    self.reloadableAuras = {
        ["Loremaster Air Lore Tracker"] = true,
        ["Bear Blue Mark Tracker"] = true,
        ["Bear Red Mark Tracker"] = true,
        ["Burglar Trick Tracker"] = true,
    }

    self.itemAuras = {
        ["Portents"] = true,
        ["Threshold Jewellery"] = true,
    }

    self.otherAuras = {
        ["Revive Tracker"] =  AuraCollection.ReviveTracker,
        ["Captain Motivating Speech Tracker"] = AuraCollection.CaptainMotivated,
        ["Captain Pet Tracker"] = AuraCollection.CappyPetBanner,
        ["Loremaster Pet Debuff Tracker"] = AuraCollection.LMPetDebuffs,
        ["Loremaster Air Lore Tracker"] = AuraCollection.LMAirLore,
        ["Bear Blue Mark Tracker"] = AuraCollection.BearMarkBlueTracker,
        ["Bear Red Mark Tracker"] = AuraCollection.BearMarkRedTracker,
        ["Scrope status"] = AuraCollection.ScropeStatus,
        ["Shadow Zone Tracker"] = AuraCollection.ShadowPuddleTracker,
        ["Burglar Trick Tracker"] = AuraCollection.BurglarDebuffs,
    }

    self.status = 1

    self.activeAuras = {}

    if self.data == nil then self.data = {} end

    for key, value in pairs(self.auras) do
        if self.data[key] == nil then
            self.data[key] = value
        end
    end

    for key, value in pairs(self.data) do
        if value == 1 and self.auras[key] then
            self:Load(key, true)
        end
    end
end

function AuraHandler:SetCallbacks(Name, value)
    if Name == "Portents" then
        self.ItemTools:LoadPortents(value)
    else
        if value then
            self.activeAuras[Name]:SetCallbacks()
        else
            self.activeAuras[Name]:RemoveCallbacks()
        end
        
    end


end

function AuraHandler:Load(Name, bool)
    if not(self.auras[Name]) then return end
    if self.itemAuras[Name] then
        self:SetCallbacks(Name, bool)
    elseif bool then
        if not(self.activeAuras[Name]) and self.otherAuras[Name] then
            self.activeAuras[Name] = self.otherAuras[Name]()
        end
    else
        if self.activeAuras[Name] then
            self.activeAuras[Name]:Unload()
            self.activeAuras[Name] = nil
        end
    end


end

function AuraHandler:HandleRaidLoads(bool)
    for key, value in pairs(self.data) do
        if value == 2 then
            self:Load(key, bool)
        end
    end

    if bool then self.status = 2 else self.status = 1 end
end

function AuraHandler:HandlePvpLoads(bool)
    for key, value in pairs(self.data) do
        if value == 3 then
            self:Load(key, bool)
        end
    end
    if bool then self.status = 3 else self.status = 1 end
end

function AuraHandler:GetData()
    return self.data
end

function AuraHandler:GetBase()
    return self.auras
end

function AuraHandler:ChangeData(key, value)

    self.data[key] = value
end

function AuraHandler:ReloadAurasWithDelay()
    self.reloadTime = Turbine.Engine.GetGameTime() + 5
    self:SetWantsUpdates(true)
end

function AuraHandler:ReloadAuras()
    for key, value in pairs(self.reloadableAuras) do
        if self.activeAuras[key] then
            self.activeAuras[key]:RemoveCallbacks()
            self.activeAuras[key]:SetCallbacks()
        end
    end
end

function AuraHandler:Update()
    if Turbine.Engine.GetGameTime() > self.reloadTime then
        self:ReloadAuras()
        self:SetWantsUpdates(false)
    end
end

function AuraHandler:Close()
    self.ItemTools:Close()

    for key, value in pairs(self.activeAuras) do
        value:Unload()
    end

    SaveTable(Turbine.DataScope.Character, "PrimeAuras", self.data)
end