PrimeUIOptions = class(Turbine.UI.Control)
function PrimeUIOptions:Constructor(parent)
    local width = 750
    local height = 500
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    self.notChanging = false

    self.BorderBackground = Turbine.UI.Control()
    self.BorderBackground:SetParent(self)
    self.BorderBackground:SetPosition(10 - 2, 10 - 2)
    self.BorderBackground:SetSize(730 + 4, 450 + 4)
    self.BorderBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.Background = Turbine.UI.Control()
    self.Background:SetParent(self)
    self.Background:SetPosition(10, 10)
    self.Background:SetSize(730, 450)
    self.Background:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    --if true then return end

    self.infoWindow = InfoWindow()

    self.treeviewBoxes = {}
    self.treeviewOptions = {}

    self.Moving = false

    self.listBoxCategories = {
        ["Effects"] = true,
        ["Skills"] = true,
        ["PlayerHits"] = true,
        ["EnemyHits"] = true,
        ["EffectAdded"] = true,
        ["EffectRemoved"] = true,
        ["PartyChat"] = true,
        ["StandardChat"] = true,
        ["SayChat"] = true,
        ["HealthThreshold"] = true,
        ["EffectAdded_Group"] = true,
        ["EffectAdded_Target"] = true,
        ["Target_HealthThreshold"] = true,
        ["Highlight_On_Effect"] = true,
        ["PlayerHeal"] = true,
        ["PlayerBenefit"] = true,
        ["Circle Timer"] = true,
        ["Quickslots"] = true,
        ["FightStart"] = true,
        ["FightEnd"] = true,
        ["FightPhase"] = true,
        ["CCBreak"] = true,
        ["EventTrigger"] = true,
        ["DefeatEvent"] = true,
        ["DNFApplied"] = true,
        ["DNFRemoved"] = true,
    }

    self.UIElementInfoStrings = {
        ["Icon"] = "An icon element that can be set to show up under specific circumstances. There is one important settings conjuction will cause the icon to show up if ALL conditions are satisfied. If this setting is turned off the icon will show up if ANY condition is satisfied.",
        ["Text"] = "A text element that can be set to show up under specific circumstances. There is one important settings conjuction will cause the icon to show up if ALL conditions are satisfied. If this setting is turned off the icon will show up if ANY condition is satisfied.",
        ["TimerIcon"] = "An icon element which utilizes a timer as its main function. It can be started with various triggers. As well as its visiblity can toggeled for various situations.",

        ["MoraleBar"] = "A morale bar that has multiple options to changes its layout.",
        ["MoraleBar_Target"] = "A morale bar of your current target that has multiple options to changes its layout.",
        ["PowerBar_Target"] = "A power bar of your current target that has multiple options to changes its layout.",
        ["PowerBar"] = "A power bar that has multiple options to changes its layout.",
        ["WrathBar"] = "A power bar that has multiple options to changes its layout.",
        ["PetMoraleBar"] = "A morale bar for pets",

        ["ResourceBar"] = "A resource bar to track class specific resources in a modern layout, there are many options to change its look. Currenlty supported classes Beorning (blue), Champion, Brawler, Hunter, Guardian (blue), RuneKeeper & Weaver.",
        ["Ballad Bar"] = "Three bars that indicate the current state of your ballads.",

        ["BuffBar"] = "A bar of icons that can be generated with various triggers.",
        ["BuffBar_Target"] = "A bar of icons that can be generated with effects added to your current target.",

        ["Skills"] = "A skill bar that populates with LOTRO quickslots to have skills in easily configurable positions. It also supports any other quickslot type using the quickslot trigger feature.",

        ["ValueBar"] = "A timer bar with minimal layout.",
        ["Timer"] = "A simple timer with various layout options. Various trigger can start this timer. Having the text of a timer as <name> will result in the UI trying to replace the text with the target of the effect.",
        ["TimerGroup"] = "A timer group where specified triggers will start new timers and add them to timer group. Timers that are of the same trigger but a different stack will attempt to refresh already existing timers. Having the text of a timer as <name> will result in the UI trying to replace the text with the target of the effect.",
        ["Circle Timer"] = "A simple circle timer with various layout options. Various trigger can start this timer. Having the text of a timer as <name> will result in the UI trying to replace the text with the target of the effect.",

        ["Countdown"] = "Start a countdown based on various triggers. There can only be one countdown active at the time.",
        ["Sound"] = "Play a sound on various triggers. This requires the Prime Sound Player to be running.",

        ["SkillLabel"] = "A simple label with background and timer.",
        ["Alert"] = "A big text alert that only allows one alert at the time to show.",
        ["AlertGroup"] = "This UI element allows multiple alerts to be shown at the same time.",

        ["Note Event"] = "Interact with the currently active note.",
        ["Note Activation"] = "Set a new active note.",

        ["Effect Listbox"] = "A listbox that contains effect icons that can be modified in multiple ways.",
    }

    self.optionInfoText = {
        ["Icon"] = "Changes the icon of the UI element. Click on the white box or current icon to bring up the icon selection menu. Alternatively you can enter the ID of an icon.",
        ["Colour"] = "Changes varies colours setting. Each scrollbar represents a different channel of the ARGB system. (Alpha changes the opacity of the colour, a value of 0 renders a colour invisible)",
        ["Font"] = "Set the font for a UI element. Some UI element will scale the font while others do not. (FixedSys15 is the only always working monospaced font)",
        ["Timer_Stack_Direction"] = "Determines which way timers are added and sorted to a timergroup. Addition will work from the opposite side of the direction.",
        ["Timer_Sorting"] = "Determines which sorting is used for a timergroup.",
        ["TextAlignment"] = "Determines the alignment of the text within the current UI element.",
        ["StackTextAlignment"] = "Determines the alignment of the text within the current UI element.",
        ["Alignment"] = "Sets the alignment of the current UI element in respect to the parent PrimeUI.",

        -- Number
        ["Height"] = "Sets the height of current UI element if applicable",
        ["Width"] = "Sets the width of current UI element if applicable",
        ["OffsetAbove"] = "Sets the offset above this UI element with the above UI element within the PrimeUI or the top of the parent UI.",
        ["OffsetBelow"] = "Sets the offset below this UI element with the below UI element within the PrimeUI or the bottom of the parent UI.",
        ["Scale"] = "Sets the scaling factor of the current UI element or the UI elements within/created.",
        ["X"] = "Sets the X coordinate (only applicable if in advanced mode)",
        ["Y"] = "Sets the Y coordinate (only applicable if in advanced mode)",
        ["BorderSize"] = "The width of the border around the UI element.",
        ["Intervals"] = "Determines the amount of bars that will be drawn over the bar.",
        ["BoxOffset"] = "Distance between the boxes.",

        ["Text"] = "Changes the text of the current UI element. In the case of the Text UI element these keywords will have additional function if used between \"<\"\">\":"
.. [[ 
State - In an instance or not
Instance_Name - Name of the instance or all
Instance_Tier - Tier of instance or \"\"
Boss_Name - Name of the boss fight
Boss_Tier - Tier of the boss fight
Boss_Completion_Time - Fight duration (wipe or completion)
Boss_Wipes - Amount of wipes in a fight
Player_Name - Name of the player
Player_Class - Class of the player
Death_Count_Character - Amount of deaths on character
Death_Count_Account - Amount of deaths on account
Death_Count_Misadventure_Character - Amount of Misadventure deaths on character
Death_Count_Misadventure_Account - Amount of Misadventure deaths on account
Player_Morale
Player_Max_Morale
Player_Base_Max_Morale
Player_Morale_Percentage
Player_Temporary_Morale
Player_Max_Temporary_Morale
Player_Power 
Player_Max_Power
Player_Base_Max_Power 
Player_Power_Percentage
Player_Temporary_Power 
Player_Max_Temporary_Power
Player_Level 
Player_Is_In_Combat
Target_Name
Target_Morale 
Target_Max_Morale 
Target_Base_Max_Morale 
Target_Temporary_Morale 
Target_Max_Temporary_Morale 
Target_Power 
Target_Max_Power 
Target_Base_Max_Power 
Target_Temporary_Power
Target_Max_Temporary_Power
Target_Level
Pet_Morale
Pet_Max_Morale
Pet_Morale_Percentage
Pet_Temporary_Morale
Pet_Max_Temporary_Morale
Pet_Name                                                                                                                                                                          
                                                                                                                                                                                 
                                                                                                                                                                          
                                                                                                                                                                                 ]],

        -- Setting
        ["AllEffects"] = "Turning this setting on will forego specific trigger settings for effects but instead process any effect.",
        ["OnlyBuffs"] = "Only allows buffs to go through selection.",
        ["OnlyDebuffs"] = "Only allows debuffs to go through selection.",
        ["AllHighlight"] = "Highlights every element within this UI element without the need to specify this for these specific elements",
        ["Reset_On_Retarget"] = "This setting will wipe the buffbar when a target swap event is detected.",
        ["AlwaysVisible"] = "Will always turn this UI element visible.",
        ["Clockwise"] = "This setting will turn the visual timer direction.",
        ["GrayOut"] = "Will slightly grayout the timericon.",
        ["Hide_While_Not_Active"] = "Will hide this element when there is no timer active.",
        ["Highlight"] = "Enabling this will highlight this element.",
        ["HighlightWhileOff"] = "Enabling this will highlight this element when it is considered \"off\".",
        ["ShowText"]  = "This setting will toggle the visiblity of the text.",
        ["Visual_Timer"] = "This setting will enable the visual timer for this element.",
        ["Static_Timers"] = "This setting will cause every trigger event associated with this UI element to create a timer that is always visible within the group timer UI.",
        ["Full_Border"] = "This setting will cause the UI element to draw a full border around the innerbox.",
        ["RKLayout"] = "This setting will cause the UI element to go up to only 10 charges instead of 20.",
        ["Conjuction"] = "This will cause the icon to show up if ALL conditions are satisfied. If this setting is turned off the icon will show up if ANY condition is satisfied.",

        -- Triggers
        ["Effects"] = "This places a trigger on any effect added that matches the conditions specified. This trigger type will keep track when an effect is added and removed and update the UI accordingly.",
        --["Skills"] = "Whenever a skill matching ",
        ["PlayerHits"] = "Whenever the player hits any target with a hit which name matches the conditions specified it utilizes the function of the UI.",
        ["EnemyHits"] = "Whenever the player is hit by a hit which name matches the conditions specified it utilizes the function of the UI.",
        ["EffectAdded"] = "Whenever an effect is added to the player that matches the conditions specified it utilizes the function of the UI.",
        ["EffectRemoved"] = "Whenever an effect is removed from the player that matches the conditions specified it utilizes the function of the UI.",
        ["PartyChat"] = "When a phrase is detected in party chat (fellowship or raid) it utilizes the function of the UI. (Markup colours have to be added to the matching string)",
        ["StandardChat"] = "When a phrase is detected in standard chat it utilizes the function of the UI. (Markup colours have to be added to the matching string)",
        ["SayChat"] = "When a phrase is detected in say chat it utilizes the function of the UI. (Markup colours have to be added to the matching string)",
        ["HealthThreshold"] = "When a player falls below or moves above a set threshold it utilizes the function of the UI. (This effect has a cooldown)",
        ["EffectAdded_Group"] = "Whenever an effect is added to any player in the group (does not include the player) that matches the conditions specified it utilizes the function of the UI.",
        ["EffectAdded_Target"] = "Whenever an effect is added to the target of the player that matches the conditions specified it utilizes the function of the UI.",
        ["Target_HealthThreshold"] = "When a target falls below or moves above a set threshold it utilizes the function of the UI. (This effect has a cooldown)",

        ["All_Buffs"] = "Enabling this will make this UI element track all buffs",
        ["All_Debuffs"] = "Enabling this will make this UI element track all debuffs",
        ["Flipped_Layout"] = "This setting will cause the listbox to fill its items in a flipped manner. Instead of top left or bottom right (Reverse_Fill enabled) items will instead fill from bottom left and top right.",
        ["Reverse fill"] = "This will cause the listbox to fill up from bottom right instead of top left. (Flipped if Flipped_Layout is enabled)",
        ["Show_Duration"] = "Show duration on the UI element",
        ["Orientation"] = "Sets the orientation of the fill direction of a listbox.",
        ["Effect_Size"] = "The size of the effect boxes minus spacing and bordersize.",
        ["Spacing"] = "Spacing inbetween items in a list box.",
        ["Visibility_Threshold"] = "Only if the duration is lower than this number will it be shown.",
        ["Show_Stack"] = "Shows the stack on the effect if applicable.",

        ["Disable_Player_Vitals"] = "Removes the player vitals from the UI. This can cause issues with other plugins and/or when loading/unloading, to fix this simply disable this optoin and relog.",

        ["DNFApplied"] = "Trigger that fires whenever a DNF is applied to a member of your party. Important note: this does not track DNFS on the player themselves.",
        ["DNFRemoved"] = "Trigger that fires whenever a DNF is removed from a party member. Important note: this does not track DNFS on the player themselves.",

        ["DefeatEvent"] = "Trigger that fires whenver someone around you is defeated or gets defeated. Allowing you to start triggers based on enemies you defeat.",

        ["EventTrigger"] = "This trigger can be fired by the EventTrigger UI Element or when specific components in other UI elements expire (for example at the end of a timer in a timer group). This allows you to start tools based on expiration of other triggers.",
        ["FightStart"] = "This trigger is fired whenever a fight that is tracked by the plugin starts.",
        ["FightPhase"] = "This trigger is fired whenever a fight that is tracked by the plugin that is in progress phases to the next phase.",
        ["FightEnd"] = "This trigger is fired whenever a fight that is tracked by the plugin ends, either by completion or wipe.",

        ["PlayerHeal"] = "Whenver the player is healed by anything or anyone this trigger will fire based on conditions; if the name of this healing skills matches the user input the trigger will fire.",
        ["PlayerBenefit"] = "Many events in this game such as heals or buffs are signaled by a line in the combat log that states that a certain benefit is applied to the player. This trigger can be used to start functionality of the UI element based on a matching benefit.",

        ["Timer_Height"] = "The height of timers in the timergroup. This also influences the size of the icon as icons are a square.",
        ["Timer_Offset"] = "The space inbetween timers in a timergroup.",

        ["Reset_On_Fight_End"] = "Whenver a fight that is tracked by the plugin ends this will remove all timers from the timergroup. (For example this can remove enrage timers).",
        ["Spark"] = "Enables a sparking graphic at the edge of timer bars for visiblity purposes.",

        ["NickName"] = "Name of the UI element given to it by the player for identifaction purposes when the PrimeUI is in advanced mode.",
        
        ["Offset"] = "Offset between items within this UI element.",


    }

    self.textAlignments = {
        ["BottomCenter"] = Turbine.UI.ContentAlignment.BottomCenter,
        ["BottomLeft"] = Turbine.UI.ContentAlignment.BottomLeft,
        ["BottomRight"]	= Turbine.UI.ContentAlignment.BottomRight,
        ["MiddleCenter"] = Turbine.UI.ContentAlignment.MiddleCenter,
        ["MiddleLeft"] = Turbine.UI.ContentAlignment.MiddleLeft,
        ["MiddleRight"] = Turbine.UI.ContentAlignment.MiddleRight,
        ["TopCenter"] = Turbine.UI.ContentAlignment.TopCenter,
        ["TopLeft"] = Turbine.UI.ContentAlignment.TopLeft,
        ["TopRight"] = Turbine.UI.ContentAlignment.TopRight,
    }

    self.contentAlignment = {
        ["Left"] = true,
        ['Middle'] = true,
        ["Right"] = true,
    }

    self.timerGroupAlignments = {
        ["Alphabetical"] = true,
        ["Alphabetical Reverse"] = true,
        ["Hight to Low (Remaining duration)"] = true,
        ["Low to High (Remaining duration)"] = true,
        ["Hight to Low (Max duration)"] = true,
        ["Low to High (Max duration)"] = true,
    }

    self.listboxOrientations = {
        ["Horizontal"] = true,
        ["Vertical"] = true,
    }


    self.timeStackAlignments = {
        ["Up"] = true,
        ["Down"] = true,
    }

    self.Classes = {
        ["Beorning"] = Turbine.Gameplay.Class.Beorning,
        ["Brawler"] = Turbine.Gameplay.Class.Brawler,
        ["Burglar"] = Turbine.Gameplay.Class.Burglar,
        ["Captain"] = Turbine.Gameplay.Class.Captain,
        ["Champion"] = Turbine.Gameplay.Class.Champion,
        ["Guardian"] = Turbine.Gameplay.Class.Guardian,
        ["Hunter"] = Turbine.Gameplay.Class.Hunter,
        ["LoreMaster"] = Turbine.Gameplay.Class.LoreMaster,
        ["Minstrel"] = Turbine.Gameplay.Class.Minstrel,
        ["RuneKeeper"] = Turbine.Gameplay.Class.RuneKeeper,
        ["Warden"] = Turbine.Gameplay.Class.Warden,
        ["BlackArrow"] = Turbine.Gameplay.Class.BlackArrow,
        ["Defiler"] = Turbine.Gameplay.Class.Defiler,
        ["Reaver"] = Turbine.Gameplay.Class.Reaver,
        ["Stalker"] = Turbine.Gameplay.Class.Stalker,
        ["WarLeader"] = Turbine.Gameplay.Class.WarLeader,
        ["Weaver"] = Turbine.Gameplay.Class.Weaver
    }

    self.alignments = {
        ["Left"] = true,
        ["Middle"] = true,
        ["Right"] = true,
    }

    self.UIElements = {
        ["Icon"] = true,
        ["Text"] = true,
        ["TimerIcon"] = true,

        ["MoraleBar"] = true,
        ["MoraleBar_Target"] = true,
        ["PowerBar_Target"] = true,
        ["PowerBar"] = true,
        ["WrathBar"] = true,
        ["PetMoraleBar"] = true,

        ["ResourceBar"] = true,
        ["Ballad Bar"] = true,

        ["BuffBar"] = true,
        ["BuffBar_Target"] = true,

        ["Skills"] = true,

        ["ValueBar"] = true,
        ["Timer"] = true,
        ["TimerGroup"] = true,
        ["Circle Timer"] = true,

        ["Countdown"] = true,
        ["Sound"] = true,

        ["SkillLabel"] = true,
        ["Alert"] = true,
        ["AlertGroup"] = true,

        ["Note Event"] = true,
        ["Note Activation"] = true,

        ["Effect Listbox"] = true,
    }

    self.SortOrderTable = {
        [1] = "Text",
        [2] = "Text",
        [10] = "Numerical",
        [20] = "Alignment",
        [21] = "Alignment",
        [22] = "Alignment",
        [23] = "Alignment",
        [24] = "Font",
        [30] = "Toggles",
        [35] = "Icon",
        [40] = "Colours",
        [50] = "Triggers",
        [60] = "Orientation",
    }

    --self.iconWindow = IconOverview()
    --self.effectWindow = HistoricalEffectOverview()
    --self.skillWindow = SkillOverview()
    --self.skillCodesWindow = SkillOverview2()

    self.IOWindow = IOWindow(self)
    self.NewWindow = NewWindow(self)

    self.leftBorder1 = Turbine.UI.Control()
    self.leftBorder1:SetParent(self)
    self.leftBorder1:SetSize(2, 450)
    self.leftBorder1:SetPosition(208, 10)
    self.leftBorder1:SetMouseVisible(false)
    self.leftBorder1:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.leftBorder1:SetBackColor(Turbine.UI.Color.Black)

    self.leftBorder2 = Turbine.UI.Control()
    self.leftBorder2:SetParent(self)
    self.leftBorder2:SetSize(3, 450)
    self.leftBorder2:SetPosition(204, 10)
    self.leftBorder2:SetMouseVisible(false)
    self.leftBorder2:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    --self.leftBorder2:SetBackColor(Turbine.UI.Color(0.6, 1, 1, 1))

    self.InfoBorderContainer = Turbine.UI.Control()
    self.InfoBorderContainer:SetParent(self)
    self.InfoBorderContainer:SetPosition(210, 10)
    self.InfoBorderContainer:SetSize(530, 95)
    self.InfoBorderContainer:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.InfoContainer = Turbine.UI.Control()
    self.InfoContainer:SetParent(self)
    self.InfoContainer:SetPosition(210, 10)
    self.InfoContainer:SetSize(530, 95 - 2)
    self.InfoContainer:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    self.InfoHeaderBackground = Turbine.UI.Label()
    self.InfoHeaderBackground:SetParent(self.InfoContainer)
    self.InfoHeaderBackground:SetSize(530, 52)
    self.InfoHeaderBackground:SetMouseVisible(false)
    self.InfoHeaderBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.InfoHeaderLabel = Turbine.UI.Label()
    self.InfoHeaderLabel:SetParent(self.InfoContainer)
    self.InfoHeaderLabel:SetSize(530 - 2, 50)
    self.InfoHeaderLabel:SetPosition(1, 0)
    self.InfoHeaderLabel:SetMouseVisible(false)
    --self.InfoHeaderLabel:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.InfoHeaderLabel:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    self.InfoHeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.InfoHeaderLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.InfoHeaderLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.InfoHeaderLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.InfoHeaderLabel:SetText("PrimeUI Options")

    self.GeneralPrimeUISettingsControl = Turbine.UI.Control()
    self.GeneralPrimeUISettingsControl:SetParent(self)
    self.GeneralPrimeUISettingsControl:SetPosition(210, 105)
    self.GeneralPrimeUISettingsControl:SetSize(530 - 10, 350)

    -- PrimeUI Options treeview
    self.PrimeUIOptionsTreeView = Turbine.UI.TreeView()
    self.PrimeUIOptionsTreeView:SetParent(self.InfoContainer)
    self.PrimeUIOptionsTreeView:SetSize(self.InfoContainer:GetWidth(), 20)
    self.PrimeUIOptionsTreeView:SetPosition(0, self.InfoHeaderBackground:GetHeight())
    self.PrimeUIOptionsTreeView:SetIndentationWidth(0)

    self.PrimeUIOptionsTreeNodes = self.PrimeUIOptionsTreeView:GetNodes()

    self.optionsListboxNode = PrimeUITools.OptionsHeader(self.InfoContainer:GetWidth(), 4, true)

    self.PrimeUIOptionsTreeNodes:Add(self.optionsListboxNode)

    -- PrimeUI general settings treeview toggle
    self.PrimeUISettingsTreeview = Turbine.UI.TreeView()
    self.PrimeUISettingsTreeview:SetParent(self.InfoContainer)
    self.PrimeUISettingsTreeview:SetSize(self.InfoContainer:GetWidth(), 20)
    self.PrimeUISettingsTreeview:SetPosition(0, self.InfoHeaderBackground:GetHeight() + 20)
    self.PrimeUISettingsTreeview:SetIndentationWidth(0)

    self.PrimeUISettingsTreeNodes = self.PrimeUISettingsTreeview:GetNodes()

    self.settingsListboxNode = PrimeUITools.OptionsHeader(self.InfoContainer:GetWidth(), 2, true)

    self.PrimeUISettingsTreeNodes:Add(self.settingsListboxNode)

    -- [[
    --]]

    self.SetupContainer = Turbine.UI.Control()
    self.SetupContainer:SetParent(self)
    self.SetupContainer:SetVisible(true)
    self.SetupContainer:SetPosition(210, 105)
    self.SetupContainer:SetSize(530 - 10, 350)
    self.SetupContainer:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    self.CurrentLeft = Turbine.UI.Control()
    self.CurrentLeft:SetParent(self.Background)
    self.CurrentLeft:SetPosition(0, 20)
    self.CurrentLeft:SetSize(22, 26)
    self.CurrentLeft:SetBackground(BackgroundHandler:GetBackground(0x411BAF1E))
    self.CurrentLeft:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

    self.CurrentRight = Turbine.UI.Control()
    self.CurrentRight:SetParent(self.Background)
    self.CurrentRight:SetPosition(195 - 23, 20)
    self.CurrentRight:SetSize(23, 26)
    self.CurrentRight:SetBackground(BackgroundHandler:GetBackground(0x411BAF20))
    self.CurrentRight:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

    self.CurrentMiddle = Turbine.UI.Control()
    self.CurrentMiddle:SetParent(self.Background)
    self.CurrentMiddle:SetPosition(22, 20)
    self.CurrentMiddle:SetSize(195 - 40, 26)
    self.CurrentMiddle:SetBackground(BackgroundHandler:GetBackground(0x411BAF19))
    self.CurrentMiddle:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

    self.CurrentLabel = Turbine.UI.Label()
    self.CurrentLabel:SetParent(self.Background)
    self.CurrentLabel:SetPosition(6, 23)
    self.CurrentLabel:SetSize(195, 20)
    self.CurrentLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
    self.CurrentLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    --self.CurrentLabel:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    self.CurrentLabel:SetText("PrimeUIs")

    self.PrimeUIContainer = Turbine.UI.TreeView()
    self.PrimeUIContainer:SetParent(self.Background)
    self.PrimeUIContainer:SetSize(200 - 10, self.Background:GetHeight() - 46)
    self.PrimeUIContainer:SetPosition(0, 46)
    self.PrimeUIContainer:SetVisible(true)
    self.PrimeUIContainer:SetWantsKeyEvents(true)
    self.PrimeUIContainer:SetMouseVisible(true)
    self.PrimeUIContainer:SetIndentationWidth( 0 )

    self.PrimeUIContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.PrimeUIContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    self.PrimeUIContainerScrollbar:SetParent( self.Background )
    self.PrimeUIContainerScrollbar:SetPosition( 200 - 10, 46 )
    self.PrimeUIContainerScrollbar:SetSize( 10, self.Background:GetHeight() - 46 )
    self.PrimeUIContainer:SetVerticalScrollBar( self.PrimeUIContainerScrollbar )

    self.ImportButton = Turbine.UI.Lotro.Button()
	self.ImportButton:SetParent(self.Background)
	self.ImportButton:SetSize(115, 40)
	self.ImportButton:SetPosition(0, 0)
    self.ImportButton:SetText("Import PrimeUI")

    self.ImportButton.Click = function()
        self.IOWindow:View()
    end

    self.NewButton = Turbine.UI.Lotro.Button()
	self.NewButton:SetParent(self.Background)
	self.NewButton:SetSize(80, 20)
	self.NewButton:SetPosition(115, 0)
    self.NewButton:SetText("New")

    self.NewButton.Click = function()
        self.NewWindow:View()
    end

    self.rootNodes = self.PrimeUIContainer:GetNodes()

    self.boxes = {}
    self.data = PrimeUIHandlerObject:GetData()

    for _, data in spairs(self.data, function(t, a, b) return t[a]["Name"] < t[b]["Name"] end) do
        self:CreateUIItem(self.SetupContainer, data)
    end

    local sortedUIElements = {}
    for key, value in pairs(self.UIElements) do table.insert( sortedUIElements, key ) end
    table.sort( sortedUIElements )

    self.UIElementOptions = UI.DropDownMenuControl(self, 400, "UI Element Dropdown Menu")
    for key, name in pairs(sortedUIElements) do
        --local menuItem = Turbine.UI.MenuItem( value )
        self.UIElementOptions:AddItem(name, 
        function()
            self.boxes[self.currentUI["Name"]]:SetParent(nil)
            self.boxes[self.currentUI["Name"]] = nil
            local count = tablelength(self.currentUI["PrimeUI"]) + 1
            local newTable = self:GetUIElementData(name, count)
            table.insert(self.currentUI["PrimeUI"], newTable)
            PrimeUIHandlerObject:Refresh(self.currentUI["Name"], self.currentUI["PrimeUI"])
            self.data = PrimeUIHandlerObject:GetData()
            self.treeviewBoxes[self.currentUI["Name"]].SourceLabel:MouseClick()

            self.UIElementOptions:SetVisible(false)
        end, self.UIElementInfoStrings[name], self.infoWindow)
    end

    self.AddButton = PrimeUITools.OptionsListBoxButton(self.InfoContainer:GetWidth() / 4, 20, "Add UI Element", function()
        if self.currentUI then
            self.UIElementOptions:ToggleVisible()
        end
    end)

    self.optionsListboxNode:AddItem(self.AddButton)

    self.MoveButton = PrimeUITools.OptionsListBoxButton(self.InfoContainer:GetWidth() / 4, 20, "Move PrimeUI", function()
        if self.currentUI then
            self.Moving = not(self.Moving)
            PrimeUIHandlerObject:Move(self.currentUI["Name"])
        end
    end)

    self.optionsListboxNode:AddItem(self.MoveButton)

    self.OutputButton = PrimeUITools.OptionsListBoxButton(self.InfoContainer:GetWidth() / 4, 20, "Output PrimeUI", function()
        if self.currentUI and self.notChanging then
            self.IOWindow:View(self.currentUI)
        end
    end)

    self.optionsListboxNode:AddItem(self.OutputButton)

    self.DeleteButton = PrimeUITools.OptionsListBoxButton(self.InfoContainer:GetWidth() / 4, 20, "Delete PrimeUI", function()
        if self.currentUI then
            local confirmationWindow = UI.ConfirmationWindow("Do you really want to delete this primeUI?", function() 
                if self.currentUI then
                    PrimeUIHandlerObject:Delete(self.currentUI["Name"])
                    self.rootNodes:Remove(self.treeviewBoxes[self.currentUI["Name"]])
                    self.treeviewBoxes[self.currentUI["Name"]]:SetParent(nil)
                    self.treeviewBoxes[self.currentUI["Name"]] = nil
                    self.boxes[self.currentUI["Name"]]:SetVisible(false)
                    self.boxes[self.currentUI["Name"]]:SetParent(nil)
                    self.boxes[self.currentUI["Name"]] = nil
                    self.InfoHeaderLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
                    self.InfoHeaderLabel:SetText("PrimeUIs")
                    self.currentUI = nil
                    self.data = PrimeUIHandlerObject:GetData()
                end
            end, function() end)
        end
    end)

    self.optionsListboxNode:AddItem(self.DeleteButton)

    -- Second row buttons
    self.UIElementOptionsButton = PrimeUITools.OptionsListBoxButton(self.InfoContainer:GetWidth() / 2, 20, "UI Element Options", function()
        if self.currentUI then
            self.SetupContainer:SetVisible(true)
            self.GeneralPrimeUISettingsControl:SetVisible(false)
        end
    end)

    self.settingsListboxNode:AddItem(self.UIElementOptionsButton)

    self.GeneralPrimeUISettingsButton = PrimeUITools.OptionsListBoxButton(self.InfoContainer:GetWidth() / 2, 20, "General PrimeUI Settings", function()
        if self.currentUI then
            self.SetupContainer:SetVisible(false)
            self.GeneralPrimeUISettingsControl:SetVisible(true)
        end
    end)

    self.settingsListboxNode:AddItem(self.GeneralPrimeUISettingsButton)

    self:CreateGeneralPrimeUIOptions()    
end

function PrimeUIOptions:Add(data)
    if not(self.boxes[data["Name"]]) and PrimeUIHandlerObject:AddUI(data) then
        self:CreateUIItem(self.SetupContainer, data)
        return true
    else
        local confirmationWindow = UI.ConfirmationWindow("A PrimeUI with this name already exists, do you want to override it?", function() 
            if data then
                PrimeUIHandlerObject:Delete(data["Name"])
                self.rootNodes:Remove(self.treeviewBoxes[data["Name"]])
                self.treeviewBoxes[data["Name"]]:SetParent(nil)
                self.treeviewBoxes[data["Name"]] = nil
                if self.boxes[data["Name"]] then
                    self.boxes[data["Name"]]:SetVisible(false)
                    self.boxes[data["Name"]]:SetParent(nil)
                    self.boxes[data["Name"]] = nil
                end
                self.InfoHeaderLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
                self.InfoHeaderLabel:SetText("PrimeUIs")
                self.data = PrimeUIHandlerObject:GetData()
                self:Add(data)
                self.IOWindow:SetVisible(false)
                ChatOutput("Overwrote the PrimeUI succesfully!")
            end
        end, function() 
            self.IOWindow:SetVisible(false)
            ChatOutput("Failed to add PrimeUI: Name already exists") 
        end)
        return false
    end
end

function PrimeUIOptions:CreateNew(name, advancedMode)
    if PrimeUIHandlerObject:AddUI({
        ["InstanceLoad"] = "All",
        ["RoleLoad"] = "All",
        ["ClassLoad"] = "All",
        ["CharLoad"] = false,
        ["ZoneLoad"] = false,
        ["GroupLoad"] = false,
        ["CharacterLoad"] = {},
        ["LineLoad"] = "All",
        ["ICLoad"] = true,
        ["OOCLoad"] = true,
        ["NeverLoad"] = false,
        ["X"] = 100,
        ["Y"] = 100,
        ["Name"] = name,
        ["PrimeUI"] = {},
        ["AdvancedMode"] = advancedMode
    }) then
        self.data = PrimeUIHandlerObject:GetData()
        for _, data in pairs(self.data) do
            if data["Name"] == name then
                self:CreateUIItem(self.SetupContainer, data)
            end
        end

        return true
    else
        return false
    end
end

function PrimeUIOptions:ExtendTreeview(data, width, func)

    if self.treeviewBoxes[data["Name"]] then return end

    local SourceNode = Turbine.UI.TreeNode()
    SourceNode:SetSize(width - 10, 20 + 2)

    SourceNode.SourceLabel = Turbine.UI.Label()
    SourceNode.SourceLabel:SetParent(SourceNode)
    SourceNode.SourceLabel:SetPosition(1,1)
    SourceNode.SourceLabel:SetSize(width - 10- 2, 20)
    SourceNode.SourceLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.SourceLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    SourceNode.SourceLabel:SetMouseVisible(true)

    SourceNode.LefLabel = Turbine.UI.Label()
    SourceNode.LefLabel:SetParent(SourceNode)
    SourceNode.LefLabel:SetPosition(0, 0)
    SourceNode.LefLabel:SetSize(30, 20)
    SourceNode.LefLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
    SourceNode.LefLabel:SetMouseVisible(false)

    SourceNode.RigthLabel = Turbine.UI.Label()
    SourceNode.RigthLabel:SetParent(SourceNode)
    SourceNode.RigthLabel:SetPosition(width - 157, 0)
    SourceNode.RigthLabel:SetSize(147, 20)
    SourceNode.RigthLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
    SourceNode.RigthLabel:SetMouseVisible(false)

    SourceNode.MidLabel = Turbine.UI.Label()
    SourceNode.MidLabel:SetParent(SourceNode)
    SourceNode.MidLabel:SetPosition(30, 0)
    SourceNode.MidLabel:SetSize(width - 70, 20)
    SourceNode.MidLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D201))
    SourceNode.MidLabel:SetMouseVisible(false)

    SourceNode.textLabel = Turbine.UI.Label()
    SourceNode.textLabel:SetParent(SourceNode)
    SourceNode.textLabel:SetPosition(1,1)
    SourceNode.textLabel:SetSize(width - 10- 2, 20)
    SourceNode.textLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.textLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    SourceNode.textLabel:SetMouseVisible(false)
    SourceNode.textLabel:SetText(data["Name"])

    SourceNode.SourceLabel.MouseEnter = function()
        SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FB))
        SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FB))
        SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D202))
    end

    SourceNode.SourceLabel.MouseLeave = function()
        SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
        SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
        SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D201))
    end

    SourceNode.SourceLabel.MouseDown = function()
        SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FC))
        SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FC))
        SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D203))
    end

    SourceNode.SourceLabel.MouseUp = function()
        SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
        SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
        SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D201))
    end

    SourceNode.ClickFunction = function()
        for key, value in pairs(self.boxes) do
            value:SetVisible(false)
        end
        if not(self.boxes[data["Name"]]) then
            self.boxes[data["Name"]] = func()
        end
        self.boxes[data["Name"]]:SetVisible(true)
        self.notChanging = false
        self:FillInfoContainer(data)
        self.notChanging = true
        if self.currentUI and self.Moving then
            PrimeUIHandlerObject:Move(self.currentUI["Name"])
            self.Moving = false
        end
        self.currentUI = data
    end

    SourceNode.SourceLabel.MouseClick = function()
        SourceNode.ClickFunction()
    end

    self.treeviewBoxes[data["Name"]] = SourceNode

    self.rootNodes:Add(SourceNode)
end

function PrimeUIOptions:FillInfoContainer(data)
    self.InfoHeaderLabel:SetText(data["Name"])
    self.InstanceButton:SetText(data["InstanceLoad"])
    self.RoleButton:SetText(data["RoleLoad"])
    self.ClassButton:SetText(data["ClassLoad"])
    self.LineButton:SetText(data["LineLoad"])
    self.OOCheckBox:SetChecked(data["OOCLoad"])
    self.ICheckBox:SetChecked(data["ICLoad"])
    self.NeverLoadCheckbox:SetChecked(data["NeverLoad"])
    self.AdvancedCheckbox:SetChecked(data["AdvancedMode"])
    self.CharacterButton:SetChecked(not(data["CharLoad"]))
    self.AllTierCheckbox:SetChecked(data["AllTiers"] == nil or data["AllTiers"])
    self.InstanceTierButton:SetText(data["InstanceTier"])
end

function PrimeUIOptions:CreateUIItem(parent, ObjectData, override)
    local width = parent:GetWidth() - 10
    local height = parent:GetHeight()

    local data1 = ObjectData["PrimeUI"]
    local name = ObjectData["Name"]

    local treeviewFunction = function()
        local valuebarBackground = Turbine.UI.Control()
        valuebarBackground:SetParent(parent)
        valuebarBackground:SetSize(width + 10, height)
        valuebarBackground:SetVisible(false)
        --valuebarBackground:SetMouseVisible(false)
        --valuebarBackground:SetBackColor(GetRandomColour())
    
        local valuebar = Turbine.UI.TreeView()
        valuebar:SetParent(valuebarBackground)
        valuebar:SetSize(width, height)
        valuebar:SetIndentationWidth(0)
    
        local valuebarNodes = valuebar:GetNodes()
        --valuebar:SetMouseVisible(false)
    
        self:UITreeView(data1, width, valuebarNodes, name)
    
        local valuebarScrollbar = Turbine.UI.Lotro.ScrollBar()
        valuebarScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
        valuebarScrollbar:SetParent(valuebarBackground)
        valuebarScrollbar:SetPosition(width, 0)
        valuebarScrollbar:SetSize(10, height)
        valuebar:SetVerticalScrollBar(valuebarScrollbar)

        return valuebarBackground
    end
    --valuebar:ExpandAll()
    if override then
        treeviewFunction()
    end

    self:ExtendTreeview(ObjectData, 200, treeviewFunction)
end

function PrimeUIOptions:GetUIElementData(type, id)
    if type == "Icon" then
        return {
            ["Order"] = id,
            ["Type"] = "Icon",
            ["Height"] = 32,
            ["Width"] = 32,
            ["Scale"] = 1,
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
            ["BorderSize"] = 0,
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},
            ["Alignment"] = "Middle",
            ["TextAlignment"] = "MiddleCenter",
            ["Text"] = "",
            ["Font"] = "TrajanProBold16",
            ["Font_Colour"] = {[1] = 1, [2] = 1, [3] = 1, [4] = 1},
            ["Icon"] = 1090551617,
            ["AlwaysVisible"] = false,
            
            ["Effects"] = {
            },
            ["Highlight"] = false,
            ["HealthThreshold"] = {}, 
            ["Conjuction"] = true,
            ["X"] = 0,
            ["Y"] = 0,
        }
    elseif type == "TimerIcon" then
        return {
            ["Order"] = id,
            ["Type"] = "TimerIcon",
            ["Height"] = 32,
            ["Width"] = 32,
            ["Scale"] = 1,
            ["OffsetAbove"] = 0,
            
            ["OffsetBelow"] = 0,
            ["BorderSize"] = 0,
            ["GrayOut"] = false,
            ["HighlightWhileOff"] = false,
            ["Alignment"] = "Middle",
            ["TextAlignment"] = "MiddleCenter",
            ["ShowText"] = true,
            ["Font"] = "TrajanProBold16",
            ["Font_Colour"] = {[1] = 1, [2] = 1, [3] = 1, [4] = 1},
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},
            ["Icon"] = 1090551617,
            ["AlwaysVisible"] = false,
            ["Clockwise"] = true,
            ["Visual_Timer"] = true,
            ["EnemyHits"] = {},
            ["PlayerHits"] = {},
            ["SayChat"] = {},
            ["PartyChat"] = {},
            ["StandardChat"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
            ["Skills"] = {},
            ["EffectAdded"] = {},
            ["EffectAdded_Group"] = {},
            ["EffectRemoved"] = {},
            ["EffectAdded_Target"] = {},
            ["Highlight"] = false,
            ["Hide_While_Not_Active"] = false,
            ["Visibility_Threshold"] = 9999,        
            ["X"] = 0,
            ["Y"] = 0,
        }
    elseif type == "MoraleBar" then
        return {
            ["Order"] = id,
            ["Type"] = "MoraleBar",
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            
            ["Height"] = 20,
            ["Text"] = "<current>/<total> (<percentage>%)",
            ["Disable_Player_Vitals"] = false,
            ["Smooth"] = false,
            ["Colours"] = { [1] = {[1] = 0.6, [2] = 0, [3] = 0.5, [4] = 0}, 
                            [2] = {[1] = 0.6, [2] = 0, [3] = 1, [4] = 0}, 
                            [3] = {[1] = 0.6, [2] = 0.7, [3] = 0, [4] = 1}},
            ["Alignment"] = "Middle",
            ["Intervals"] = 0,
            ["Interval_Colour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0}, 
            ["Width"] = 500,
            ["Font"] = "BookAntiquaBold19",
            ["TextAlignment"] = "MiddleRight",
            ["Highlight_On_Effect"] = {},
            ["Highlight_Colour"] = {[1] = 1, [2] = 1, [3] = 1, [4] = 1},
            ["BorderSize"] = 0,
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},        
            ["X"] = 0,
            ["Y"] = 0,
        }
    elseif type == "PetMoraleBar" then
        return {
            ["Order"] = id,
            ["Type"] = "PetMoraleBar",
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["Height"] = 20,
            ["Text"] = "<current>/<total> (<percentage>%)",
            ["Smooth"] = false,
            ["Colours"] = { [1] = {[1] = 0.6, [2] = 0, [3] = 0.5, [4] = 0}, 
                            [2] = {[1] = 0.6, [2] = 0, [3] = 1, [4] = 0}, 
                            [3] = {[1] = 0.6, [2] = 0.7, [3] = 0, [4] = 1}},
            ["Alignment"] = "Middle",
            ["Intervals"] = 0,
            ["Interval_Colour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0}, 
            ["Width"] = 500,
            ["Font"] = "BookAntiquaBold19",
            ["TextAlignment"] = "MiddleRight",
            ["Highlight_Colour"] = {[1] = 1, [2] = 1, [3] = 1, [4] = 1},
            ["BorderSize"] = 0,
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},        
            ["X"] = 0,
            ["Y"] = 0,
        }
    elseif type == "MoraleBar_Target" then
        return {
            ["Order"] = id,
            ["Type"] = "MoraleBar_Target",
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            
            ["Height"] = 20,
            ["Text"] = "<current>/<total> (<percentage>%)",
            ["TextAlignment"] = "MiddleRight",
            ["Smooth"] = false,
            ["Colours"] = { [1] = {[1] = 0.6, [2] = 0, [3] = 0.5, [4] = 0}, 
                            [2] = {[1] = 0.6, [2] = 0, [3] = 1, [4] = 0}, 
                            [3] = {[1] = 0.6, [2] = 0.7, [3] = 0, [4] = 1}},
            ["Alignment"] = "Middle",
            ["Intervals"] = 0,
            ["Interval_Colour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0}, 
            ["Width"] = 500,
            ["Font"] = "BookAntiquaBold19",
            ["BorderSize"] = 0,
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},        
            ["X"] = 0,
            ["Y"] = 0,
        }
    elseif type == "PowerBar" then
        return {
            ["Order"] = id,
            ["Type"] = "PowerBar",
            ["OffsetAbove"] = 0,
            
            ["OffsetBelow"] = 0,
            ["Height"] = 20,
            ["Text"] = "<current>/<total> (<percentage>%)",
            ["TextAlignment"] = "MiddleRight",
            ["Smooth"] = true,
            ["Alignment"] = "Middle",
            ["Colours"] = { [1] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0}, 
                            [2] = {[1] = 0.6, [2] = 0, [3] = 0, [4] = 1}},
            ["Intervals"] = 0,
            ["Interval_Colour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0}, 
            ["Width"] = 500,
            ["Font"] = "BookAntiquaBold19",
            ["BorderSize"] = 0,
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},      
            ["X"] = 0,
            ["Y"] = 0,
        }
    elseif type == "PowerBar_Target" then
        return {
            ["Order"] = id,
            ["Type"] = "PowerBar_Target",
            ["OffsetAbove"] = 0,
            
            ["OffsetBelow"] = 0,
            ["Height"] = 20,
            ["Text"] = "<current>/<total> (<percentage>%)",
            ["TextAlignment"] = "MiddleRight",
            ["Smooth"] = false,
            ["Alignment"] = "Middle",
            ["Colours"] = { [1] = {[1] = 1, [2] = 0, [3] = 0, [4] = 1}, 
                            [2] = {[1] = 0.6, [2] = 0, [3] = 0, [4] = 1}},
            ["Intervals"] = 0,
            ["Interval_Colour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0}, 
            ["Width"] = 500,
            ["Font"] = "BookAntiquaBold19",
            ["BorderSize"] = 0,
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},      
            ["X"] = 0,
            ["Y"] = 0,
        }
    elseif type == "WrathBar" then
        return {
            ["Order"] = id,
            ["Type"] = "WrathBar",
            
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["Height"] = 20,
            ["Smooth"] = true,
            ["Text"] = "<current>/<total> (<percentage>%)",
            ["Alignment"] = "Middle",
            ["Colours"] = { [1] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0}, 
                            [2] = {[1] = 0.6, [2] = 1, [3] = 0, [4] = 0}},
            ["Intervals"] = 0,
            ["Interval_Colour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0}, 
            ["Width"] = 500,
            ["Font"] = "BookAntiquaBold19",
            ["BorderSize"] = 0,
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},        
            ["X"] = 0,
            ["Y"] = 0,
        }
    elseif type == "ResourceBar" then
        return {
            ["Order"] = id,
            ["Type"] = "ResourceBar",
            
            ["Height"] = 10,
            ["Width"] = 320,
            ["Scale"] = 1,
            ["Animate"] = true,
            ["Full_Border"] = true,
            ["ShowText"] = true,
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["ForegroundColour"] = {
                [1] = {[1] = 0.8, [2] = 0, [3] = 0.4,  [4] = 0},
                [2] = {[1] = 0.8, [2] = 0, [3] = 0.4,  [4] = 0},
                [3] = {[1] = 0.8, [2] = 0, [3] = 0.4,  [4] = 0},
                [4] = {[1] = 0.8, [2] = 0.4, [3] = 0.4,  [4] = 0},
                [5] = {[1] = 0.8, [2] = 0.4, [3] = 0.4,  [4] = 0},
                [6] = {[1] = 0.8, [2] = 0.4, [3] = 0.4,  [4] = 0},
                [7] = {[1] = 0.8, [2] = 0.4, [3] = 0,  [4] = 0},
                [8] = {[1] = 0.8, [2] = 0.4, [3] = 0,  [4] = 0},
                [9] = {[1] = 0.8, [2] = 0.4, [3] = 0,  [4] = 0},
            },
            ["BackgroundColour"] = {
                [1] = {[1] = 0.8, [2] = 0, [3] =0.8,  [4] = 0},
                [2] = {[1] = 0.8, [2] = 0, [3] =0.8,  [4] = 0},
                [3] = {[1] = 0.8, [2] = 0, [3] =0.8,  [4] = 0},
                [4] = {[1] = 0.8, [2] =0.8, [3] =0.8,  [4] = 0},
                [5] = {[1] = 0.8, [2] =0.8, [3] =0.8,  [4] = 0},
                [6] = {[1] = 0.8, [2] =0.8, [3] =0.8,  [4] = 0},
                [7] = {[1] = 0.8, [2] =0.8, [3] = 0,  [4] = 0},
                [8] = {[1] = 0.8, [2] =0.8, [3] = 0,  [4] = 0},
                [9] = {[1] = 0.8, [2] =0.8, [3] = 0,  [4] = 0},
            },
            ["BoxOffset"] = 3,
            ["BorderSize"] = 0,
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
            ["Alignment"] = "Middle",
            ["RKLayout"] = false,
            ["RK_ForegroundColour_Heal"] = {[1] = 0.8, [2] = 0, [3] = 0.4,  [4] = 0},
            ["RK_ForegroundColour_DPS"] = {[1] = 0.8, [2] = 0.4, [3] = 0,  [4] = 0},
            ["RK_BackgroundColour_Heal"] = {[1] = 0.8, [2] = 0, [3] = 0.8,  [4] = 0},
            ["RK_BackgroundColour_DPS"] = {[1] = 0.8, [2] = 0.8, [3] = 0,  [4] = 0},
            ["BoxBackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},        
            ["X"] = 0,
            ["Y"] = 0,
            ["Font_Colour"] = {[1] = 1, [2] = 1, [3] = 1,  [4] = 1},
            ["Font"] = "TrajanProBold24"
        }
    elseif type == "ValueBar" then
        return {
            ["Order"] = id,
            ["Type"] = "ValueBar",
            ["EventTrigger"] = {},
            ["Height"] = 20,
            ["Width"] = 320,
            ["Visibility_Threshold"] = 9999,
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
            ["BorderSize"] = 0,
            ["Vertical"] = false,
            ["Alignment"] = "Middle",
            ["BarAlignment"] = "Middle",
            ["BorderColour"] = {[1] = 0, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
            ["ForegroundColour"] = {[1] = 1, [2] = 152/288, [3] = 0,  [4] = 0},
            ["EffectAdded"] = {},
            ["EffectRemoved"] = {},
            ["EffectAdded_Group"] = {},
            ["EffectAdded_Target"] = {},    
            ["SayChat"] = {},
            ["PartyChat"] = {},
            ["StandardChat"] = {},
            ["EnemyHits"] = {},
            ["PlayerHits"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
            ["Skills"] = {

            },     
            ["X"] = 0,
            ["Y"] = 0,
        }
    elseif type == "BuffBar" then
        return {
            ["Order"] = id,
            ["Type"] = "BuffBar",
            
            ["Height"] = 20,
            ["Width"] = 100,
            ["Scale"] = 1,
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["Alignment"] = "Middle",
            ["TextAlignment"] = "BottomCenter",
            ["StackTextAlignment"] = "TopCenter",
            ["Font_Timer"] = "FixedSys15",
            ["Font_Stack"] = "FixedSys15",
            ["Font_Stack_Colour"] = {[1] = 1, [2] = 1, [3] = 1,  [4] = 1},
            ["Font_Timer_Colour"] = {[1] = 1, [2] = 1, [3] = 1,  [4] = 1},
            ["HighlightColour"] = {[1] = 1, [2] = 1, [3] = 1,  [4] = 1},
            ["HighlightSize"] = 2,
            ["Effects"] = {
            },
            ["Skills"] = {
            },
            ["EnemyHits"] = {},
            ["PlayerHits"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
            ["AllEffects"] = false,
            ["OnlyDebuffs"] = false,
            ["OnlyBuffs"] = false,
            ["AllHighlight"] = false,      
            ["X"] = 0,
            ["Y"] = 0,
            ["Offset"] = 0,
            ["BorderColour"] = {[1] = 1, [2] = 0, [3] = 0,  [4] = 0},
            ["BorderSize"] = 1,
        }
    elseif type == "BuffBar_Target" then
        return {
            ["Order"] = id,
            ["Type"] = "BuffBar_Target",
            ["Height"] = 20,
            ["Width"] = 100,
            
            ["Scale"] = 1,
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["Alignment"] = "Middle",
            ["TextAlignment"] = "BottomCenter",
            ["StackTextAlignment"] = "TopCenter",
            ["Font_Timer"] = "FixedSys15",
            ["Font_Stack"] = "FixedSys15",
            ["Font_Stack_Colour"] = {[1] = 1, [2] = 1, [3] = 1,  [4] = 1},
            ["Font_Timer_Colour"] = {[1] = 1, [2] = 1, [3] = 1,  [4] = 1},
            ["AllEffects"] = false,
            ["OnlyDebuffs"] = false,
            ["OnlyBuffs"] = false,
            ["AllHighlight"] = false,
            ["Reset_On_Retarget"] = true,
            ["EffectAdded_Target"] = {},
            ["X"] = 0,
            ["Y"] = 0,
            ["Offset"] = 0,
        }
    elseif type == "Timer" then
        return {
            ["Order"] = id,
            ["Type"] = "Timer",
            ["Height"] = 40,
            ["EventTrigger"] = {},
            ["Width"] = 300,
            ["Scale"] = 1,
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["BorderSize"] = 0,
            ["Alignment"] = "Left",
            ["Font"] = "TrajanProBold16",
            ["Duration_Font"] = "FixedSys15",
            ["Icon"] = 1090551617,
            ["Text"] = "",
            ["BorderColour"] = {[1] = 0, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
            ["BackgroundColour"] = {[1] = 0.9, [2] = 0, [3] = 0,  [4] = 0},
            ["ForegroundColour"] = {[1] = 1, [2] = 0.5, [3] = 0.5,  [4] = 0.5},
            ["AlwaysVisible"] = true,
            ["AllHighlight"] = false,
            ["Spark"] = true,
            ["EffectAdded"] = {},
            ["EffectAdded_Group"] = {},
            ["EffectAdded_Target"] = {},    
            ["EffectRemoved"] = {},
            ["EnemyHits"] = {},
            ["PlayerHits"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
            ["Skills"] = {},
            ["Effects"] = {},
            ["SayChat"] = {},
            ["DefeatEvent"] = {},
            ["PartyChat"] = {},
            ["StandardChat"] = {},      
            ["X"] = 0,
            ["Y"] = 0,
            ["Unique"] = false,
        }
    elseif type == "TimerGroup" then
        return {
            ["Order"] = id,
            ["Type"] = "TimerGroup",
            ["Height"] = 40,
            ["Width"] = 300,
            ["EventTrigger"] = {},
            ["Scale"] = 1,
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
            ["BorderSize"] = 0,
            ["Alignment"] = "Left",
            ["Icon"] = 1090551617,
            ["BorderColour"] = {[1] = 0, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
            ["Timer_BackgroundColour"] = {[1] = 0.6, [2] = 0, [3] = 0,  [4] = 0},
            ["Timer_ForegroundColour"] = {[1] = 1, [2] = 0.5, [3] = 0.5,  [4] = 0.5},
            ["AlwaysVisible"] = true,
            ["AllHighlight"] = false,
            ["Spark"] = false,
            ["EffectAdded"] = {},
            ["EffectAdded_Group"] = {},
            ["EffectRemoved"] = {},
            ["EnemyHits"] = {},
            ["Effects"] = {},
            ["PlayerHits"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
            ["Skills"] = {},
            ["SayChat"] = {},
            ["PartyChat"] = {},
            ["StandardChat"] = {},        
            ["EffectAdded_Target"] = {},
            ["FightStart"] = {},
            ["FightEnd"] = {},
            ["FightPhase"] = {},
            ["DefeatEvent"] = {},
            ["DNFApplied"] = {},
            ["DNFRemoved"] = {},
            ["Reset_On_Fight_End"] = false,
            ["X"] = 0,
            ["Y"] = 0,
            ["Timer_Height"] = 20,
            ["Timer_Font"] = "TrajanProBold16",
            ["Duration_Font"] = "FixedSys15",
            ["Static_Timers"] = false,
            ["Timer_Offset"] = 3,
            ["Timer_Sorting"] = "High to Low (Remaining duration)",
            ["Timer_Stack_Direction"] = "Down",
            ["Target_HealthThreshold"] = {},
            ["Reset_On_Retarget"] = false,
        }
    elseif type == "Circle Timer" then
        return {
            ["Order"] = id,
            ["Type"] = "Circle Timer",
            ["OffsetAbove"] = 0,
            ["EventTrigger"] = {},
            ["OffsetBelow"] = 0,
            ["BackgroundRingColour"] = {[1] = 1, [2] = 1, [3] = 1,  [4] = 1},
            ["TimerRingColour"] = {[1] = 1, [2] = 0, [3] = 0.3,  [4] = 0},
            ["Alignment"] = "Middle",
            ["EffectAdded"] = {},
            ["EffectAdded_Group"] = {},
            ["EffectRemoved"] = {},
            ["EnemyHits"] = {},
            ["PlayerHits"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
            ["Skills"] = {},
            ["SayChat"] = {},
            ["PartyChat"] = {},
            ["StandardChat"] = {},        
            ["EffectAdded_Target"] = {},            
            ["X"] = 0,
            ["Y"] = 0,
            ["Text_Font"] = "TrajanProBold16",
            ["Timer_Font"] = "FixedSys15",
            ["Static_Timers"] = false,
            ["Target_HealthThreshold"] = {},
            ["Reset_On_Retarget"] = false,
            ["Clockwise"] = false,
            ["Show_Timer"] = true,
        }
    elseif type == "Text" then
        return {
            ["Order"] = id,
            ["Type"] = "Text",
            ["Height"] = 32,
            ["Width"] = 300,
            ["Scale"] = 1,
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            
            ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
            ["BorderSize"] = 0,
            ["Alignment"] = "Middle",
            ["Font"] = "TrajanProBold16",
            ["TextAlignment"] = "MiddleLeft",
            ["Font_Colour"] = {[1] = 1, [2] = 1, [3] = 1,  [4] = 1},
            ["Text"] = "Text",
            ["BorderColour"] = {[1] = 0, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
            ["AlwaysVisible"] = false,
            ["Effects"] = {
            },
            ["Conjuction"] = true,
            ["HealthThreshold"] = {},
            ["Instance_Only"] = false,            
            ["X"] = 0,
            ["Y"] = 0,
        }
    elseif type == "Alert" then
        return {
            ["Order"] = id,
            ["Type"] = "Alert",
            ["EventTrigger"] = {},
            ["Height"] = 32,
            ["Width"] = 300,
            ["Scale"] = 1,
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
            ["BorderSize"] = 0,
            ["Alignment"] = "Middle",
            ["TextAlignment"] = "MiddleCenter",
            ["Font"] = "TrajanProBold24",
            ["Font_Colour"] = {[1] = 1, [2] = 1, [3] = 1,  [4] = 1},
            ["Outline_Colour"] = {[1] = 1, [2] = 0, [3] = 0,  [4] = 0},
            ["Text"] = "Text",
            ["BorderColour"] = {[1] = 0, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
            ["Duration_Font"] = "FixedSys15",
            ["Show_Duration"] = true,
            ["Decimal_Threshold"] = 2,
            ["DurationTextAlignment"] = "MiddleCenter",
            ["EnemyHits"] = {},
            ["PlayerHits"] = {},
            ["SayChat"] = {},
            ["PartyChat"] = {},
            ["StandardChat"] = {},
            ["CCBreak"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
            ["Skills"] = {},
            ["EffectAdded"] = {},
            ["EffectRemoved"] = {},
            ["HealthThreshold"] = {},
            ["EffectAdded_Group"] = {},
            ["EffectAdded_Target"] = {}, 
            ["Target_HealthThreshold"] = {},     
            ["DNFApplied"] = {},
            ["DNFRemoved"] = {}, 
            ["X"] = 0,
            ["Y"] = 0,
        }
    elseif type == "AlertGroup" then
        return {
            ["Order"] = id,
            ["Type"] = "AlertGroup",
            ["Height"] = 100,
            ["Width"] = 400,
            ["AlertHeight"] = 32,
            ["EventTrigger"] = {},
            ["Scale"] = 1,
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["AlertBorderSize"] = 0,
            ["ReverseFill"] = false,
            ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0,  [4] = 0},
            ["BorderSize"] = 0,
            ["Alignment"] = "Middle",
            ["TextAlignment"] = "MiddleLeft",
            ["Font"] = "TrajanProBold16",
            ["Font_Colour"] = {[1] = 1, [2] = 1, [3] = 1,  [4] = 1},
            ["Outline_Colour"] = {[1] = 1, [2] = 0, [3] = 0,  [4] = 0},
            ["BorderColour"] = {[1] = 0, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
            ["AlertBackgroundColour"] = {[1] = 0, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
            ["AlertBorderColour"] = {[1] = 0, [2] = 0.08, [3] = 0.08,  [4] = 0.08},
            ["Duration_Font"] = "FixedSys15",
            ["Show_Duration"] = true,
            ["Decimal_Threshold"] = 2,
            ["DurationTextAlignment"] = "MiddleCenter",
            ["EnemyHits"] = {},
            ["PlayerHits"] = {},
            ["SayChat"] = {},
            ["PartyChat"] = {},
            ["StandardChat"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
            ["CCBreak"] = {},
            ["Skills"] = {},
            ["EffectAdded"] = {},
            ["EffectRemoved"] = {},
            ["HealthThreshold"] = {},
            ["EffectAdded_Group"] = {},
            ["EffectAdded_Target"] = {}, 
            ["Target_HealthThreshold"] = {},    
            ["DNFApplied"] = {},
            ["DNFRemoved"] = {},
            ["X"] = 0,
            ["Y"] = 0,
        }
    elseif type == "Countdown" then
        return {
            ["Order"] = id,
            ["Type"] = "Countdown",
            ["Visibility_Threshold"] = 9999,
            ["EventTrigger"] = {},
            ["EffectAdded"] = {},
            ["EffectRemoved"] = {},
            ["EnemyHits"] = {},
            ["PlayerHits"] = {},
            ["Skills"] = {},
            ["SayChat"] = {},
            ["PartyChat"] = {},
            ["StandardChat"] = {},
            ["EffectAdded_Group"] = {},
            ["EffectAdded_Target"] = {}, 
            ["Target_HealthThreshold"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
            ["Width"] = 250,
            ["Height"] = 125,
            ["X"] = 0,
            ["Y"] = 0,
            ["Scale"] = 1,
            ["Font"] = "TrajanProBold36",
            ["FontColour"] = {[1] = 1, [2] = 0.95, [3] = 0.67, [4] = 0.04},
            ["ThresholdColour"] = {[1] = 1, [2] = 0.40, [3] = 0, [4] = 0},
            ["Threshold"] = 5,
        }
    elseif type == "Sound" then
        return {
            ["Order"] = id,
            ["Type"] = "Sound",
            ["EventTrigger"] = {},
            ["EnemyHits"] = {},
            ["PlayerHits"] = {},
            ["SayChat"] = {},
            ["PartyChat"] = {},
            ["StandardChat"] = {},
            ["Skills"] = {},
            ["EffectAdded"] = {},
            ["EffectRemoved"] = {},
            ["HealthThreshold"] = {},
            ["EffectAdded_Group"] = {},
            ["EffectAdded_Target"] = {}, 
            ["Target_HealthThreshold"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
        }
    elseif type == "Note Event" then
        return {
            ["Order"] = id,
            ["Type"] = "Note Event",
            ["EnemyHits"] = {},
            ["PlayerHits"] = {},
            ["SayChat"] = {},
            ["PartyChat"] = {},
            ["StandardChat"] = {},
            ["Skills"] = {},
            ["EffectAdded"] = {},
            ["EffectRemoved"] = {},
            ["HealthThreshold"] = {},
            ["EffectAdded_Group"] = {},
            ["EffectAdded_Target"] = {}, 
            ["Target_HealthThreshold"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
            ["FightStart"] = {},
            ["FightEnd"] = {},
            ["FightPhase"] = {},
            
        }
    elseif type == "Note Activation" then
        return {
            ["Order"] = id,
            ["Type"] = "Note Activation",
            ["EnemyHits"] = {},
            ["PlayerHits"] = {},
            ["SayChat"] = {},
            ["PartyChat"] = {},
            ["StandardChat"] = {},
            ["Skills"] = {},
            ["EffectAdded"] = {},
            ["EffectRemoved"] = {},
            ["HealthThreshold"] = {},
            ["EffectAdded_Group"] = {},
            ["EffectAdded_Target"] = {}, 
            ["Target_HealthThreshold"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
            ["FightStart"] = {},
            ["FightEnd"] = {},
            ["FightPhase"] = {},
            
        }
    elseif type == "SkillLabel" then
        return {
            ["Order"] = id,
            ["Type"] = "SkillLabel",
            ["EnemyHits"] = {},
            ["PlayerHits"] = {},
            ["SayChat"] = {},
            ["PartyChat"] = {},
            ["StandardChat"] = {},
            ["PlayerHeal"] = {},
            ["PlayerBenefit"] = {},
            ["Highlight_On_Effect"] = {},
            ["Skills"] = {},
            ["EffectAdded"] = {},
            ["EffectRemoved"] = {},
            ["EffectAdded_Group"] = {},
            ["EffectAdded_Target"] = {}, 
            ["Height"] = 32,
            ["Width"] = 32,
            ["Scale"] = 1,
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["BorderSize"] = 0,
            ["Alignment"] = "Middle",
            ["TextAlignment"] = "MiddleCenter",
            ["Font"] = "TrajanProBold16",
            ["Font_Colour"] = {[1] = 1, [2] = 1, [3] = 1, [4] = 1},
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},
            ["Highlight_Colour"] = {[1] = 1, [2] = 1, [3] = 1, [4] = 1},
            ["Highlight_Size"] = 3,
            ["Icon"] = 1090551617,
            ["Visibility_Threshold"] = 9999,     
            ["Opacity_While_Active"] = 1,
            ["Opacity_While_Not_Active"] = 1,
            ["AlwaysVisible"] = false,
            ["Clockwise"] = true,
            ["Visual_Timer"] = true,
            ["Highlight"] = false,
            ["Hide_While_Not_Active"] = false,
            ["Hide_While_Active"] = false,
            ["HighlightWhileOff"] = false,
            ["X"] = 0,
            ["Y"] = 0,
            
        }
    elseif type == "Skills" then
        return {
            ["Order"] = id,
            ["Type"] = "Skills",
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["Scale"] = 1,
            ["Highlight_On_Effect"] = {},
            ["Skills"] = {},
            ["Quickslots"] = {},
            ["X"] = 0,
            ["Y"] = 0,
            ["Height"] = 32,
            ["Width"] = 32,
            ["Font_Colour"] = {[1] = 1, [2] = 1, [3] = 1, [4] = 1},
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},
            ["BorderSize"] = 0,
            ["Offset"] = 1,
            ["Font"] = "FixedSys15",
            ["HighlightColour"] = {[1] = 1, [2] = 1, [3] = 1,  [4] = 1},
            ["HighlightSize"] = 2,
            
        }
    elseif type == "Ballad Bar" then
        return {
            ["Order"] = id,
            ["Type"] = "Ballad Bar",
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["Scale"] = 1,
            ["X"] = 0,
            ["Y"] = 0,
            ["Height"] = 20,
            ["Width"] = 300,
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},
            ["BackgroundColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},
            ["BoxBackgroundColour"] = {[1] = 1, [2] = 0.125, [3] = 0.125, [4] = 0.125},
            ["DamageColour"] = {[1] = 1, [2] = 0.3, [3] = 0, [4] = 0},
            ["PowerColour"] = {[1] = 1, [2] = 0, [3] = 0, [4] = 0.3},
            ["HealColour"] = {[1] = 1, [2] = 0, [3] = 0.3, [4] = 0},
            ["BorderSize"] = 0,
            ["Offset"] = 1,
            ["Box Offset"] = 10,
            ["Alignment"] = "Middle",
            
        }
    elseif type == "Effect Listbox" then
        return {
            ["Order"] = id,
            ["Type"] = "Effect Listbox",
            ["OffsetAbove"] = 0,
            ["OffsetBelow"] = 0,
            ["Scale"] = 1,
            ["X"] = 0,
            ["Y"] = 0,
            ["Height"] = 100,
            ["Width"] = 300,
            ["BorderSize"] = 0,
            ["BorderColour"] = {[1] = 0, [2] = 0, [3] = 0, [4] = 0},
            ["Spacing"] = 1,
            ["Listbox_Alignment"] = "Left",
            ["Effect_Duration_TextAlignment"] = "MiddleCenter",
            ["Effect_Duration_Font"] = "Verdana10",
            ["Effect_Stack_TextAlignment"] = "BottomCenter",
            ["Effect_Stack_Font"] = "Verdana10",
            ["All_Buffs"] = true,
            ["All_Debuffs"] = false,
            ["Orientation"] = "Horizontal",
            ["Flipped_Layout"] = false,
            ["Reverse_Fill"] = false,
            ["Effect_Size"] = 24,
            ["Show_Duration"] = false,
            ["Visibility_Threshold"] = 99999,
            ["Show_Stack"] = false,
        }
    end
end

function PrimeUIOptions:UITreeView(data1, width, valuebarNodes, name)

    for index, data in spairs(data1, function(t,a,b) return t[a]["Order"] < t[b]["Order"] end) do

        local removalFunction = function()
            self.currentUI["PrimeUI"][index] = nil

            local index = 1
            for key, value in spairs(self.currentUI["PrimeUI"], function(t,a,b) return t[a]["Order"] < t[b]["Order"] end) do
                self.currentUI["PrimeUI"][key]["Order"] = index
                index = index + 1
            end

            self.boxes[self.currentUI["Name"]]:SetParent(nil)
            self.boxes[self.currentUI["Name"]] = nil
            local count = tablelength(self.currentUI["PrimeUI"]) + 1
            local newTable = self:GetUIElementData(name, count)
            table.insert(self.currentUI["PrimeUI"], newTable)
            PrimeUIHandlerObject:Refresh(self.currentUI["Name"], self.currentUI["PrimeUI"])
            self.data = PrimeUIHandlerObject:GetData()
            self.treeviewBoxes[self.currentUI["Name"]].SourceLabel:MouseClick()
            --self.boxes[self.currentUI["Name"]]:SetVisible(true)
        end

        local movefunction = function(up)
            local newOrder = data["Order"]
            local oldOrder = data["Order"]

            if up then
                if newOrder == 1 then return end
                newOrder = newOrder - 1
            else
                if newOrder + 1 > tablelength(self.currentUI["PrimeUI"]) then
                    return 
                end
                newOrder = newOrder + 1
            end

            data["Order"] = -1

            for key, value in spairs(self.currentUI["PrimeUI"], function(t,a,b) return t[a]["Order"] < t[b]["Order"] end) do
                if self.currentUI["PrimeUI"][key]["Order"] == newOrder then
                    self.currentUI["PrimeUI"][key]["Order"] = oldOrder
                end
            end

            for key, value in spairs(self.currentUI["PrimeUI"], function(t,a,b) return t[a]["Order"] < t[b]["Order"] end) do
                if self.currentUI["PrimeUI"][key]["Order"] == -1 then
                    self.currentUI["PrimeUI"][key]["Order"] = newOrder
                end
            end

            self.boxes[self.currentUI["Name"]]:SetParent(nil)
            self.boxes[self.currentUI["Name"]] = nil
            local count = tablelength(self.currentUI["PrimeUI"]) + 1
            local newTable = self:GetUIElementData(name, count)
            table.insert(self.currentUI["PrimeUI"], newTable)
            PrimeUIHandlerObject:Refresh(self.currentUI["Name"], self.currentUI["PrimeUI"])
            self.data = PrimeUIHandlerObject:GetData()
            self.treeviewBoxes[self.currentUI["Name"]].SourceLabel:MouseClick()
            --self.boxes[self.currentUI["Name"]]:SetVisible(true)
        end

        --valuebar:AddItem(self:Border(width))
        --local typeHeader = self:Label(width, data["Type"], removalFunction, movefunction) 
        local typeHeader = PrimeUITools.UIElementHeader(width, data["Type"], data["NickName"], removalFunction, movefunction, function(newName)
            data["NickName"] = newName
            PrimeUIHandlerObject:Refresh(name, data1)
        end, function()
            for key, value in pairs(self:GetUIElementData(data["Type"], 0)) do
                if data[key] == nil then
                    data[key] = value
                    ChatOutput("Added: " .. tostring(key))
                end
            end

            if self.currentUI then
                self.boxes[self.currentUI["Name"]]:SetParent(nil)
                self.boxes[self.currentUI["Name"]] = nil
                PrimeUIHandlerObject:Refresh(self.currentUI["Name"], self.currentUI["PrimeUI"])
                self.data = PrimeUIHandlerObject:GetData()
                self.treeviewBoxes[self.currentUI["Name"]].SourceLabel:MouseClick()
                ChatOutput("Added all missing default values to this UI Element")
            end
        end)

        valuebarNodes:Add(typeHeader)
        local UINodes = typeHeader:GetChildNodes()
        local buttonListboxNode = PrimeUITools.OptionsHeader(width, 5)
        --UINodes:Add(self:Border(width))
        UINodes:Add(buttonListboxNode)

        local optionHeader = ""
        local subUINodes = nil
        
        for key, value in spairs(data, function(t,a,b) 
            if self:SortOrder(a, t[a]) == self:SortOrder(b, t[b]) then
                return a < b
            else
                return self:SortOrder(a, t[a]) < self:SortOrder(b, t[b])
            end
        end) do
            local newOptionHeader = self.SortOrderTable[self:SortOrder(key, value)]
            if newOptionHeader and newOptionHeader ~= optionHeader then
                optionHeader = newOptionHeader
                local subLabel = self:OptionLabel(width, tostring(optionHeader))
                buttonListboxNode:AddItem(PrimeUITools.OptionsListBoxButton(width / 5, 30, tostring(optionHeader), function() 
                    typeHeader:CollapseAll()
                    subLabel:Expand() 
                end))
                subUINodes = subLabel:GetChildNodes()
                UINodes:Add(subLabel)
                --UINodes:Add(self:Border(width))
            end    
            local skip = false
            if key == "Order" or key == "Type" then
                skip = true
            elseif key == "Icon" then
                local element = PrimeUITools.IconInput(width, key, value, self, (function(newIcon)
                    data[key] = newIcon
                    
                    PrimeUIHandlerObject:Refresh(name, data1)
                end))
                subUINodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                subUINodes:Add(element)
                skip = true
            elseif self.listBoxCategories[key] then
                local element = self:ListBoxInput(width, key, value, data["Type"], (function(effectName, newState)
                    if newState and data[key][effectName] then
                        ChatOutput("Failed to add item: Item already exists")
                        return true
                    end
                    data[key][effectName] = newState
                    
                    PrimeUIHandlerObject:Refresh(name, data1)
                end))
                --subUINodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                subUINodes:Add(element)
            elseif string.find(key, "Colour") then
                local element = self:ColourInput(width, key, value, (function(newColour, index)
                    if index then
                        data[key][index] = newColour
                    else
                        data[key] = newColour
                    end
                    
                    PrimeUIHandlerObject:Refresh(name, data1)
                end))
                self:InfoButton(element, width, self.optionInfoText["Colour"])
                subUINodes:Add(element)
            elseif string.find(key, "Font") then
                local element = PrimeUITools.FontInput(width, key, value, (function(newFont)
                    data[key] = newFont
                    
                    PrimeUIHandlerObject:Refresh(name, data1)
                end))
                --subUINodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText["Font"])
                subUINodes:Add(element)
                skip = true
            elseif string.find(key, "Timer_Stack_Direction") then
                local element = PrimeUITools.AlignmentInput(width, key, value, self.timeStackAlignments, (function(alignment)
                    data[key] = alignment
                    
                    PrimeUIHandlerObject:Refresh(name, data1)
                end))
                --subUINodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                subUINodes:Add(element)
                skip = true
            elseif string.find(key, "Timer_Sorting") then
                local element = PrimeUITools.AlignmentInput(width, key, value, self.timerGroupAlignments, (function(alignment)
                    data[key] = alignment
                    
                    PrimeUIHandlerObject:Refresh(name, data1)
                end))
                --subUINodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                subUINodes:Add(element)
                skip = true
            elseif string.find(key, "Orientation") then
                local element = PrimeUITools.AlignmentInput(width, key, value, self.listboxOrientations, (function(alignment)
                    data[key] = alignment
                    
                    PrimeUIHandlerObject:Refresh(name, data1)
                end))
                --subUINodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                subUINodes:Add(element)
                skip = true
            elseif string.find(key, "TextAlignment") then
                local element = PrimeUITools.AlignmentInput(width, key, value, self.textAlignments, (function(alignment)
                    data[key] = alignment
                    
                    PrimeUIHandlerObject:Refresh(name, data1)
                end))
                --subUINodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText["TextAlignment"])
                subUINodes:Add(element)
                skip = true
            elseif string.find(key, "Alignment") then
                local element = PrimeUITools.AlignmentInput(width, key, value, self.contentAlignment, (function(alignment)
                    data[key] = alignment
                    
                    PrimeUIHandlerObject:Refresh(name, data1)
                end))
                --subUINodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText["Alignment"])
                subUINodes:Add(element)
                skip = true
            elseif isnumber(value) then
                local element = PrimeUITools.NumericalInput(width, key, value, (function(text) 
                    local number = tonumber(text)
                    if number then
                        data[key] = number
                        
                        PrimeUIHandlerObject:Refresh(name, data1)
                    end
                end))
                --subUINodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                subUINodes:Add(element)
                skip = true
            elseif value == true or value == false then
                local element = PrimeUITools.BoolInput(width, key, value, (function(bool) 
                    data[key] = bool
                    
                    PrimeUIHandlerObject:Refresh(name, data1)
                end))
                --subUINodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                subUINodes:Add(element)
                skip = true
            elseif type(value) == "string" then
                local element = PrimeUITools.StringInput(width, key, value, key == "Text", (function(text) 
                    if text then
                        data[key] = text
                        
                        PrimeUIHandlerObject:Refresh(name, data1)
                    end
                end))
                --subUINodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                subUINodes:Add(element)
                skip = true
            else
                ChatOutput("Skipped")
                ChatOutput(key)
            end

            if not(skip) then subUINodes:Add(self:Border(width)) end
        end
    end
end

function PrimeUIOptions:SortOrder(key, value)
    if key == "Order" or key == "Type" then
        return 9999
    elseif key == "Icon" then
        return 35
    elseif string.find(key, "Orientation") then
        return 60
    elseif self.listBoxCategories[key] then
        return 50
    elseif string.find(key, "Colour") then
        return 40
    elseif string.find(key, "Timer_Sorting") then
        return 22 
    elseif string.find(key, "Font") then
        return 24
    elseif string.find(key, "Timer_Stack_Direction") then
        return 23
    elseif string.find(key, "TextAlignment") then
        return 21
    elseif string.find(key, "Alignment") then
        return 20
    elseif isnumber(value) then
        return 10
    elseif value == true or value == false then
        return 30
    elseif key == "Text" then
        return 1
    elseif type(value) == "string" then
        return 2
    else
        return 9999
    end
end

function PrimeUIOptions:Border(width)
    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 9)
    valuebar:SetMouseVisible(false)
    valuebar:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    --valuebar:SetBackColor(Turbine.UI.Color(0.6, 0.125, 0.125, 0.125))
    valuebar:SetBackground(BackgroundHandler:GetBackground(0x4110CD4D))

    --[[
    valuebar.topBar = Turbine.UI.Control()
    valuebar.topBar:SetParent(valuebar)
    valuebar.topBar:SetSize(width, 3)
    valuebar.topBar:SetPosition(0, 0)
    valuebar.topBar:SetMouseVisible(false)
    valuebar.topBar:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar.topBar:SetBackColor(Turbine.UI.Color(0.6, 1, 1, 1))

    valuebar.lowBar = Turbine.UI.Control()
    valuebar.lowBar:SetParent(valuebar)
    valuebar.lowBar:SetSize(width, 3)
    valuebar.lowBar:SetPosition(0, 6)
    valuebar.lowBar:SetMouseVisible(false)
    valuebar.lowBar:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar.lowBar:SetBackColor(Turbine.UI.Color(0.6, 1, 1, 1))
    --]]

    

    return valuebar
end

function PrimeUIOptions:ListBoxBorder(width)
    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 9)
    valuebar:SetMouseVisible(false)
    valuebar:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar:SetBackground(BackgroundHandler:GetBackground(0x4110CD4D))

    return valuebar
end

function PrimeUIOptions:OptionLabel(width, text)
    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 0)

    valuebar.border = Turbine.UI.Control()
    valuebar.border:SetParent(valuebar)
    valuebar.border:SetSize(width, 50)
    valuebar.border:SetMouseVisible(false)
    valuebar.border:SetBackColor(Turbine.UI.Color(0, 0, 0))

    valuebar.label = Turbine.UI.Label()
    valuebar.label:SetParent(valuebar)
    valuebar.label:SetSize(width - 4, 50 - 4)
    valuebar.label:SetPosition(2, 2)
    valuebar.label:SetMouseVisible(false)
    valuebar.label:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar.label:SetBackColor(Turbine.UI.Color(0.8, 0.125, 0.125, 0.125))
    valuebar.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    valuebar.label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold25)
    valuebar.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    valuebar.label:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    valuebar.label:SetText(text)

    return valuebar
end

function PrimeUIOptions:ColourInput(width, text, currentValue, func)

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 160)
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

    if currentValue then
        if type(currentValue[1]) == "table" then
            for key, value in pairs(currentValue) do
                self:SingleColourOptions(valuebar, width, text, value, func, key)
                valuebar:SetSize(width, 160 * key)
            end
            return valuebar
        else
            self:SingleColourOptions(valuebar, width, text, currentValue, func)
            return valuebar
        end
    end

    return valuebar
end

function PrimeUIOptions:SingleColourOptions(parent, width, text, currentValue, func, index)
    local y = 0
    if index then
        y = (index - 1) * 160
    end
    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetParent(parent)
    valuebar:SetSize(width, 160)
    valuebar:SetPosition(0, y)
    valuebar:SetMouseVisible(false)
   valuebar:SetBackColor(Turbine.UI.Color(0.01,0.31,0.31))

    valuebar.label = Turbine.UI.Label()
	valuebar.label:SetParent(valuebar)
	valuebar.label:SetSize(150, 40)
	valuebar.label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.label:SetPosition(0, 20)
    valuebar.label:SetText(text)

    valuebar.currentLabel = Turbine.UI.Label()
	valuebar.currentLabel:SetParent(valuebar)
	valuebar.currentLabel:SetSize(120, 20)
	valuebar.currentLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.currentLabel:SetPosition(0, 130)
    valuebar.currentLabel:SetText("Current Colour:")

    valuebar.Current = Turbine.UI.Control()
    valuebar.Current:SetParent(valuebar)
    valuebar.Current:SetSize(32, 32)
    valuebar.Current:SetMouseVisible(false)
    valuebar.Current:SetPosition(115, 126)
    valuebar.Current:SetBackColor(Turbine.UI.Color(currentValue[1], currentValue[2], currentValue[3], currentValue[4]))

    valuebar.newLabel = Turbine.UI.Label()
	valuebar.newLabel:SetParent(valuebar)
	valuebar.newLabel:SetSize(100, 20)
	valuebar.newLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.newLabel:SetPosition(155, 130)
    valuebar.newLabel:SetText("New Colour:")

    valuebar.Example = Turbine.UI.Control()
    valuebar.Example:SetParent(valuebar)
    valuebar.Example:SetSize(32, 32)
    valuebar.Example:SetMouseVisible(false)
    valuebar.Example:SetPosition(250, 126)
    valuebar.Example:SetBackColor(Turbine.UI.Color(currentValue[1], currentValue[2], currentValue[3], currentValue[4]))

    -- 1
    valuebar.scrollbar1 = Turbine.UI.Lotro.ScrollBar()
	valuebar.scrollbar1:SetParent(valuebar)
    valuebar.scrollbar1:SetValue(currentValue[1] * 100)
	valuebar.scrollbar1:SetSize(250, 10)
    valuebar.scrollbar1:SetOrientation(Turbine.UI.Orientation.Horizontal)
	valuebar.scrollbar1:SetPosition(150, 20)
    valuebar.scrollbar1:SetBackColor(Turbine.UI.Color(currentValue[1], 0, 0, 0))

    valuebar.scrollbar1label = Turbine.UI.Label()
	valuebar.scrollbar1label:SetParent(valuebar)
	valuebar.scrollbar1label:SetSize(150, 20)
	valuebar.scrollbar1label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.scrollbar1label:SetPosition(400, 15)
    valuebar.scrollbar1label:SetText("Alpha: " .. tostring(currentValue[1]))

    -- 2
    valuebar.scrollbar2 = Turbine.UI.Lotro.ScrollBar()
	valuebar.scrollbar2:SetParent(valuebar)
	valuebar.scrollbar2:SetSize(250, 10)
    valuebar.scrollbar2:SetOrientation(Turbine.UI.Orientation.Horizontal)
	valuebar.scrollbar2:SetPosition(150, 40)
    valuebar.scrollbar2:SetValue(currentValue[2] * 100)
    valuebar.scrollbar1:SetBackColor(Turbine.UI.Color(1, currentValue[2], 0, 0))

    valuebar.scrollbar2label = Turbine.UI.Label()
	valuebar.scrollbar2label:SetParent(valuebar)
	valuebar.scrollbar2label:SetSize(150, 20)
	valuebar.scrollbar2label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.scrollbar2label:SetPosition(400, 35)
    valuebar.scrollbar2label:SetText("Red: " .. tostring(currentValue[2]))
    
    -- 3
    valuebar.scrollbar3 = Turbine.UI.Lotro.ScrollBar()
	valuebar.scrollbar3:SetParent(valuebar)
	valuebar.scrollbar3:SetSize(250, 10)
    valuebar.scrollbar3:SetOrientation(Turbine.UI.Orientation.Horizontal)
	valuebar.scrollbar3:SetPosition(150, 60)
    valuebar.scrollbar3:SetValue(currentValue[3] * 100)
    valuebar.scrollbar1:SetBackColor(Turbine.UI.Color(1, 0, currentValue[3], 0))

    valuebar.scrollbar3label = Turbine.UI.Label()
	valuebar.scrollbar3label:SetParent(valuebar)
	valuebar.scrollbar3label:SetSize(150, 20)
	valuebar.scrollbar3label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.scrollbar3label:SetPosition(400, 55)
    valuebar.scrollbar3label:SetText("Green: " .. tostring(currentValue[3]))

    -- 4
    valuebar.scrollbar4 = Turbine.UI.Lotro.ScrollBar()
    valuebar.scrollbar4:SetParent(valuebar)
    valuebar.scrollbar4:SetSize(250, 10)
    valuebar.scrollbar4:SetOrientation(Turbine.UI.Orientation.Horizontal)
    valuebar.scrollbar4:SetPosition(150, 80)
    valuebar.scrollbar4:SetValue(currentValue[4] * 100)
    valuebar.scrollbar1:SetBackColor(Turbine.UI.Color(1, 0, 0, currentValue[4]))

    valuebar.scrollbar4label = Turbine.UI.Label()
    valuebar.scrollbar4label:SetParent(valuebar)
    valuebar.scrollbar4label:SetSize(150, 20)
    valuebar.scrollbar4label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.scrollbar4label:SetPosition(400, 75)
    valuebar.scrollbar4label:SetText("Blue: " .. tostring(currentValue[4]))

    valuebar.scrollbar1.ValueChanged = function()
        valuebar.scrollbar1label:SetText("Alpha:  " .. valuebar.scrollbar1:GetValue() / 100)
        valuebar.Example:SetBackColor(Turbine.UI.Color(valuebar.scrollbar1:GetValue() / 100, valuebar.scrollbar2:GetValue() / 100, valuebar.scrollbar3:GetValue() / 100, valuebar.scrollbar4:GetValue() / 100))
        valuebar.scrollbar1:SetBackColor(Turbine.UI.Color(valuebar.scrollbar1:GetValue() / 100, 0, 0, 0))
    end

    valuebar.scrollbar2.ValueChanged = function()
        valuebar.scrollbar2label:SetText("Red:  " .. valuebar.scrollbar2:GetValue() / 100)
        valuebar.Example:SetBackColor(Turbine.UI.Color(valuebar.scrollbar1:GetValue() / 100, valuebar.scrollbar2:GetValue() / 100, valuebar.scrollbar3:GetValue() / 100, valuebar.scrollbar4:GetValue() / 100))
        valuebar.scrollbar2:SetBackColor(Turbine.UI.Color(1, valuebar.scrollbar2:GetValue() / 100, 0, 0))
    end

    valuebar.scrollbar3.ValueChanged = function()
        valuebar.scrollbar3label:SetText("Green:  " .. valuebar.scrollbar3:GetValue() / 100)
        valuebar.Example:SetBackColor(Turbine.UI.Color(valuebar.scrollbar1:GetValue() / 100, valuebar.scrollbar2:GetValue() / 100, valuebar.scrollbar3:GetValue() / 100, valuebar.scrollbar4:GetValue() / 100))
        valuebar.scrollbar3:SetBackColor(Turbine.UI.Color(1, 0, valuebar.scrollbar3:GetValue() / 100, 0))
    end


    valuebar.scrollbar4.ValueChanged = function()
        valuebar.scrollbar4label:SetText("Blue:  " .. valuebar.scrollbar4:GetValue() / 100)
        valuebar.Example:SetBackColor(Turbine.UI.Color(valuebar.scrollbar1:GetValue() / 100, valuebar.scrollbar2:GetValue() / 100, valuebar.scrollbar3:GetValue() / 100, valuebar.scrollbar4:GetValue() / 100))
        valuebar.scrollbar4:SetBackColor(Turbine.UI.Color(1, 0, 0, valuebar.scrollbar4:GetValue() / 100))
    end

    valuebar.Button = Turbine.UI.Lotro.Button()
    valuebar.Button:SetParent(valuebar)
    valuebar.Button:SetSize(150, 100)
    valuebar.Button:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    valuebar.Button:SetMouseVisible(false)
    valuebar.Button:SetPosition(300, 130)
    valuebar.Button:SetText("Change colour")

    valuebar.Button.Click = function()
        valuebar.Current:SetBackColor(Turbine.UI.Color(valuebar.scrollbar1:GetValue() / 100, valuebar.scrollbar2:GetValue() / 100, valuebar.scrollbar3:GetValue() / 100, valuebar.scrollbar4:GetValue() / 100))
        func({valuebar.scrollbar1:GetValue() / 100, valuebar.scrollbar2:GetValue() / 100, valuebar.scrollbar3:GetValue() / 100, valuebar.scrollbar4:GetValue() / 100}, index)
    end
end

function PrimeUIOptions:ListBoxInput(width, text, currentValue, type, func)
    if type ~= "Skills" then
        return PrimeUITools.CreateTriggerListBox(width, text, currentValue, type, func, self)
    elseif type == "SkillLabel" and text == "Highlight_On_Effect" or type == "Skills" and text == "Highlight_On_Effect" then
        return PrimeUITools.CreateHighlightSkillListBox(width, text, currentValue, type, func, self)
    elseif type == "Skills" and text ~= "Quickslots" then
        return PrimeUITools.CreateSkillListBox(width, text, currentValue, type, func, self)
    elseif type == "Skills" and text == "Quickslots" then
        return PrimeUITools.CreateQuickslotOptions(width, text, currentValue, type, func, self)
    end
end

function PrimeUIOptions:InfoButton(parent, width, text)
    local SelectButton = Turbine.UI.Control()
	SelectButton:SetParent(parent)
	SelectButton:SetSize(16, 16)
    --SelectButton:SetBackColor(GetRandomColour())
    SelectButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SelectButton:SetBackground(BackgroundHandler:GetBackground(0x41168DAC))
	SelectButton:SetPosition(width - 16, 5)
    SelectButton.Text = text
    SelectButton.MouseEnter = function()
        self.infoWindow:View(SelectButton.Text)
    end

    

    SelectButton.MouseLeave = function()
        self.infoWindow:SetVisible(false)
    end
end

function PrimeUIOptions:GetEffectWindow()
    if not(self.effectWindow) then self.effectWindow = HistoricalEffectOverview() end

    return self.effectWindow
end

function PrimeUIOptions:GetSkillWindow()
    if not(self.skillWindow) then self.skillWindow = SkillOverview() end

    return self.skillWindow
end

function PrimeUIOptions:GetIconWindow()
    if not(self.iconWindow) then self.iconWindow = IconOverview() end

    return self.iconWindow
end

function PrimeUIOptions:SkillOverview2()
    if not(self.skillCodesWindow) then self.skillCodesWindow = SkillOverview2() end

    return self.skillCodesWindow
end

function PrimeUIOptions:CreateGeneralPrimeUIOptions()
    -- PrimeUI Options treeview
    self.PrimeUIGeneralOptionsTreeviewInControl = Turbine.UI.TreeView()
    self.PrimeUIGeneralOptionsTreeviewInControl:SetParent(self.GeneralPrimeUISettingsControl)
    self.PrimeUIGeneralOptionsTreeviewInControl:SetSize(self.GeneralPrimeUISettingsControl:GetWidth() - 10, self.GeneralPrimeUISettingsControl:GetHeight())
    self.PrimeUIGeneralOptionsTreeviewInControl:SetIndentationWidth(0)

    self.PrimeUIGeneralOptionsScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.PrimeUIGeneralOptionsScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical)
    self.PrimeUIGeneralOptionsScrollbar:SetParent( self.GeneralPrimeUISettingsControl)
    self.PrimeUIGeneralOptionsScrollbar:SetPosition( self.GeneralPrimeUISettingsControl:GetWidth() - 10, 0)
    self.PrimeUIGeneralOptionsScrollbar:SetSize( 10,self.GeneralPrimeUISettingsControl:GetHeight())
    self.PrimeUIGeneralOptionsTreeviewInControl:SetVerticalScrollBar( self.PrimeUIGeneralOptionsScrollbar)

    self.PrimeUIGeneralOptionsTreeNodesInControl = self.PrimeUIGeneralOptionsTreeviewInControl:GetNodes()

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(PrimeUITools.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Loading Parameters"))

    -- Class button
    self.ClassMenu = Turbine.UI.ContextMenu()
    self.ClassMenuItems = self.ClassMenu:GetItems()

    local menuItem = Turbine.UI.MenuItem( "All" )
    self.ClassMenuItems:Add(menuItem)
    menuItem.Click = function()
        self.ClassButton:SetText("All")
        self.currentUI["ClassLoad"] = "All"
        PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
    end

    for key, value in spairs(self.Classes, function(t, a, b) return a < b end) do
        local menuItem = Turbine.UI.MenuItem( key )
        self.ClassMenuItems:Add(menuItem)
        menuItem.Click = function()
            self.ClassButton:SetText(key)
            self.currentUI["ClassLoad"] = key
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end

    
    self.ClassButton = PrimeUITools.ButtonInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Class:", function()
        if self.currentUI then
            self.ClassMenu:ShowMenu()
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.ClassButton)

    --Instance
    self.InstanceMenu = UI.DropDownMenuControl(self, 200, "Instance Dropdown Menu")
    for key, value in spairs(InstanceController:GetDungeonNameTable(), function(t, a, b) return t[a] < t[b] end) do
        --local menuItem = Turbine.UI.MenuItem( value )
        self.InstanceMenu:AddItem(value, 
        function()
            self.InstanceButton:SetText(value)
            self.currentUI["InstanceLoad"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            self.InstanceMenu:SetVisible(false)
        end)
    end


    self.InstanceButton = PrimeUITools.ButtonInput(self.GeneralPrimeUISettingsControl:GetWidth()- 10, "Instance:", function()
        if self.currentUI then
            self.InstanceMenu:ToggleVisible()
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.InstanceButton)

    self.AllTierCheckbox = PrimeUITools.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "All Tiers", false, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["AllTiers"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.AllTierCheckbox)

    self.TierMenu = UI.DropDownMenuControl(self, 200, "Tier Menu Dropdown Menu")
    for i = 1, 10 do
        --local menuItem = Turbine.UI.MenuItem( value )
        self.TierMenu:AddItem(i, 
        function()
            self.InstanceTierButton:SetText(i)
            self.currentUI["InstanceTier"] = tostring(i)
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            self.TierMenu:SetVisible(false)
        end)
    end

    self.InstanceTierButton = PrimeUITools.ButtonInput(self.GeneralPrimeUISettingsControl:GetWidth()- 10, "Instance Tier:", function()
        if self.currentUI then
            self.TierMenu:ToggleVisible()
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.InstanceTierButton)

    -- Role
    self.RoleMenu = Turbine.UI.ContextMenu()
    self.RoleMenuItems = self.RoleMenu:GetItems()

    local menuItem = Turbine.UI.MenuItem( "All" )
    self.RoleMenuItems:Add(menuItem)
    menuItem.Click = function()
        self.RoleButton:SetText("All")
        self.currentUI["RoleLoad"] = "All"
        PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
    end

    for key, value in spairs(Roles:GetAvailableRoles(), function(t, a, b) return t[a] < t[b] end) do
        local menuItem = Turbine.UI.MenuItem( value )
        self.RoleMenuItems:Add(menuItem)
        menuItem.Click = function()
            self.RoleButton:SetText(value)
            self.currentUI["RoleLoad"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end

    self.RoleButton = PrimeUITools.ButtonInput(self.GeneralPrimeUISettingsControl:GetWidth()- 10, "Role:", function()
        if self.currentUI then
            self.RoleMenu:ShowMenu()
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.RoleButton)

    -- Line button
    self.classMenu = Turbine.UI.ContextMenu()
    self.classMenuItems = self.classMenu:GetItems()

    local classItem = Turbine.UI.MenuItem( "All" )
    classItem.Click = function()
        self.LineButton:SetText("All")
        self.currentUI["LineLoad"] = "All"
        PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
    end
    self.classMenuItems:Add(classItem)

    local classItem = Turbine.UI.MenuItem( "Blue" )
    classItem.Click = function()
        self.LineButton:SetText("Blue" )
        self.currentUI["LineLoad"] ="Blue"
        PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
    end
    self.classMenuItems:Add(classItem)

    local classItem = Turbine.UI.MenuItem( "Red" )
    classItem.Click = function()
        self.LineButton:SetText("Red")
        self.currentUI["LineLoad"] ="Red"
        PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
    end
    self.classMenuItems:Add(classItem)

    local classItem = Turbine.UI.MenuItem( "Yellow" )
    classItem.Click = function()
        self.LineButton:SetText("Yellow")
        self.currentUI["LineLoad"] = "Yellow"
        PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
    end
    self.classMenuItems:Add(classItem)

    self.LineButton = PrimeUITools.ButtonInput(self.GeneralPrimeUISettingsControl:GetWidth()- 10, "Trait line:", function()
        if self.currentUI then
            self.classMenu:ShowMenu()
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.LineButton)

    -- Never load
    self.NeverLoadCheckbox = PrimeUITools.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Never Load", false, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["NeverLoad"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.NeverLoadCheckbox)

    -- Show in combat
    self.ICheckBox = PrimeUITools.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Show in combat", true, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["ICLoad"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.ICheckBox)


    -- Show out of combat
    self.OOCheckBox = PrimeUITools.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Show out of combat", true, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["OOCLoad"] =  value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.OOCheckBox)

    -- Character load
    self.CharacterButton = PrimeUITools.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Load on all characters", true, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["CharLoad"] = not(value)
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.CharacterButton)

    self.characterNode = PrimeUITools.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Load for specific character(s)")

    self.childCharacterNodes =  self.characterNode:GetChildNodes()

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.characterNode)

    self.characterLoadNodes = {}

    for key, _ in spairs(Profiles:GetPreferences(), function(t, a, b) return a < b end) do
        self.characterLoadNodes[key] = PrimeUITools.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, key, false, function(value)
            if self.currentUI and self.notChanging then
                if not(self.currentUI["CharacterLoad"]) then self.currentUI["CharacterLoad"] = {} end
                self.currentUI["CharacterLoad"][key] = value
                PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            end
        end)
        self.childCharacterNodes:Add(self.characterLoadNodes[key])
    end

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(PrimeUITools.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "General Settings"))

    -- Advanced mode toggle
    self.AdvancedCheckbox = PrimeUITools.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth(), "Advanced mode", false, function(value)
        if self.currentUI and self.notChanging then
            local neverloadValue = self.currentUI["NeverLoad"]
            self.currentUI["AdvancedMode"] = value
            self.currentUI["NeverLoad"] = true
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            self.currentUI["NeverLoad"] = neverloadValue
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.AdvancedCheckbox)
end

IOWindow = class(Turbine.UI.Lotro.Window)
function IOWindow:Constructor(options)
    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(800, 800)
    self:SetPosition(math.floor(Turbine.UI.Display.GetWidth() / 2 - (self:GetWidth() / 2)), math.floor(Turbine.UI.Display.GetHeight() / 2 - (self:GetHeight()/2)))
    self:SetVisible(false)
    self:SetText("PrimeUI")

    self.TextBox = Turbine.UI.Lotro.TextBox()
    self.TextBox:SetParent(self)
    self.TextBox:SetSize(780, 720)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.Arial12)
    --self.TextBox:SetMouseVisible(true)
    self.TextBox:SetPosition(190, 15)
    self.TextBox:SetPosition(10, 40)

    self.SelectButton = Turbine.UI.Lotro.Button()
	self.SelectButton:SetParent(self)
	self.SelectButton:SetSize(100, 20)
	self.SelectButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.SelectButton:SetPosition(math.floor(self:GetWidth() / 2 - (100 / 2)), 760)
    self.SelectButton:SetText("Select All")

    self.SelectButton.Click = function()
        self.TextBox:SelectAll()
    end

    self.ImportButton = Turbine.UI.Lotro.Button()
	self.ImportButton:SetParent(self)
	self.ImportButton:SetSize(100, 20)
	self.ImportButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.ImportButton:SetPosition(math.floor(self:GetWidth() / 2 - (100 / 2)), 760)
    self.ImportButton:SetText("Import")

    self.options = options

    self.ImportButton.Click = function()
        local result, table = pcall(unpickle, self.TextBox:GetText():gsub("@@", "\n"))
        if result then
            if self.options:Add(table) then
                self:SetVisible(false)
                ChatOutput("Imported PrimeUI: " .. table["Name"])
            else
                ChatOutput("Failed to add PrimeUI")
            end
        else
            ChatOutput("Failed to add PrimeUI: Incorrect PrimeUI string!")
        end
    end
end

function IOWindow:View(data)
    self:SetVisible(true)
    self:SetZOrder(100)
    self.TextBox:SetText("")
    if data then
        --TableToString(data, title, self.TextBox)
        self.TextBox:SetText(pickle(data):gsub("\n", "@@"))
        self.ImportButton:SetVisible(false)
        self.SelectButton:SetVisible(true)
    else
        self.ImportButton:SetVisible(true)
        self.SelectButton:SetVisible(false)
    end
end

NewWindow = class(Turbine.UI.Lotro.Window)
function NewWindow:Constructor(options)
    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(300, 100)
    self:SetPosition(math.floor(Turbine.UI.Display.GetWidth() / 2 - (self:GetWidth() / 2)), math.floor(Turbine.UI.Display.GetHeight() / 2 - (self:GetHeight()/2)))
    self:SetVisible(false)
    self:SetText("Add")

    self.TextBox = Turbine.UI.Lotro.TextBox()
    self.TextBox:SetParent(self)
    self.TextBox:SetSize(280, 20)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.Arial12)
    self.TextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TextBox:SetMouseVisible(false)
    self.TextBox:SetPosition(10, 40)

    self.ImportButton = Turbine.UI.Lotro.Button()
	self.ImportButton:SetParent(self)
	self.ImportButton:SetSize(100, 20)
	self.ImportButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.ImportButton:SetPosition(math.floor(self:GetWidth() - (130)), 65)
    self.ImportButton:SetText("Add")

    self.ICheckBox = Turbine.UI.Lotro.CheckBox()
	self.ICheckBox:SetParent(self)
	self.ICheckBox:SetSize(100, 20)
	self.ICheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.ICheckBox:SetPosition(30, 65)
    self.ICheckBox:SetText("Advanced")
    self.ICheckBox:SetChecked(false)

    self.options = options

    self.ImportButton.Click = function()
        if self.options:CreateNew(tostring(self.TextBox:GetText()), self.ICheckBox:IsChecked()) then
            self:SetVisible(false)
        else
            ChatOutput("Failed to make new PrimeUI: There is already a PrimeUI with that name!")
        end
    end
end

function NewWindow:View()
    self:SetVisible(true)
    self:SetZOrder(100)
    self.TextBox:SetText("")
end

InfoWindow = class(Turbine.UI.Window)
function InfoWindow:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(400, 100)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.TextBox = Turbine.UI.Label()
    self.TextBox:SetParent(self)
    self.TextBox:SetSize(200, 20)
    self.TextBox:SetPosition(3, 3)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    self.TextBox:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    --self.TextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TextBox:SetMouseVisible(false)
    self.TextBox:SetBackColor(Turbine.UI.Color(0.8, 0.125, 0.125, 0.125))
end

function InfoWindow:View(Text)
    self:SetVisible(true)
    local x, y = self:GetMousePosition()
    local oldX, oldY = self:GetPosition()
    self:SetPosition((x + oldX) - 200, y + oldY + 5)
    self:SetZOrder(1)
    self.TextBox:SetText(Text or "No info text available.")
    local length = Text and math.ceil(string.len(Text) / 70) + 1 or 1
    self:SetSize(400, length * 22)
    self.TextBox:SetSize(400 - 6, length * 22 - 6)
end