ClassSkillSlot = class(Turbine.UI.Window)
function ClassSkillSlot:Constructor(parent, x, y, base, normal, skill, hideOnCreation, pet, highlight, scale)
    Turbine.UI.Window.Constructor(self)

    self.base = base
    self.normal = 35
    self.hideOnCreation = hideOnCreation
    if scale then
        self.scale = scale
    else
        self.scale = 1
    end

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(self.normal * self.scale, self.normal * self.scale)
    self:SetVisible(true)
    --self:SetBackColor(Turbine.UI.Color(0,0,0))

    self.textFunction = StringifyDuration

    if highlight then
        self.highlight = HighlightFrame(self)
    end

    self.baseImageID = 0x41007E35

    self.currentNumber = -1

    if pet then
        self.typeNumber = 1
    else
        self.typeNumber = 0
    end

    self.IconLabel = Turbine.UI.Lotro.Quickslot()
    self.IconLabel:SetParent(self)
    self.IconLabel:SetSize(self.normal, self.normal)
    --self.IconLabel:SetBackColor(GetRandomColour())
    self.IconLabel:SetPosition(-3, -3)
    --self.IconLabel:SetAllowDrop(false)
    self.shortcut = Turbine.UI.Lotro.Shortcut(6 + self.typeNumber, skill)
    self.IconLabel:SetShortcut(self.shortcut)
    if self.hideOnCreation then
        self.IconLabel:SetVisible(false)
        --ChatOutput("X")
    end
    --self.IconLabel:SetVisible(false)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(self.normal, self.normal)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    --self.textLabel:SetPosition(-2, -2)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetSize(self.normal * self.scale, self.normal * self.scale)

    --self.fMLabel = ClassSkillLabel(self, 0, 0, base, base, CJIconSmalll, true)

    self.IconLabel.ShortcutChanged = function()
        --self.IconLabel:SetShortcut(self.shortcut)
        ChatOutput(self.IconLabel:GetShortcut():GetData())
    end

    self.IconLabel:SetStretchMode(1)
    self.IconLabel:SetSize(self.normal * self.scale, self.normal * self.scale)


    self.duration = 0
    --self:ToggleHighlight(true)
    --self.textLabel:SetText("0")
end

function ClassSkillSlot:ToggleVisible(value)
    self:SetVisible(value)
    self.IconLabel:SetVisible(value)
end

function ClassSkillSlot:SetTimer(timer, maxTimer)
    self.duration = timer
end

function ClassSkillSlot:ExecuteUpdate(delta)
    self.duration = self.duration - delta

    if self.duration < 0 then
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText("")
        return true
    end

    if self.currentNumber == math.round(self.duration) then
        return
    else
        self.currentNumber = math.round(self.duration)
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText(self.textFunction(self.currentNumber))
    end
    
end

function ClassSkillSlot:Unload()
    self.shortcut = nil
    self.IconLabel:SetParent(nil)
    self.textLabel:SetParent(nil)
    self:SetParent(nil)
    self = nil
end

function ClassSkillSlot:ToggleHighlight(value)
    if self.highlight then
        self.highlight:Toggle(value)
    end
end

function ClassSkillSlot:AddBackground(icon)
    self.IconLabel:SetStretchMode(nil)
    self.IconLabel:SetSize(self.base, self.base)
    self.IconLabel:SetStretchMode(1)
    self.IconLabel:SetBackground(BackgroundHandler:GetBackground(icon))
    self.IconLabel:SetSize(self.normal * self.scale, self.normal * self.scale)
end

-------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------

ClassSkillSlotPrimeUI = class(Turbine.UI.Window)
function ClassSkillSlotPrimeUI:Constructor(parent, x, y, width, height, code, borderColour, borderSize, reverse, visibitilityThreshold, hideWhileOff, hideWhileOn, opacityOn, opacityOff, font, scale, highlight, highlightColour, higlightSize, callbackFunction)
    Turbine.UI.Window.Constructor(self)

    self.width = 34
    self.height = 34
    self.scale = scale or 1

    self.visibitilityThreshold = visibitilityThreshold or 9999
    self.hideWhileOff = hideWhileOff or false
    self.hideWhileOn = hideWhileOn or false
    self.opacityOff = opacityOff or 1
    self.opacityOn = opacityOn or 1
    self.borderSize = borderSize or 0
    self.callbackFunction = callbackFunction

    if type(code) == "table" then
        self.data = code.Data
        self.type = code.Type
        self.item = code.Item
        self.shortcut = Turbine.UI.Lotro.Shortcut(self.type, self.data) 
    else
        self.code = code
        self.shortcut = Turbine.UI.Lotro.Shortcut(6, self.code)
    end

    self.currentDuration = 0

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetVisible(not(self.hideWhileOff))
    self:SetBackColor(borderColour or Turbine.UI.Color(0,0,0))
    self:SetOpacity(self.opacityOff)
    self:SetSize(self.width * self.scale + 2 * self.borderSize, self.height * self.scale + 2 * self.borderSize)

    self.textFunction = StringifyDuration

    if highlight then
        --self.highlight = HighlightFrame(self, borderSize)
        self:SetZOrder(100)
        self.highlight = HighlightFrame3(self, 0, 0, (self.width + 2 * self.borderSize) * self.scale, (self.height + 2 * self.borderSize) * self.scale, highlightColour, higlightSize)
    end

    self.baseImageID = 0x41007E35

    self.currentNumber = -1

    self.IconLabel = Turbine.UI.Lotro.Quickslot()
    self.IconLabel:SetParent(self)
    self.IconLabel:SetSize(35, 35)
    --self.IconLabel:SetBackColor(GetRandomColour())
    self.IconLabel:SetPosition(-2 + self.borderSize, -2 + self.borderSize)
    --self.IconLabel:SetAllowDrop(false)
    self.IconLabel:SetShortcut(self.shortcut)
    self.IconLabel:SetUseOnRightClick(true)
    if self.hideOnCreation then
        self.IconLabel:SetVisible(false)
    end
    --self.IconLabel:SetVisible(false)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    --self.textLabel:SetSize(self.width, self.height)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(font or Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetMultiline(false)
    --self.textLabel:SetPosition(-2, -2)
    --self.textLabel:SetStretchMode(1)
    self.textLabel:SetSize(self.width * self.scale + 2 * self.borderSize, self.height * self.scale + 2 * self.borderSize)

    --self.fMLabel = ClassSkillLabel(self, 0, 0, base, base, CJIconSmalll, true)

    self.IconLabel.ShortcutChanged = function()
        --self.IconLabel:SetShortcut(self.shortcut)
        ChatOutput(self.IconLabel:GetShortcut():GetData())
    end

    self.IconLabel:SetStretchMode(1)
    self.IconLabel:SetSize(35 * self.scale, 35 * self.scale)

    --self:ToggleHighlight(true)
    --self.textLabel:SetText("0")
end

function ClassSkillSlotPrimeUI:ExecuteUpdate(delta)

    --Update time
    self.currentDuration = self.currentDuration - delta

    self:SetVisible(self.currentDuration <= self.visibitilityThreshold and not(self.hideWhileOn))

    if self.currentDuration < 0 then
        --if self.callback then RemoveCallback(Updater, "ExecuteUpdate", self.callback) end
        --self.callback = nil
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText("")
        self:SetOpacity(self.opacityOff)
        

        self:SetVisible(not(self.hideWhileOff))

        if self.callbackFunction then self.callbackFunction() end
        return true
    end

    -- Update timer label
    self.textLabel:SetStretchMode(nil)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetText(self.textFunction(self.currentDuration))
end

function ClassSkillSlotPrimeUI:Unload()
    self:SetParent(nil)
end

function ClassSkillSlotPrimeUI:ToggleVisible()

end

function ClassSkillSlotPrimeUI:ToggleHighlight(value)
    if self.highlight then
        self.highlight:Toggle(value)
    end
end

function ClassSkillSlotPrimeUI:SetTimer(time, maxTimer)
    if not(time) then return end
    self.currentDuration = time
    self.maxDuration = maxTimer
    self:SetOpacity(self.opacityOn)
    self:SetVisible(self.currentDuration <= self.visibitilityThreshold and not(self.hideWhileOn)  and time > 0.1)
end

-------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------

PrimeUISkillLabel = class(Turbine.UI.Window)
function PrimeUISkillLabel:Constructor(parent, x, y, width, height, scale, icon, borderColour, borderSize, reverse, visibitilityThreshold, hideWhileOff, hideWhileOn, opacityOn, opacityOff, highlightColour, higlightSize, highlightWhileOff, highlight)
    Turbine.UI.Window.Constructor(self)

    self.width = width
    self.height = height
    self.borderSize = borderSize
    self.scale = scale
    self.reverse = reverse
    self.icon = icon
    self.shade = true
    self.visibitilityThreshold = visibitilityThreshold
    self.hideWhileOff = hideWhileOff
    self.hideWhileOn = hideWhileOn
    self.opacityOff = opacityOff or 1
    self.opacityOn = opacityOn or 1
    self.highlightWhileOff = highlightWhileOff
    self.highlight = highlight

    self.normalOpacity = normalOpacity
    self.usageOpacity = usageOpacity
    self.hideOnCreation = hideOnCreation

    self.textFunction = StringifyDuration

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(self.width + 2 * self.borderSize, self.height + 2 * self.borderSize)
    self:SetBackColor(borderColour)
    self:SetVisible(not(self.hideWhileOff))
    self:SetMouseVisible(false)
    self:SetOpacity(self.opacityOff)

    self.currentDuration = 0
    self.maxDuration = 0
    self.baseImageID = 0x41007E35

    self.IconLabel = Turbine.UI.Label()
    self.IconLabel:SetParent(self)
    self.IconLabel:SetSize(self.width, self.height)
    --self.IconLabel:SetStretchMode(1)
    self.IconLabel:SetBackground(BackgroundHandler:GetBackground(tonumber(self.icon) or self.icon))
    self.IconLabel:SetPosition(self.borderSize, self.borderSize)
    self.IconLabel:SetBlendMode(Turbine.UI.BlendMode.GrayScale)
    self.IconLabel:SetMouseVisible(false)
    

    if self.shade then
        self.elapsedOverlay = Turbine.UI.Control()
        self.elapsedOverlay:SetStretchMode( 1 )
        self.elapsedOverlay:SetMouseVisible( false )
        --self.elapsedOverlay:SetZOrder( 99 )
        self.elapsedOverlay:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
        self.elapsedOverlay:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay )
        self.elapsedOverlay:SetParent( self )
        self.elapsedOverlay:SetSize(self.width + 2 + self.borderSize, self.height + 2  + self.borderSize)
        self.elapsedOverlay:SetMouseVisible(false)
    end

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(self.width  + self.borderSize, self.height  + self.borderSize)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    --self.textLabel:SetPosition(-2, -2)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetMultiline(false)

    self.highlightFrame = HighlightFrame3(self, 0, 0, (self.width + 2 * self.borderSize) * self.scale, (self.height + 2 * self.borderSize) * self.scale, highlightColour, higlightSize)
    --self.highlightFrame:SetPosition(self.borderSize,  self.borderSize)
    self.highlightFrame:Toggle(self.highlightWhileOff)


    self:SetStretchMode(1)
    self:SetSize((self.width + 2 * self.borderSize) * self.scale, (self.height + 2 * self.borderSize) * self.scale)


    self.duration = 0
    --self.textLabel:SetText("0")

    self.ExecuteUpdate = function(delta)

        --Update time
        self.currentDuration = self.currentDuration - delta

        self:SetVisible(self.currentDuration <= self.visibitilityThreshold and not(self.hideWhileOn))

        if self.currentDuration < 0 then
            if self.callback then RemoveCallback(Updater, "ExecuteUpdate", self.callback) end
            self.callback = nil
            self.textLabel:SetStretchMode(nil)
            self.textLabel:SetStretchMode(1)
            self.textLabel:SetText("")
            self.elapsedOverlay:SetVisible(false)
            self.elapsedOverlay:SetOpacity(self.opacityOff)
            self:SetOpacity(self.opacityOff)
            if self.highlight and self.highlightFrame then
                self.highlightFrame:Toggle(false)
            end

            if self.highlightWhileOff and self.highlightFrame then
                self.highlightFrame:Toggle(true)
            end
            

            self:SetVisible(not(self.hideWhileOff))
            return
        end

        -- Visual timer
        if self.shade then
            self.elapsedOverlay:SetVisible(true)
            local percentComplete = math.min(59, math.ceil(60 * self.currentDuration / self.maxDuration))
    
            if self.currentPercentage ~= percentComplete then 
    
                self.currentPercentage = percentComplete
    
                local imageId = self.baseImageID + self.currentPercentage            
    
                self.elapsedOverlay:SetStretchMode(3)
                self.elapsedOverlay:SetSize(32, 32)
                self.elapsedOverlay:SetBackground(BackgroundHandler:GetBackground(imageId))
                self.elapsedOverlay:SetStretchMode(1)
                self.elapsedOverlay:SetSize(self.width + 2 + self.borderSize, self.height + 2 + self.borderSize)
            end
        end

        -- Update timer label
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText(self.textFunction(self.currentDuration))
    end
end

function PrimeUISkillLabel:SetTimer(time, maxTime)
    self.currentDuration = time
    self.maxDuration = maxTime
    self:SetOpacity(self.opacityOn)

    if self.highlightWhileOff and self.highlightFrame then
        self.highlightFrame:Toggle(false)
    end

    if self.highlight and self.highlightFrame then
        self.highlightFrame:Toggle(true)
    end


    self:SetVisible(self.currentDuration <= self.visibitilityThreshold and not(self.hideWhileOn))

    self.elapsedOverlay:SetVisible(true)
    self.elapsedOverlay:SetOpacity(self.opacityOn)
    self.elapsedOverlay:SetStretchMode(3)
    self.elapsedOverlay:SetSize(32, 32)
    self.elapsedOverlay:SetBackground(BackgroundHandler:GetBackground(self.baseImageID + math.min(59, math.ceil(60 * self.currentDuration / self.maxDuration))))
    self.elapsedOverlay:SetStretchMode(1)
    self.elapsedOverlay:SetSize(self.width + 2 + self.borderSize, self.height + 2 + self.borderSize)

    if not(self.callback) then self.callback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
end

function PrimeUISkillLabel:Unload()
    self:SetParent(nil)
end

function PrimeUISkillLabel:ToggleHighlight(value)
    self.highlightFrame:Toggle(value)
end