FirstTimerOptions = class(Turbine.UI.Lotro.Window)
function FirstTimerOptions:Constructor()
    local width = 600
    local height = 400
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(x,y)
    self:SetText("Prime")
    self:SetVisible(true)

    -- Setup windows
    OptionControls = {}

    -- Welcome screen
    OptionControls[#OptionControls + 1] = FirstTimerWindowsWelcome(self)

    -- Combat Timer
    OptionControls[#OptionControls + 1] = FirstTimerWindowsCombatTimer(self)

    -- Alerts
    OptionControls[#OptionControls + 1] = FirstTimerWindowsAlerts(self)

    -- Skill Timers
    --OptionControls[#OptionControls + 1] = FirstTimerWindowsTimers(self)

    -- Loot
    OptionControls[#OptionControls + 1] = FirstTimerWindowsLoot(self)

    -- Target window
    OptionControls[#OptionControls + 1] = FirstTimerWindowsTarget(self)

    -- Skill window
    --OptionControls[#OptionControls + 1] = FirstTimerWindowsSkillWindow(self)

    -- Sound player
    OptionControls[#OptionControls + 1] = FirstTimerWindowsSound(self)

    -- Skill Alert Timers
    --OptionControls[#OptionControls + 1] = FirstTimerWindowsSkillAlertTimers(self)
    
    -- Target Box
    --OptionControls[#OptionControls + 1] = FirstTimerWindowsTargetBox(self)

    -- Finish screen
    OptionControls[#OptionControls + 1] = FirstTimerWindowsFinish(self)

    OptionControls[1]:SetVisible(true)

    local OptionCount = #OptionControls
    local CurrentOptions = 1

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(50, 20)
    NameLabel:SetPosition(275, 350)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
    NameLabel:SetText(CurrentOptions .. " / " .. OptionCount)
    
    -- Create buttons
    local PrevButton = Turbine.UI.Lotro.Button()
    PrevButton:SetParent(self)
    PrevButton:SetSize(100, 15)
    PrevButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    PrevButton:SetMouseVisible(true)
    PrevButton:SetPosition(175, 350)
    PrevButton:SetText("Previous")
    PrevButton:SetVisible(false)

    local NextButton = Turbine.UI.Lotro.Button()
    NextButton:SetParent(self)
    NextButton:SetSize(100, 15)
    NextButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    NextButton:SetMouseVisible(true)
    NextButton:SetPosition(325, 350)
    NextButton:SetText("Next")

    
    local FinishButton = Turbine.UI.Lotro.Button()
    FinishButton:SetParent(self)
    FinishButton:SetVisible(false)
    FinishButton:SetSize(100, 15)
    FinishButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    FinishButton:SetMouseVisible(true)
    FinishButton:SetPosition(325, 350)
    FinishButton:SetText("Finish")


    -- Handle state changes
    self.NewState = function()

        -- Handle the button state
        if CurrentOptions == 1 then
            PrevButton:SetVisible(false)
        elseif CurrentOptions > 1 then
            PrevButton:SetVisible(true)
        end

        if CurrentOptions == OptionCount then
            NextButton:SetVisible(false)
            FinishButton:SetVisible(true)
        elseif CurrentOptions < OptionCount then
            NextButton:SetVisible(true)
            FinishButton:SetVisible(false)
        end

        -- Handle the window state
        for key, value in pairs(OptionControls) do
            value:SetVisible(false)
        end
        OptionControls[CurrentOptions]:SetVisible(true)

        NameLabel:SetText(CurrentOptions .. " / " .. OptionCount)
    end

    -- Button Events
    PrevButton.Click = function()
        CurrentOptions = CurrentOptions - 1
        self.NewState()
    end

    NextButton.Click = function()
        CurrentOptions = CurrentOptions + 1
        self.NewState()
    end

    FinishButton.Click = function()
        Settings.FirstTime = false
        ReloadPlugin()
    end

    self.Closing = function()
        Settings.FirstTime = false
        ReloadPlugin()
    end
end

function CheckWindowTemplate(parent, setting, text, x, y)
    local cBox = Turbine.UI.Lotro.CheckBox()
    cBox:SetParent(parent)
    cBox:SetPosition(x, y)
    cBox:SetSize(300,20)
    cBox:SetChecked(setting)
    cBox:SetText(text)
    cBox:SetVisible(true)
    return cBox
end

--[[
==================================================================================================================================================================
==================================================================================================================================================================
==================================================================================================================================================================
]]

-- Welcome window
FirstTimerWindowsWelcome = class(Turbine.UI.Control)
function FirstTimerWindowsWelcome:Constructor(parent)
    local width = 500
    local height = 500
    local font = Settings.LOFont
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    --self:SetPosition(x,y)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetParent(parent)

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 75)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("First Time Setup")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 400)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 75)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\nThis is the first time setup for the Prime Plugin to help you customize it to your needs. It will go through every tool that you can enable/disable. It will not touch on the tools that the player has to configure themselves (such as buff bars or skill overlays), these tools can be found in the options accessible through the plugin options button (default spot bottom left).\n\nIf you have any questions or feedback try out the discord: https://discord.gg/aW6SmZKB79\n\nThank you for using the PrimePlugin! Don't take yourself too seriously and remember to have fun!")

    local PatchButton = Turbine.UI.Lotro.Button()
    PatchButton:SetParent(self)
    PatchButton:SetVisible(true)
    PatchButton:SetSize(150, 15)
    PatchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    PatchButton:SetMouseVisible(true)
    PatchButton:SetPosition(225, 330)
    PatchButton:SetText("Check Patch Notes")

    
    PatchButton.Click = function()
        WindowsHandlerController:CreatePatchWindow()
    end

    local FinishButton2 = Turbine.UI.Lotro.Button()
    FinishButton2:SetParent(self)
    FinishButton2:SetVisible(true)
    FinishButton2:SetSize(100, 15)
    FinishButton2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    FinishButton2:SetMouseVisible(true)
    FinishButton2:SetPosition(250, 370)
    FinishButton2:SetText("Skip Setup")

    FinishButton2.Click = function()
        Settings.FirstTime = false
        ReloadPlugin()
    end

    self.menu = Turbine.UI.ContextMenu()
    self.menuItems = self.menu:GetItems()



    for key, value in pairs(Profiles:GetPreferences()) do
        local menuItem = Turbine.UI.MenuItem(key)
        menuItem.Click = function()
            Profiles:ChangePreference(key)
            self.button:SetText("Current profile: " .. key)
            ReloadPlugin()
        end
        self.menuItems:Add(menuItem)
    end

    self.button = Turbine.UI.Lotro.Button()
    self.button:SetParent(self)
    self.button:SetPosition(300, 40)
    self.button:SetSize(200,15)
    self.button:SetText("Current profile: " .. Profiles:GetPreferences()[Player:GetName()])
    self.button:SetVisible(true)

    self.button.Click = function()
        self.menu:ShowMenu()
    end

    --[[
    local EffectBox1 = Turbine.UI.Lotro.CheckBox()
    EffectBox1:SetParent(self)
    EffectBox1:SetPosition(300, 40)
    EffectBox1:SetSize(200,20)
    EffectBox1:SetChecked(LoadSettings[Turbine.Gameplay.LocalPlayer.GetInstance():GetName()] == 1)
    EffectBox1:SetText("Character settings")
    EffectBox1:SetVisible(true)

    local EffectBox2 = Turbine.UI.Lotro.CheckBox()
    EffectBox2:SetParent(self)
    EffectBox2:SetPosition(300, 60)
    EffectBox2:SetSize(200,20)
    EffectBox2:SetChecked(LoadSettings[Turbine.Gameplay.LocalPlayer.GetInstance():GetName()] == 2)
    EffectBox2:SetText("Account settings")
    EffectBox2:SetVisible(true)

    EffectBox1.CheckedChanged = function()
        if EffectBox1:IsChecked() then
            LoadSettings[Turbine.Gameplay.LocalPlayer.GetInstance():GetName()] = 1
            LoadSettings.SaveSettings = false
            EffectBox2:SetChecked(false)
            ReloadPlugin()
        end
    end

    EffectBox2.CheckedChanged = function()
        if EffectBox2:IsChecked() then
            LoadSettings[Turbine.Gameplay.LocalPlayer.GetInstance():GetName()] = 2
            LoadSettings.SaveSettings = false
            EffectBox1:SetChecked(false)
            ReloadPlugin()
        end
    end
    --]]
end

--[[
==================================================================================================================================================================
==================================================================================================================================================================
==================================================================================================================================================================
]]

-- Combat timer window
FirstTimerWindowsCombatTimer = class(Turbine.UI.Control)
function FirstTimerWindowsCombatTimer:Constructor(parent)
    local width = 500
    local height = 500
    local font = Settings.LOFont
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    --self:SetPosition(x,y)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetParent(parent)

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("Combat Timer")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\nThe Combat Timer is a big simple timer on your screen that will show you how long you are engaged in combat. By overriding the combat timer it will in certain fights try to track the fight time instead of in combat time. This is to combat losing track of the time when you die in the middle of a fight.")


    local CheckWindow = CheckWindowTemplate(self, Settings.CTEnabled, "Enable Combat Timer", 100, 260)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.CTEnabled = CheckWindow:IsChecked()
    end

    local CheckWindow = CheckWindowTemplate(self, Settings.CTOverride, "Enable Boss Override", 100, 280)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.CTOverride = CheckWindow:IsChecked()
    end

end

--[[
==================================================================================================================================================================
==================================================================================================================================================================
==================================================================================================================================================================
]]

-- Alert window
FirstTimerWindowsAlerts = class(Turbine.UI.Control)
function FirstTimerWindowsAlerts:Constructor(parent)
    local width = 500
    local height = 500
    local font = Settings.LOFont
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    --self:SetPosition(x,y)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetParent(parent)

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("Group Alerts")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\nThe Group Alerts will notify you on certain effects or events used against you or the group. It will also notify you if a defeated party member has an active dnf applied.")


    local CheckWindow = CheckWindowTemplate(self, Settings.AEnabled, "Enable Group Alerts", 100, 190)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.AEnabled = CheckWindow:IsChecked()
    end


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 220)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("Effect Alerts")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 220)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\nThe Effect Alerts will notify you on certain effects or events used against you specifically.")


    local CheckWindow = CheckWindowTemplate(self, Settings.EEnabled, "Enable Self Alerts", 100, 300)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.EEnabled = CheckWindow:IsChecked()
    end

end

--[[
==================================================================================================================================================================
==================================================================================================================================================================
==================================================================================================================================================================
]]

-- Timer window
FirstTimerWindowsTimers= class(Turbine.UI.Control)
function FirstTimerWindowsTimers:Constructor(parent)
    local width = 500
    local height = 500
    local font = Settings.LOFont
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    --self:SetPosition(x,y)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetParent(parent)

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 50)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("Boss Timers")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 50)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\nBoss timers will help you keep track of mechanics in boss fights to plan your fight.")

    local CheckWindow = CheckWindowTemplate(self, Settings.SEnabled, "Enable Boss Timers", 100, 120)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.SEnabled = CheckWindow:IsChecked()
    end

    
    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 150)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("Skill Timers")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 150)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\nSkill timers can track (or approximate) the cooldowns of major skills used by party members and yourself. It also shows currently active major skills.")

    local CheckWindow = CheckWindowTemplate(self, Settings.SPEnabled, "Enable Skill Tracking", 100, 240)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.SPEnabled = CheckWindow:IsChecked()
    end

    local CheckWindow = CheckWindowTemplate(self, Settings.SPCDEnabled, "Enable Skill Cooldown Timers", 100, 260)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.SPCDEnabled = CheckWindow:IsChecked()
    end

    local CheckWindow = CheckWindowTemplate(self, Settings.SPActiveEnabled, "Enable Active Timers", 100, 280)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.SPActiveEnabled = CheckWindow:IsChecked()
    end

end

--[[
==================================================================================================================================================================
==================================================================================================================================================================
==================================================================================================================================================================
]]

-- Loot window
FirstTimerWindowsLoot = class(Turbine.UI.Control)
function FirstTimerWindowsLoot:Constructor(parent)
    local width = 500
    local height = 500
    local font = Settings.LOFont
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    --self:SetPosition(x,y)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetParent(parent)

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("Loot Window")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\nTracks endgame lootlocks on all characters on your account and shows them in a single window for convenience.")

    local CheckWindow = CheckWindowTemplate(self, Settings.LOEnabled, "Enable Loot Tracking", 100, 190)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.LOEnabled = CheckWindow:IsChecked()
    end

    self.TimezoneBox = Turbine.UI.Lotro.TextBox()
    self.TimezoneBox:SetParent(self)
    self.TimezoneBox:SetSize(30, 20)
    self.TimezoneBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TimezoneBox:SetPosition(150, 250)
    self.TimezoneBox:SetText(AccountData["TimeZone"])

    self.TimeZoneLabel = Turbine.UI.Label()
    self.TimeZoneLabel:SetParent(self)
    self.TimeZoneLabel:SetSize(60, 20)
    self.TimeZoneLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TimeZoneLabel:SetPosition(90, 250)
    self.TimeZoneLabel:SetText("GMT")

    self.TimeZoneBUtton = Turbine.UI.Lotro.Button()
    self.TimeZoneBUtton:SetParent(self)
    self.TimeZoneBUtton:SetSize(100, 20)
    self.TimeZoneBUtton:SetPosition(180, 250)
    self.TimeZoneBUtton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TimeZoneBUtton:SetText("Set Timezone")

    self.TimeZoneBUtton.Click = function()
        local newZone = tonumber(self.TimezoneBox:GetText())
        if newZone then
            AccountData["TimeZone"] = newZone
        end
    end

end

--[[
==================================================================================================================================================================
==================================================================================================================================================================
==================================================================================================================================================================
]]

-- Loot window
FirstTimerWindowsTarget = class(Turbine.UI.Control)
function FirstTimerWindowsTarget:Constructor(parent)
    local width = 500
    local height = 500
    local font = Settings.LOFont
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    --self:SetPosition(x,y)
    self:SetMouseVisible(false)
    self:SetVisible(false)
    self:SetParent(parent)

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 50)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("Target Window")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 300)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 50)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\nShows buffs and debuffs from your target in the form of timers for better visibility. As default a certain set of effects is chosen, but you can choose to see all effects. By clicking on the window you can see the latest encounters, it will show time and dps of a target.")

    local CheckWindow = CheckWindowTemplate(self, Settings.TEnabled, "Enable Target Window", 100, 260)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.TEnabled = CheckWindow:IsChecked()
    end

    local CheckWindow = CheckWindowTemplate(self, Settings.TShowAll, "Show all effects on target", 100, 300)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.TShowAll = CheckWindow:IsChecked()
    end

    local CheckWindow = CheckWindowTemplate(self, not(Settings.TEffects), "Disable effect tracking", 100, 320)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.TEffects = not(CheckWindow:IsChecked())
    end

end

--[[
==================================================================================================================================================================
==================================================================================================================================================================
==================================================================================================================================================================
]]

-- Skill Window
FirstTimerWindowsSkillWindow = class(Turbine.UI.Control)
function FirstTimerWindowsSkillWindow:Constructor(parent)
    local width = 500
    local height = 500
    local font = Settings.LOFont
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    --self:SetPosition(x,y)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetParent(parent)

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("Skill Window")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\nCertain classes have a skill window that displays a timer for an easily forgotten skill. This just serves as a reminder and is somewhat outdated with the addition of skill overlays.")

    local CheckWindow = CheckWindowTemplate(self, Settings.SWVisible, "Show Skill Window", 100, 200)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.SWVisible = CheckWindow:IsChecked()
    end

end

--[[
==================================================================================================================================================================
==================================================================================================================================================================
==================================================================================================================================================================
]]

-- Welcome window
FirstTimerWindowsSound = class(Turbine.UI.Control)
function FirstTimerWindowsSound:Constructor(parent)
    local width = 500
    local height = 500
    local font = Settings.LOFont
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    --self:SetPosition(x,y)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetParent(parent)

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("Sound Player")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\nAllows you to play sounds on certain events so you get an audio alert on top of a visual one. This only works if you have access to the prime sound player program.")

    local CheckWindow = CheckWindowTemplate(self, Settings.Sound, "Enable Sound Player",  100, 200)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.Sound = CheckWindow:IsChecked()
    end


end

--[[
==================================================================================================================================================================
==================================================================================================================================================================
==================================================================================================================================================================
]]

-- Welcome window
FirstTimerWindowsSkillAlertTimers = class(Turbine.UI.Control)
function FirstTimerWindowsSkillAlertTimers:Constructor(parent)
    local width = 500
    local height = 500
    local font = Settings.LOFont
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    --self:SetPosition(x,y)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetParent(parent)

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("Skill Alert Timers (Alerts require an active target window and alerts enabled to work!)")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\n\nThis tool is a combination between timers and alerts. Its use is mainly meant for pvmp but can be used for pve. It can show alerts when certain effects expire on a target (think slows, defensive cds), or when skills or enemies or allies are ready for use again (defensive cds). For certain pvmp skills used against you a timer will be started to track the cooldown of the skill.")

    local CheckWindow = CheckWindowTemplate(self, Settings.SKAEnabled, "Enable Skill Alerts",  100, 270)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.SKAEnabled = CheckWindow:IsChecked()
    end

    local CheckWindow = CheckWindowTemplate(self, Settings.SKTEnabled, "Enable Enemy Skill Timers (PvMP)",  100, 290)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.SKTEnabled = CheckWindow:IsChecked()
    end


end

--[[
==================================================================================================================================================================
==================================================================================================================================================================
==================================================================================================================================================================
]]

-- Welcome window
FirstTimerWindowsTargetBox = class(Turbine.UI.Control)
function FirstTimerWindowsTargetBox:Constructor(parent)
    local width = 500
    local height = 500
    local font = Settings.LOFont
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    --self:SetPosition(x,y)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetParent(parent)

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("Target Box (Beta)")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 100)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\nThis tool will help with targetting an enemy or ally that is either in danger or might require action. It will attempt to show a box that when clicked set your target to it. ")

    local CheckWindow = CheckWindowTemplate(self, Settings.TBEnabled, "Enable Target Box",  100, 200)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.TBEnabled = CheckWindow:IsChecked()
    end


end

--[[
==================================================================================================================================================================
==================================================================================================================================================================
==================================================================================================================================================================
]]

-- Welcome window
FirstTimerWindowsFinish = class(Turbine.UI.Control)
function FirstTimerWindowsFinish:Constructor(parent)
    local width = 600
    local height = 500
    local font = Settings.LOFont
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    --self:SetPosition(x,y)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetParent(parent)

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(500, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(50, 30)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("Completed Setup")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(500, 500)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(50, 30)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    NameLabel:SetText("\n\nTo access more settings on the previous windows look in the either the plugins manager options or the options (This can be found in the plugin options button (default bottom left) and accessing windows > options)).\n\nBesides these windows the plugin also offers more functionality:\n-Note window for your raid leader to put notes for the raid/fight\n-Stat window: Records many stats about your account and characters\n-Improved readycheck: Your raid leader can do an improved readycheck so everyone can see who is ready and who is slacking (All need the primeplugin)\n-Swap Warner: A simple swappy checker so you do not forget to swap back (see /prime help)\n-Dungeon Window: Has information about end game instances\n-Buff windows: A performance friendly way to track buffs or debuffs on yourself (accessed through options > buffs)")

end