OptionOptions = class(Turbine.UI.Window)
function OptionOptions:Constructor()
    local width = 1100
    local height = 590
    local x = Settings.LOX - 125
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Window.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(x,y)
    self:SetWantsKeyEvents(true)
    self:SetText("Option Options")
    self:SetVisible(true)
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    OPTIONS_OPEN = true

    self.reloadStatus = false

    self.VisibleChanged = function()
        if self.reloadStatus then 
            ReloadPlugin(true) 
        elseif not self:IsVisible() then
            ReloadPlugin(true)
        end
    end

    -- Move logic
    self.Moving = false

    self.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
  
    self.MouseUp = function()
        self.Moving = false
    end
  
    self.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    -- Options Container
    local ColorBackground = Turbine.UI.Control()
    ColorBackground:SetParent(self)
    ColorBackground:SetPosition(10, 10)
    ColorBackground:SetSize(1080, 570)
    ColorBackground:SetMouseVisible(false)
    ColorBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local EdgeColour = Turbine.UI.Control()
    EdgeColour:SetParent(self)
    EdgeColour:SetPosition(550 - 50, 15)
    EdgeColour:SetSize(100, 30)
    EdgeColour:SetMouseVisible(false)
    EdgeColour:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local MoveButton = Turbine.UI.Label()
    MoveButton:SetParent(self)
    MoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    MoveButton:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    MoveButton:SetFontStyle(Turbine.UI.FontStyle.Outline)
    MoveButton:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    MoveButton:SetForeColor(Turbine.UI.Color(1, 1, 1))
    MoveButton:SetText("Options")
    MoveButton:SetPosition(550 - 50 + 1, 15 + 1)
    MoveButton:SetSize(100 - 2, 30 - 2)
    MoveButton:SetMouseVisible(false)
    MoveButton:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    -- Reload button
    local ReloadBackground = Turbine.UI.Control()
    ReloadBackground:SetParent(self)
    ReloadBackground:SetPosition(10, 10)
    ReloadBackground:SetSize(35, 35)
    ReloadBackground:SetMouseVisible(false)
    ReloadBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local Image = Turbine.UI.Label()
    Image:SetParent(ReloadBackground)
    Image:SetPosition(0, 0)
    Image:SetSize(25, 25)
    Image:SetBackColor(Turbine.UI.Color(0, 102/255, 0))
    Image:SetWantsKeyEvents(false)
    Image:SetMouseVisible(false)

    local Button = Turbine.UI.Label()
    Button:SetParent(ReloadBackground)
    Button:SetPosition(0, 0)
    Button:SetSize(25, 25)
    Button:SetBackground(BackgroundHandler:GetBackground(MoveIcon))
    Button:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    Button:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    Button:SetWantsKeyEvents(false)
    Button:SetMouseVisible(true)

    Button.MouseClick = function()
        ReloadPlugin(true)
    end

    -- Close Button
    local CloseBackground = Turbine.UI.Control()
    CloseBackground:SetParent(self)
    CloseBackground:SetPosition(1100 - 45, 10)
    CloseBackground:SetSize(35, 35)
    CloseBackground:SetMouseVisible(false)
    CloseBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local Image = Turbine.UI.Label()
    Image:SetParent(CloseBackground)
    Image:SetPosition(10, 0)
    Image:SetSize(25, 25)
    Image:SetBackColor(Turbine.UI.Color(153/255, 0, 0))
    Image:SetWantsKeyEvents(false)
    Image:SetMouseVisible(false)

    local Button = Turbine.UI.Label()
    Button:SetParent(CloseBackground)
    Button:SetPosition(10, 0)
    Button:SetSize(25, 25)
    Button:SetBackground(BackgroundHandler:GetBackground(XIcon))
    Button:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    Button:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    Button:SetWantsKeyEvents(false)
    Button:SetMouseVisible(true)

    Button.MouseClick = function()
        self:SetVisible(false)
    end

    local innerheight = 504

    local OptionsContainer = Turbine.UI.Control()
    OptionsContainer:SetParent(self)
    OptionsContainer:SetPosition(300, 50)
    OptionsContainer:SetSize(750, innerheight)
    OptionsContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.primeBackground = Turbine.UI.Control()
    self.primeBackground:SetParent(OptionsContainer)
    self.primeBackground:SetPosition(0, 0)
    self.primeBackground:SetSize(1920, 1080)
    self.primeBackground:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/Prime.jpg"))
    self.primeBackground:SetStretchMode(1)
    self.primeBackground:SetSize(750, innerheight)
    self.primeBackground:SetOpacity(0.8)
    --self.primeBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    OptionsDic = {} 
    ActiveOptionsPages = {}
    OptionsFuncDic = {}

    OptionsDic["Target Window Old"] = true
    OptionsFuncDic["Target Window Old"] = TargetWindowTools.TargetWindowOptions

    OptionsDic["Target Window"] = true
    OptionsFuncDic["Target Window"] = TargetWindowTools.TargetWindowOptionsNew

    OptionsDic["Skill Overlay"] = true
    OptionsFuncDic["Skill Overlay"] = SkillTools.SkillOverlayOptions

    --local SkillOptions = SkillTools.SkillTimerDualSettings(OptionsContainer)
    --OptionsDic["Skill Timers"] = SkillOptions

    --local EffectOptionsWindow = EffectAlertDualSettings(OptionsContainer)
    --OptionsDic["Effect Alerts"] = EffectOptionsWindow

    --local ChatOptionsWindow = ChatAlertSettings(OptionsContainer)
    --OptionsDic["Chat Alerts"] = ChatOptionsWindow

    --OptionsDic["Loot Settings"] = true
    --OptionsFuncDic["Loot Settings"] = LootWindowSettings

    OptionsDic["Buff Bars"] = true
    OptionsFuncDic["Buff Bars"] = SkillTools.BuffTrackerSettings

    OptionsDic["Weapon Swaps"] = true
    OptionsFuncDic["Weapon Swaps"] = SwapWarnerSettings

    OptionsDic["Countdown"] = true
    OptionsFuncDic["Countdown"] = CountdownSettings

    OptionsDic["Prime UI"] = true
    OptionsFuncDic["Prime UI"] = ClassSpecificTools.PrimeUIOptions

    OptionsDic["Boss Timers"] = true
    OptionsFuncDic["Boss Timers"] = BossTimerSettings

    OptionsDic["Combat Timer"] = true
    OptionsFuncDic["Combat Timer"] = CombatTimerSettings

    OptionsDic["Move Settings"] = true
    OptionsFuncDic["Move Settings"] = MoveSettingsController

    OptionsDic["Settings"] = true
    OptionsFuncDic["Settings"] = SettingsSettings

    OptionsDic["Note Windows"] = true
    OptionsFuncDic["Note Windows"] = Notes.NoteWindowsSettings

    OptionsDic["Skill Tracker"] = true
    OptionsFuncDic["Skill Tracker"] = SkillTools.SkillTrackerWindowOptions

    OptionsDic["Class Tools"] = true
    OptionsFuncDic["Class Tools"] = ClassSpecificTools.ClassToolsOptions

    OptionsDic["Plugin Manager"] = true
    OptionsFuncDic["Plugin Manager"] = PluginsManagerSettings

    OptionsDic["Instances"] = true
    OptionsFuncDic["Instances"] = Instances.MplusOptions

    OptionsDic["Sounds"] = true
    OptionsFuncDic["Sounds"] = SoundOptions
    
    OptionsDic["Auras"] = true
    OptionsFuncDic["Auras"] = AuraCollection.AuraOptions

    OptionsDic["Alerts/Timers"] = true
    OptionsFuncDic["Alerts/Timers"] = Alerts.AlertOptions

    OptionsDic["Alerts/Timers Windows"] = true
    OptionsFuncDic["Alerts/Timers Windows"] =  Alerts.AlertWindowOptions

    ButtonsDic = {}

    SortedNames = {}
    for key, value in pairs(OptionsDic) do table.insert( SortedNames, key ) end
    table.sort( SortedNames )

    local buttonSize = innerheight / #SortedNames

    local index = 0
    for key, value in pairs(SortedNames) do
        local EdgeColour = Turbine.UI.Control()
        EdgeColour:SetParent(self)
        EdgeColour:SetPosition(50, 50 + index * buttonSize)
        EdgeColour:SetSize(250, 25)
        EdgeColour:SetMouseVisible(true)
        EdgeColour:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

        local MoveButton = Turbine.UI.Label()
        MoveButton:SetParent(self)
        MoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        MoveButton:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
        MoveButton:SetFontStyle(Turbine.UI.FontStyle.Outline)
        MoveButton:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        MoveButton:SetForeColor(Turbine.UI.Color(1, 1, 1))
        MoveButton:SetText(value)
        MoveButton:SetPosition(50 + 1, 50 + index * buttonSize + 1)
        MoveButton:SetSize(250 - 2, buttonSize - 2)
        MoveButton:SetMouseVisible(true)
        MoveButton:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
        MoveButton.MouseClick = function()
            for button, _ in pairs(ButtonsDic) do
                button:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
            end
            MoveButton:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

            for _, optionPage in pairs(ActiveOptionsPages) do
                optionPage:SetVisible(false)
            end
            if ActiveOptionsPages[value] then
                ActiveOptionsPages[value]:SetVisible(true)
            else
                ActiveOptionsPages[value] = OptionsFuncDic[value](OptionsContainer)
                ActiveOptionsPages[value]:SetVisible(true)
            end
            self.primeBackground:SetVisible(false)
        end

        ButtonsDic[MoveButton] = true

        index = index + 1
    end
end

function OptionOptions:ChangesMade()
    self.reloadStatus = true
end