function CreateTriggerListBox(width, triggerType, listboxItems, UIType, func, optionPage)
    local headerNode = Turbine.UI.TreeNode()
    headerNode:SetMouseVisible(false)
    headerNode:SetSize(width, 20)

    -- The header label with the trigger name
    headerNode.label = Turbine.UI.Label()
    headerNode.label:SetParent(headerNode)
    headerNode.label:SetSize(width, 20)
    headerNode.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    headerNode.label:SetPosition(0, 0)
    headerNode.label:SetText(triggerType)
    headerNode.label:SetBackColor(Turbine.UI.Color.Black)

    local optionsTreeNode = headerNode:GetChildNodes()

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

   local optionsHeight = 0
   local listboxHeight = 300

    valuebar.optionsControl = Turbine.UI.Control()
	valuebar.optionsControl:SetParent(valuebar)
    valuebar.optionsControl:SetPosition(0, 0)
    valuebar.optionsControl:SetBackColor(Turbine.UI.Color.DarkSlateGray)

    valuebar.nameTextBox = Turbine.UI.Lotro.TextBox()
    valuebar.nameTextBox:SetParent(valuebar.optionsControl)
    valuebar.nameTextBox:SetSize(width - 50, 20)
    valuebar.nameTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.nameTextBox:SetPosition(0, optionsHeight)

    -- Set the correct name for the name text box
    if string.find(triggerType, "Effect") then
        valuebar.nameTextBox:SetText("Effect Name")
    elseif string.find(triggerType, "Skills") then
        valuebar.nameTextBox:SetText("Skill Name")
    elseif string.find(triggerType, "Target_HealthThreshold") then
        valuebar.nameTextBox:SetText("Target Name")
    elseif string.find(triggerType, "Hits") then
        valuebar.nameTextBox:SetText("Hit Name")
    elseif string.find(triggerType, "Chat") then
        valuebar.nameTextBox:SetText("Phrase")
    elseif string.find(triggerType, "HealthThreshold")  or string.find(triggerType, "Fight")  or string.find(triggerType, "DNF") then
        valuebar.nameTextBox:SetVisible(false)
    elseif string.find(triggerType, "Player") then
        valuebar.nameTextBox:SetText("Skill Name")
    elseif string.find(triggerType, "CCBreak")  then
        valuebar.nameTextBox:SetText("Target Name (or empty for all names)")
    else
        valuebar.nameTextBox:SetText("Name")
    end

    -- Create the time input box
    if UIType ~= "Icon" and UIType ~= "Note Event" and UIType ~= "Sound" and UIType ~= "Text" and UIType ~= "MoraleBar" and  UIType ~= "Note Activation" and not(string.find(triggerType, "Highlight_On_Effect")) then
        valuebar.timeBar = Turbine.UI.Lotro.TextBox()
        valuebar.timeBar:SetParent(valuebar.optionsControl)
        valuebar.timeBar:SetSize(50, 20)
        valuebar.timeBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.timeBar:SetPosition(width - 50, optionsHeight)
        valuebar.timeBar:SetText("Time")
    end

    -- Handle fight as name input
    if string.find(triggerType, "Fight") and InstanceController then
        valuebar.fightButton = Turbine.UI.Lotro.Button()
        valuebar.fightButton:SetParent(valuebar.optionsControl)
        valuebar.fightButton:SetSize(300, 20)
        valuebar.fightButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.fightButton:SetPosition(0, optionsHeight)
        valuebar.fightButton:SetText("Fight Name")
    
    
        valuebar.fightMenu = Turbine.UI.ContextMenu()
        valuebar.fightMenuItems = valuebar.fightMenu:GetItems()
        for key, _ in spairs(InstanceController:GetFightNames(), function(t, a, b) return a < b end) do
            local menuItem = Turbine.UI.MenuItem( key )
            valuebar.fightMenuItems:Add(menuItem)
            menuItem.Click = function()
                valuebar.fightButton:SetText(key)
            end
        end
    
        valuebar.fightButton.Click = function()
            valuebar.fightMenu:ShowMenu()
        end
    end

    optionsHeight = optionsHeight + 25

    -- Browse button input box
    if string.find(triggerType, "Effect") then
        valuebar.effectBrowseButton = Turbine.UI.Lotro.Button()
        valuebar.effectBrowseButton:SetParent(valuebar.optionsControl)
        valuebar.effectBrowseButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.effectBrowseButton:SetPosition(0, optionsHeight)
        valuebar.effectBrowseButton:SetText("Browse Encountered Effects")
        valuebar.effectBrowseButton:SetSize(500, 20)

        valuebar.effectBrowseButton.Click = function()
            local effectWindow = optionPage:GetEffectWindow()
            effectWindow:SetVisible(true) 
            effectWindow:Register(valuebar.nameTextBox)
        end
    elseif string.find(triggerType, "Skill") then
        valuebar.skillBrowseButton = Turbine.UI.Lotro.Button()
        valuebar.skillBrowseButton:SetParent(valuebar.optionsControl)
        valuebar.skillBrowseButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.skillBrowseButton:SetPosition(0, optionsHeight)
        valuebar.skillBrowseButton:SetText("Browse Detected Skills")
        valuebar.skillBrowseButton:SetSize(500, 20)

        valuebar.skillBrowseButton.Click = function()
            local skillWindow = optionPage:GetSkillWindow()
            skillWindow:SetVisible(true) 
            skillWindow:Register(valuebar.nameTextBox)
        end
    elseif string.find(triggerType, "Threshold") then
        valuebar.thresholdBrowseButton = Turbine.UI.Lotro.Button()
        valuebar.thresholdBrowseButton:SetParent(valuebar.optionsControl)
        valuebar.thresholdBrowseButton:SetSize(100, 20)
        valuebar.thresholdBrowseButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.thresholdBrowseButton:SetPosition(0, optionsHeight)
        valuebar.thresholdBrowseButton:SetText("<=")

        valuebar.thresholdBrowseMenu = Turbine.UI.ContextMenu()
        valuebar.thresholdBrowseMenuItems = valuebar.thresholdBrowseMenu :GetItems()

        local leqItem = Turbine.UI.MenuItem("<=")
        valuebar.thresholdBrowseMenuItems:Add(leqItem)
        leqItem.Click = function()
            valuebar.thresholdBrowseButton:SetText("<=")
        end

        local moqItem = Turbine.UI.MenuItem(">=")
        valuebar.thresholdBrowseMenuItems:Add(moqItem)
        moqItem.Click = function()
            valuebar.thresholdBrowseButton:SetText(">=")
        end
    
        valuebar.thresholdBrowseButton.Click = function()
            valuebar.thresholdBrowseMenu:ShowMenu()
        end

        valuebar.thresholdNumberTextBox = Turbine.UI.Lotro.TextBox()
        valuebar.thresholdNumberTextBox:SetParent(valuebar.optionsControl)
        valuebar.thresholdNumberTextBox:SetSize(100, 20)
        valuebar.thresholdNumberTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.thresholdNumberTextBox:SetPosition(120, optionsHeight)
        valuebar.thresholdNumberTextBox:SetText("Percentage")

        valuebar.thresholdOperatorInforButton = InfoButton(valuebar.optionsControl, width, 100, optionsHeight + 2, "This is the operator which is used to judge if a certain threshold has been reached or passed. The options are less or equal \"<=\" or more or equal \">=\".", optionPage.infoWindow)
    end

    if UIType ~= "Icon" and UIType ~= "Text" and UIType ~= "Note Event" and UIType ~= "Sound" and ((string.find(triggerType, "Effect") and not(string.find(triggerType, "Highlight_On_Effect"))) or string.find(triggerType, "Skill")) and UIType ~= "MoraleBar" and  UIType ~= "Note Activation" or string.find(triggerType, "DNF")  then
        -- Get time for effect or skill
        valuebar.timerCheckBox = Turbine.UI.Lotro.CheckBox()
        valuebar.timerCheckBox:SetParent(valuebar.optionsControl)
        valuebar.timerCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        if string.find(triggerType, "Skill") then
            valuebar.timerCheckBox:SetText("Use skill cooldown as time")
            valuebar.timerCheckBox:SetPosition(width - 250, optionsHeight)
            valuebar.timerCheckBox:SetSize(250, 20)
        else
            valuebar.timerCheckBox:SetText("Use duration as time")
            valuebar.timerCheckBox:SetPosition(width - 200, optionsHeight)
            valuebar.timerCheckBox:SetSize(200, 20)
        end        
    end

    if string.find(triggerType, "Highlight_On_Effect") and UIType == "SkillLabel" then
        -- Get time for effect or skill
        valuebar.skillLabelHighlightBox = Turbine.UI.Lotro.CheckBox()
        valuebar.skillLabelHighlightBox:SetParent(valuebar.optionsControl)
        valuebar.skillLabelHighlightBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.skillLabelHighlightBox:SetText("Invert")
        valuebar.skillLabelHighlightBox:SetPosition(width - 200, optionsHeight)
        valuebar.skillLabelHighlightBox:SetSize(200, 20)
    end

    if string.find(triggerType, "Effect") or string.find(triggerType, "Skill") or string.find(triggerType, "Threshold") or string.find(triggerType, "DNF") then 
        optionsHeight = optionsHeight + 25
    end

    -- Add text box option
    if UIType == "Circle Timer" or UIType == "TimerGroup" or UIType == "Alert" or UIType == "AlertGroup" then
        valuebar.shownTextInputBox = Turbine.UI.Lotro.TextBox()
        valuebar.shownTextInputBox:SetParent(valuebar.optionsControl)
        valuebar.shownTextInputBox:SetSize(width - 16, 20)
        valuebar.shownTextInputBox:SetPosition(0, optionsHeight)
        valuebar.shownTextInputBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        if string.find(UIType, "Timer") then
            valuebar.shownTextInputBox:SetText("Text shown on Timer")
        else
            valuebar.shownTextInputBox:SetText("Text")
        end

        valuebar.showTextInfoButton = InfoButton(valuebar.optionsControl, width, width - 16, optionsHeight + 2, "Using \"<name>\" as your timer text will in applicable cases replace this part of the text with the name of the target of this trigger type. \nFor the CCBreak trigger you can instead use \"<Target>\", \"<Type>\" and/or \"<Culprit>\" to get the cc break target, the cc type that was broken and the source of the cc break respectively.", optionPage.infoWindow)
    end

    if UIType == "Note Event" then
        valuebar.noteEventTriggerIntputBox = Turbine.UI.Lotro.TextBox()
        valuebar.noteEventTriggerIntputBox:SetParent(valuebar.optionsControl)
        valuebar.noteEventTriggerIntputBox:SetSize(width - 16, 20)
        valuebar.noteEventTriggerIntputBox:SetPosition(0, optionsHeight)
        valuebar.noteEventTriggerIntputBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.noteEventTriggerIntputBox:SetText("Note Event Trigger")
    end

    if UIType == "Note Activation" then
        valuebar.noteActivationNameBox = Turbine.UI.Lotro.TextBox()
        valuebar.noteActivationNameBox:SetParent(valuebar.optionsControl)
        valuebar.noteActivationNameBox:SetSize(width - 16, 20)
        valuebar.noteActivationNameBox:SetPosition(0, optionsHeight)
        valuebar.noteActivationNameBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.noteActivationNameBox:SetText("Note Name")
    end

    if (UIType == "Icon" or UIType == "Text") and triggerType == "Effects" then
        valuebar.iconModeBox = Turbine.UI.Lotro.CheckBox()
        valuebar.iconModeBox:SetParent(valuebar.optionsControl)
        valuebar.iconModeBox:SetSize(100, 20)
        valuebar.iconModeBox:SetPosition(200, optionsHeight)
        valuebar.iconModeBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.iconModeBox:SetText("Toggle")
        valuebar.iconModeBox:SetChecked(true)

        valuebar.iconModeShowInfo = InfoButton(valuebar.optionsControl, width, 300, optionsHeight + 2, "This toggle sets if the icon should be shown if the effect is applied (toggled) or not applied (not toggled). This option interacts with the conjunction option in the settings too.", optionPage.infoWindow)
    end

    if UIType == "Sound" then
        valuebar.soundButton = Turbine.UI.Lotro.Button()
        valuebar.soundButton:SetParent(valuebar.optionsControl)
        valuebar.soundButton:SetSize(100, 20)
        valuebar.soundButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.soundButton:SetPosition(0, optionsHeight)
        valuebar.soundButton:SetText("SoundEffect")
    
    
        valuebar.soundMenu = Turbine.UI.ContextMenu()
        valuebar.soundMenuItems = valuebar.soundMenu :GetItems()
        for key, value in spairs(SoundEffects, function(t, a, b) return a < b end) do
            local menuItem = Turbine.UI.MenuItem( key )
            valuebar.soundMenuItems:Add(menuItem)
            menuItem.Click = function()
                valuebar.soundButton:SetText(key)
            end
        end
    
        valuebar.soundButton.Click = function()
            valuebar.soundMenu:ShowMenu()
        end
    end

    optionsHeight = optionsHeight + 25

    -- If applicable add an icon to the trigger
    if UIType == "TimerGroup" or UIType == "Timer" or UIType == "BuffBar" or UIType == "BuffBar_Target" or UIType == "AlertGroup" or (UIType == "Alert" and (string.find(triggerType, "Effect") or string.find(triggerType, "Skill"))) then
        valuebar.EffectTimerIconBox = Turbine.UI.Control()
        valuebar.EffectTimerIconBox:SetParent(valuebar.optionsControl)
        valuebar.EffectTimerIconBox:SetPosition(0, optionsHeight)
        valuebar.EffectTimerIconBox:SetSize(32,32)
        valuebar.EffectTimerIconBox:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
        valuebar.EffectTimerIconBox:SetBackground(BackgroundHandler:GetBackground(0x41007F41))
        valuebar.EffectTimerIconBox:SetVisible(true)

        valuebar.TimerIconTextBox = Turbine.UI.Lotro.TextBox()
        valuebar.TimerIconTextBox:SetParent(valuebar.optionsControl)
        valuebar.TimerIconTextBox:SetSize(110, 30)
        valuebar.TimerIconTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        valuebar.TimerIconTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.TimerIconTextBox:SetMouseVisible(false)
        valuebar.TimerIconTextBox:SetPosition(40, optionsHeight)
        valuebar.TimerIconTextBox:SetMultiline(false)
        valuebar.TimerIconTextBox:SetText(0x41007F41)

        valuebar.EffectTimerIconBox.MouseClick = function()
            local iconWindow = optionPage:GetIconWindow()
            iconWindow:SetVisible(true) 
            iconWindow:Register(valuebar.EffectTimerIconBox, valuebar.TimerIconTextBox)
        end

        valuebar.EffectTimerIconBox.MouseDoubleClick = function()
            valuebar.EffectTimerIconBox:SetBackground(BackgroundHandler:GetBackground(0x41007F41))
            valuebar.TimerIconTextBox:SetText(0x41007F41)
        end

        valuebar.iconInputShowInfo = InfoButton(valuebar.optionsControl, width, 150, optionsHeight + 7, "If applicable pick an icon to show on the UI element when this trigger is activated. You can either pick one through the menu by clicking on the box on the left or fill in your own ID in the textbox. You can also input a path to a specific image. For example: \"PrimePlugins/RaidTools/Images/RolePlay.tga\" to get the PrimePlugin roleplay icon in the image folder.", optionPage.infoWindow)

        if string.find(triggerType, "Effect") or string.find(triggerType, "Skill") then
            valuebar.takeIconFromTriggerBox = Turbine.UI.Lotro.CheckBox()
            valuebar.takeIconFromTriggerBox:SetParent(valuebar.optionsControl)
            valuebar.takeIconFromTriggerBox:SetSize(200, 20)
            valuebar.takeIconFromTriggerBox:SetPosition(200, optionsHeight + 20)
            valuebar.takeIconFromTriggerBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            if triggerType == "Skills" then
                valuebar.takeIconFromTriggerBox:SetText("Take icon from skill")
            else
                valuebar.takeIconFromTriggerBox:SetText("Take icon from effect")
            end
        end

        if string.find(triggerType, "Effect") then
            valuebar.iconMatchBox = Turbine.UI.Lotro.CheckBox()
            valuebar.iconMatchBox:SetParent(valuebar.optionsControl)
            valuebar.iconMatchBox:SetSize(100, 20)
            valuebar.iconMatchBox:SetPosition(200, optionsHeight)
            valuebar.iconMatchBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            valuebar.iconMatchBox:SetText("Match icon")

            valuebar.iconInputShowInfo = InfoButton(valuebar.optionsControl, width, 300, optionsHeight + 2, "The icon picked in the icon box will be matched against the icon supplied on the trigger, only if these are a match will the trigger active. This option is not compatible with the \"Take icon from effect\" option.", optionPage.infoWindow)
        end

        if UIType == "AlertGroup" then
            valuebar.showIconBox = Turbine.UI.Lotro.CheckBox()
            valuebar.showIconBox:SetParent(valuebar.optionsControl)
            valuebar.showIconBox:SetSize(100, 20)
            valuebar.showIconBox:SetPosition(380, optionsHeight)
            valuebar.showIconBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            valuebar.showIconBox:SetText("Show Icon")

            valuebar.showIconShowInfo = InfoButton(valuebar.optionsControl, width, 480, optionsHeight + 2, "Enable this to show the selected icon on the alert.", optionPage.infoWindow)
        end
    end

    if UIType == "TimerGroup" or (UIType == "Timer" and triggerType == "EffectAdded_Target") or UIType == "BuffBar" or UIType == "BuffBar_Target" then
        valuebar.uniqueCheckBox = Turbine.UI.Lotro.CheckBox()
        valuebar.uniqueCheckBox:SetParent(valuebar.optionsControl)
        valuebar.uniqueCheckBox:SetSize(100, 20)
        valuebar.uniqueCheckBox:SetPosition(width - 100, optionsHeight)
        valuebar.uniqueCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.uniqueCheckBox:SetText("Unique")

        valuebar.uniqueInfoShow = InfoButton(valuebar.optionsControl, width, width - 16 - 100, optionsHeight + 2, "Set this trigger as unique so it can not create multiple instances of the same trigger while the another trigger of the same type is still active.", optionPage.infoWindow)

        if UIType == "TimerGroup" then
            valuebar.overrideInfoCheckBox = Turbine.UI.Lotro.CheckBox()
            valuebar.overrideInfoCheckBox:SetParent(valuebar.optionsControl)
            valuebar.overrideInfoCheckBox:SetSize(100, 20)
            valuebar.overrideInfoCheckBox:SetPosition(width - 100, optionsHeight + 20)
            valuebar.overrideInfoCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            valuebar.overrideInfoCheckBox:SetText("Override")
    
            valuebar.overrideInfo = InfoButton(valuebar.optionsControl, width, width - 16 - 100, optionsHeight + 2 + 20, "This will override a timer in the list if a duplicate already exist instead of creating a new one. This requires the unique option to be enabled.", optionPage.infoWindow)
        end
    end

    if UIType == "BuffBar" or UIType == "BuffBar_Target" then
        valuebar.highlightCheckBox = Turbine.UI.Lotro.CheckBox()
        valuebar.highlightCheckBox:SetParent(valuebar.optionsControl)
        valuebar.highlightCheckBox:SetSize(100, 20)
        valuebar.highlightCheckBox:SetPosition(width - 100, optionsHeight + 20)
        valuebar.highlightCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.highlightCheckBox:SetText("Highlight")
    end

    optionsHeight = optionsHeight + 40

    if triggerType == "FightPhase" then
        valuebar.FightPhaseBox = Turbine.UI.Lotro.TextBox()
        valuebar.FightPhaseBox:SetParent(valuebar.optionsControl)
        valuebar.FightPhaseBox:SetSize(110, 20)
        valuebar.FightPhaseBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        valuebar.FightPhaseBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.FightPhaseBox:SetMouseVisible(false)
        valuebar.FightPhaseBox:SetPosition(0, optionsHeight)
        valuebar.FightPhaseBox:SetMultiline(false)
        valuebar.FightPhaseBox:SetText("Phase")

        valuebar.uniqueInfoShow = InfoButton(valuebar.optionsControl, width, 110, optionsHeight + 2, "The phase number specifies at what phase in the fight this trigger activates. A fight will start in phase 1 and might have additional phases as marked by the blue text popup.", optionPage.infoWindow)
    end

    if string.find(triggerType, "Fight") then
        valuebar.fightTierBox = Turbine.UI.Lotro.TextBox()
        valuebar.fightTierBox:SetParent(valuebar.optionsControl)
        valuebar.fightTierBox:SetSize(100, 20)
        valuebar.fightTierBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        valuebar.fightTierBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.fightTierBox:SetMouseVisible(false)
        valuebar.fightTierBox:SetPosition(200, optionsHeight)
        valuebar.fightTierBox:SetMultiline(false)
        valuebar.fightTierBox:SetText("Tier")

        valuebar.fightTierOverrideBox = Turbine.UI.Lotro.CheckBox()
        valuebar.fightTierOverrideBox:SetParent(valuebar.optionsControl)
        valuebar.fightTierOverrideBox:SetSize(100, 20)
        valuebar.fightTierOverrideBox:SetPosition(320, optionsHeight)
        valuebar.fightTierOverrideBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.fightTierOverrideBox:SetChecked(true)
        valuebar.fightTierOverrideBox:SetText("All tiers")

        valuebar.uniqueInfoShow = InfoButton(valuebar.optionsControl, width, 300, optionsHeight + 2, "Here you can specify the trigger to only activate on a specific tier. This can be overwritten with the checkbox which will make sure the trigger will work on any tier. Helpful for certain triggers that have dynamic timings based on tier.", optionPage.infoWindow)

        optionsHeight = optionsHeight + 20
    end

    if string.find(triggerType, "CCBreak") then
        valuebar.ccTypeTextBox = Turbine.UI.Lotro.TextBox()
        valuebar.ccTypeTextBox:SetParent(valuebar.optionsControl)
        valuebar.ccTypeTextBox:SetSize(100, 20)
        valuebar.ccTypeTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        valuebar.ccTypeTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.ccTypeTextBox:SetMouseVisible(false)
        valuebar.ccTypeTextBox:SetPosition(0, optionsHeight)
        valuebar.ccTypeTextBox:SetMultiline(false)
        valuebar.ccTypeTextBox:SetText("CC type")

        valuebar.ccTypeOverrideBox = Turbine.UI.Lotro.CheckBox()
        valuebar.ccTypeOverrideBox:SetParent(valuebar.optionsControl)
        valuebar.ccTypeOverrideBox:SetSize(120, 20)
        valuebar.ccTypeOverrideBox:SetPosition(100, optionsHeight)
        valuebar.ccTypeOverrideBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.ccTypeOverrideBox:SetText("All CC types")

        valuebar.cctypeInfoShow = InfoButton(valuebar.optionsControl, width, 220, optionsHeight + 2, "The trigger will only fire if the type of crowd control that is broken matches this type. If all types is selected it will fire for any type that is detected. The CC type are all spelled without a capital, for example \"daze\".", optionPage.infoWindow)

        optionsHeight = optionsHeight + 20
    end

    if UIType == "TimerGroup" or UIType == "Timer" or UIType == "Countdown" or UIType == "Alert" or UIType == "AlertGroup" or UIType == "Circle Timer" then
        valuebar.eventTriggerTextbox = Turbine.UI.Lotro.TextBox()
        valuebar.eventTriggerTextbox:SetParent(valuebar.optionsControl)
        valuebar.eventTriggerTextbox:SetSize(200, 20)
        valuebar.eventTriggerTextbox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        valuebar.eventTriggerTextbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.eventTriggerTextbox:SetMouseVisible(false)
        valuebar.eventTriggerTextbox:SetPosition(0, optionsHeight)
        valuebar.eventTriggerTextbox:SetMultiline(false)
        valuebar.eventTriggerTextbox:SetText("Event Keyword")

        valuebar.eventTriggerInfoShow = InfoButton(valuebar.optionsControl, width, 220, optionsHeight + 2, "This event will fire when the current trigger expires. For example, when a timer runs out this event will fire. This event will be applied to the current primeUI and all UI elements that have a TriggerEvent with this keyword will fire. This allows you to fire events at the end of other events, or create loops.", optionPage.infoWindow)

        optionsHeight = optionsHeight + 20
    end

    valuebar.addTriggerEntryButton = Turbine.UI.Lotro.Button()
    valuebar.addTriggerEntryButton:SetParent(valuebar)
    valuebar.addTriggerEntryButton:SetSize(100, 20)
    valuebar.addTriggerEntryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.addTriggerEntryButton:SetPosition(width - 120, optionsHeight)
    valuebar.addTriggerEntryButton:SetText("Add")

    optionsHeight = optionsHeight + 20

    -- Set options control to match all its children
    valuebar.optionsControl:SetSize(width, optionsHeight)

    -- Add listbox for items
    valuebar.listbox = Turbine.UI.ListBox()
    valuebar.listbox:SetParent(valuebar)
    valuebar.listbox:SetSize(width - 10, listboxHeight)
    valuebar.listbox:SetPosition(0, valuebar.optionsControl:GetHeight())
    valuebar.listbox:SetVisible(tablelength(listboxItems) > 0)

    valuebar.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    valuebar.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    valuebar.Scrollbar:SetParent(valuebar)
    valuebar.Scrollbar:SetPosition(width - 10, valuebar.optionsControl:GetHeight())
    valuebar.Scrollbar:SetSize(10, listboxHeight)
    valuebar.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    valuebar.listbox:SetVerticalScrollBar(valuebar.Scrollbar)

    for key, value in pairs(listboxItems) do
        valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(key, value, width - 10, triggerType, UIType, func, valuebar.listbox))
    end

    valuebar:SetSize(width, valuebar.listbox:GetHeight() + valuebar.optionsControl:GetHeight())

    optionsTreeNode:Add(valuebar.optionsControl)

    valuebar.addTriggerEntryButton.Click = function()
        local triggerEntry
        
        if UIType == "Circle Timer" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            local timeValue = tonumber(valuebar.timeBar:GetText())
            if valuebar.timerCheckBox and valuebar.timerCheckBox:IsChecked() then timeValue = valuebar.timerCheckBox:IsChecked() end
            if not(triggerToken) or not(timeValue) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            triggerEntry = {
                ["Time"] = timeValue,
                ["Unique"] = valuebar.uniqueCheckBox and valuebar.uniqueCheckBox:IsChecked(),
                ["Message"] = valuebar.shownTextInputBox and valuebar.shownTextInputBox:GetText(),
                ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),
            }
            if func(triggerToken, triggerEntry) then
                return
            end

            valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            valuebar.listbox:SetVisible(true)

        elseif UIType == "Countdown" or UIType == "SkillLabel" or UIType == "TimerIcon" or UIType == "ValueBar" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            local timeValue = valuebar.timeBar and tonumber(valuebar.timeBar:GetText())
            if valuebar.timerCheckBox and valuebar.timerCheckBox:IsChecked() then timeValue = valuebar.timerCheckBox:IsChecked() end
            if not(triggerToken) or (not(timeValue) and triggerType ~= "Highlight_On_Effect") or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            if valuebar.thresholdNumberTextBox then
                triggerEntry = {
                    ["Countdown"] = timeValue,
                    ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                    ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                    ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),
                    ["Highlight_Value"] = valuebar.skillLabelHighlightBox and valuebar.skillLabelHighlightBox:IsChecked(),
                }
                if func(triggerToken, triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            else
                triggerEntry = {
                    ["Countdown"] = timeValue,
                    ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),
                    ["Highlight_Value"] = valuebar.skillLabelHighlightBox and valuebar.skillLabelHighlightBox:IsChecked(),
                }
                if func(triggerToken, triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            end

            valuebar.listbox:SetVisible(true)

        elseif UIType == "Sound" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            local sound = tostring(valuebar.soundButton:GetText())
            if not(triggerToken) or not(sound) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            if valuebar.thresholdNumberTextBox then
                triggerEntry = {
                    ["Sound"] = sound,
                    ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                    ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                }
                if func(triggerToken, triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            else
                if func(triggerToken, sound) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, sound, width - 10, triggerType, UIType, func, valuebar.listbox))
            end

            valuebar.listbox:SetVisible(true)

        elseif UIType == "Icon" or UIType == "Text" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if triggerType == "HealthThreshold" and valuebar.thresholdNumberTextBox then
                triggerToken = tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            local showIconValue
            if valuebar.iconModeBox then
                showIconValue = valuebar.iconModeBox:IsChecked()
            end
            if not(triggerToken) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            if valuebar.thresholdBrowseButton then
                triggerEntry = {
                    ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                }
                if func(triggerToken, triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            else
                if func(triggerToken, showIconValue) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, showIconValue, width - 10, triggerType, UIType, func, valuebar.listbox))
            end

            
            valuebar.listbox:SetVisible(true)
        elseif UIType == "Note Event" or UIType == "Note Activation" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if triggerType == "HealthThreshold" and valuebar.thresholdNumberTextBox then
                triggerToken = tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            local tierInfo
            if valuebar.fightTierBox then
                tierInfo = tonumber(valuebar.fightTierBox:GetText())
                if valuebar.fightTierOverrideBox and valuebar.fightTierOverrideBox:IsChecked() then
                    tierInfo = valuebar.fightTierOverrideBox:IsChecked()
                end
            end

            if not(triggerToken) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            if valuebar.thresholdBrowseButton then
                triggerEntry = {
                    ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                    ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                    ["Event"] = valuebar.noteEventTriggerIntputBox and tostring(valuebar.noteEventTriggerIntputBox:GetText()),
                    ["Note_Name"] = valuebar.noteActivationNameBox and tostring(valuebar.noteActivationNameBox:GetText())
                }
                if func(triggerToken, triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            elseif string.find(triggerType, "Fight") then
                triggerEntry = {
                    ["Event"] = valuebar.noteEventTriggerIntputBox and tostring(valuebar.noteEventTriggerIntputBox:GetText()),
                    ["Note_Name"] = valuebar.noteActivationNameBox and tostring(valuebar.noteActivationNameBox:GetText()),
                    ["Phase"] = valuebar.FightPhaseBox and tonumber(valuebar.FightPhaseBox:GetText()),
                    ["Boss_Name"] = valuebar.fightButton and tostring(valuebar.fightButton:GetText()),
                    ["Tier_Info"] = tierInfo,
                }

                if func(Turbine.Engine.GetGameTime(), triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(Turbine.Engine.GetGameTime(), triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            elseif UIType == "Note Event" then
                if func(triggerToken, valuebar.noteEventTriggerIntputBox and tostring(valuebar.noteEventTriggerIntputBox:GetText())) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, valuebar.noteEventTriggerIntputBox and tostring(valuebar.noteEventTriggerIntputBox:GetText()), width - 10, triggerType, UIType, func, valuebar.listbox))
            elseif UIType == "Note Activation" then
                if func(triggerToken, valuebar.noteActivationNameBox and tostring(valuebar.noteActivationNameBox:GetText())) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, valuebar.noteActivationNameBox and tostring(valuebar.noteActivationNameBox:GetText()), width - 10, triggerType, UIType, func, valuebar.listbox))
            end

            valuebar.listbox:SetVisible(true)

        elseif UIType == "TimerGroup"  then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "Fight") and valuebar.fightButton or string.find(triggerType, "DNF") then
                triggerToken = Turbine.Engine.GetGameTime()--tostring(valuebar.fightButton:GetText())
            end
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            local timeValue = tonumber(valuebar.timeBar:GetText())
            if valuebar.timerCheckBox and valuebar.timerCheckBox:IsChecked() then timeValue = valuebar.timerCheckBox:IsChecked() end
            local iconValue = valuebar.TimerIconTextBox:GetText()
            if valuebar.takeIconFromTriggerBox and valuebar.takeIconFromTriggerBox:IsChecked() == true then iconValue = valuebar.takeIconFromTriggerBox:IsChecked() end
            local iconMatch
            if valuebar.iconMatchBox then iconMatch = valuebar.iconMatchBox:IsChecked() end
            local tierInfo
            if valuebar.fightTierBox then
                tierInfo = tonumber(valuebar.fightTierBox:GetText())
                if valuebar.fightTierOverrideBox and valuebar.fightTierOverrideBox:IsChecked() then
                    tierInfo = valuebar.fightTierOverrideBox:IsChecked()
                end
            end
            if not(triggerToken) or not(timeValue) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            triggerEntry = {
                ["Time"] = timeValue,
                ["Unique"] = valuebar.uniqueCheckBox:IsChecked(),
                ["Message"] = valuebar.shownTextInputBox:GetText(),
                ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                ["Icon"] = iconValue,
                ["Match_icon"] = iconMatch,
                ["Phase"] = valuebar.FightPhaseBox and tonumber(valuebar.FightPhaseBox:GetText()),
                ["Boss_Name"] = valuebar.fightButton and tostring(valuebar.fightButton:GetText()),
                ["Tier_Info"] = tierInfo,
                ["Override"] = valuebar.overrideInfoCheckBox and valuebar.overrideInfoCheckBox:IsChecked(),
                ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),
            }
            if func(triggerToken, triggerEntry) then
                return
            end

            valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            valuebar.listbox:SetVisible(true)
        elseif UIType == "BuffBar" or UIType == "BuffBar_Target" or UIType == "Timer" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            local timeValue = tonumber(valuebar.timeBar:GetText())
            if valuebar.timerCheckBox and valuebar.timerCheckBox:IsChecked() then timeValue = valuebar.timerCheckBox:IsChecked() end
            local iconValue = valuebar.TimerIconTextBox:GetText()
            if valuebar.takeIconFromTriggerBox and valuebar.takeIconFromTriggerBox:IsChecked() == true then iconValue = valuebar.takeIconFromTriggerBox:IsChecked() end
            local iconMatch
            if valuebar.iconMatchBox then iconMatch = valuebar.iconMatchBox:IsChecked() end
            local highlight
            if valuebar.highlightCheckBox then highlight = valuebar.highlightCheckBox:IsChecked() end
            if not(triggerToken) or not(timeValue) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            triggerEntry = {
                ["Time"] = timeValue,
                ["Unique"] = valuebar.uniqueCheckBox and valuebar.uniqueCheckBox:IsChecked(),
                ["Icon"] = iconValue,
                ["Fit_Icon"] = iconMatch,
                ["Highlight"] = highlight,
                ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),
            }
            if func(triggerToken, triggerEntry) then
                return
            end

            valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            valuebar.listbox:SetVisible(true)
        elseif UIType == "Alert" or UIType == "AlertGroup" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            if string.find(triggerType, "DNF") then
                triggerToken = Turbine.Engine.GetGameTime()
            end
            if triggerType == "HealthThreshold" then
               triggerToken = tostring(tonumber(valuebar.thresholdNumberTextBox:GetText())) .. tostring(valuebar.thresholdBrowseButton:GetText())
            end
            local timeValue = tonumber(valuebar.timeBar:GetText())
            if valuebar.timerCheckBox and valuebar.timerCheckBox:IsChecked() then timeValue = valuebar.timerCheckBox:IsChecked() end
            local iconValue = valuebar.TimerIconTextBox and valuebar.TimerIconTextBox:GetText()
            if valuebar.takeIconFromTriggerBox and valuebar.takeIconFromTriggerBox:IsChecked() == true then iconValue = valuebar.takeIconFromTriggerBox:IsChecked() end
            local iconMatch
            if valuebar.iconMatchBox then iconMatch = valuebar.iconMatchBox:IsChecked() end
            local showIcon 
            if valuebar.showIconBox then showIcon = valuebar.showIconBox:IsChecked() end
            local ccType
            if valuebar.ccTypeTextBox then
                ccType = tostring(valuebar.ccTypeTextBox:GetText())
                if valuebar.ccTypeOverrideBox and valuebar.ccTypeOverrideBox:IsChecked() then ccType = valuebar.ccTypeOverrideBox:IsChecked() end
            end
            if not(triggerToken) or not(timeValue) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            triggerEntry = {
                ["Countdown"] = timeValue,
                ["Text"] = valuebar.shownTextInputBox:GetText(),
                ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                ["Icon"] = iconValue,
                ["Match_Icon"] = iconMatch,
                ["Show_Icon"] = showIcon,
                ["CCType"] = ccType,
                ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),
            }
            if func(triggerToken, triggerEntry) then
                return
            end

            valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            valuebar.listbox:SetVisible(true)
        elseif UIType == "MoraleBar" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            if triggerToken then
                triggerEntry = {
                    ["Highlight_Colour"] = "Temp",
                }
                if func(triggerToken, triggerEntry) then
                    return
                end

                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
                valuebar.listbox:SetVisible(true)
            end
        end
    end

    optionsTreeNode:Add(valuebar)

    return headerNode
end

function InfoButton(parent, width, x, y, text, infoWindow)
    local SelectButton = Turbine.UI.Control()
	SelectButton:SetParent(parent)
	SelectButton:SetSize(16, 16)
    --SelectButton:SetBackColor(GetRandomColour())
    SelectButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SelectButton:SetBackground(BackgroundHandler:GetBackground(0x41168DAC))
	SelectButton:SetPosition(x, y)
    SelectButton.Text = text
    SelectButton.MouseEnter = function()
        infoWindow:View(SelectButton.Text)
    end

    SelectButton.MouseLeave = function()
        infoWindow:SetVisible(false)
    end

    return SelectButton
end