function GetListboxTiemPrimeUIEntry(key, value, width, triggerType, UIType, func, listbox)
    local listBoxItem = Turbine.UI.Control()
    listBoxItem:SetMouseVisible(false)
    listBoxItem:SetSize(width, 20)
    listBoxItem:SetBackColor(Turbine.UI.Color.Black)

    local innerWidth = width - 2

    local itemHeight = 0

    listBoxItem.InnerBox = Turbine.UI.Control()
    listBoxItem.InnerBox:SetParent(listBoxItem)
    listBoxItem.InnerBox:SetPosition(1, 1)
    listBoxItem.InnerBox:SetSize(innerWidth, 18)
    listBoxItem.InnerBox:SetBackColor(Turbine.UI.Color.DarkSlateBlue)

    listBoxItem.label = Turbine.UI.Label()
	listBoxItem.label:SetParent(listBoxItem.InnerBox)
	listBoxItem.label:SetSize(innerWidth, 25)
	listBoxItem.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	listBoxItem.label:SetPosition(0, itemHeight)
    if string.find(triggerType, "Fight") then
        listBoxItem.label:SetText(tostring(value.Boss_Name))
    elseif not(string.find(triggerType, "DNF")) then
        listBoxItem.label:SetText(tostring(key))
    end
    listBoxItem.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    listBoxItem.label:SetOutlineColor(Turbine.UI.Color.Black)
    listBoxItem.label:SetBackColor(Turbine.UI.Color(0.2,0.15,0.53))

    listBoxItem.RemovalButton = Turbine.UI.Lotro.Button()
    listBoxItem.RemovalButton:SetParent(listBoxItem.InnerBox)
    listBoxItem.RemovalButton:SetSize(100, 20)
    listBoxItem.RemovalButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    listBoxItem.RemovalButton:SetMouseVisible(false)
    listBoxItem.RemovalButton:SetPosition(width - 110, itemHeight + 2)
    listBoxItem.RemovalButton:SetText("Remove")

    listBoxItem.RemovalButton.Click = function()
        func(key, nil)
        listbox:RemoveItem(listBoxItem)
    end

    listBoxItem.headerDivider = Turbine.UI.Control()
    listBoxItem.headerDivider:SetParent(listBoxItem.InnerBox)
    listBoxItem.headerDivider:SetPosition(0, 25)
    listBoxItem.headerDivider:SetSize(innerWidth, 1)
    listBoxItem.headerDivider:SetBackColor(Turbine.UI.Color.Black)

    itemHeight = itemHeight + 35

    -- Handle time in trigger
    if (UIType == "Icon" or UIType == "Text") and triggerType ~= "HealthThreshold" then
        listBoxItem.iconShowBox = Turbine.UI.Lotro.CheckBox()
        listBoxItem.iconShowBox:SetParent(listBoxItem.InnerBox)
        listBoxItem.iconShowBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        listBoxItem.iconShowBox:SetChecked(value)
        listBoxItem.iconShowBox:SetPosition(0, itemHeight)
        listBoxItem.iconShowBox:SetSize(100, 20)
        listBoxItem.iconShowBox:SetText("Toggle")

        listBoxItem.iconShowBox.CheckedChanged = function()
            listBoxItem.ChangeFunction()
        end

        itemHeight = itemHeight + 25
    elseif UIType == "Note Event" or  UIType == "Note Activation" then
        listBoxItem.noteEventBar = Turbine.UI.Lotro.TextBox()
        listBoxItem.noteEventBar:SetParent(listBoxItem.InnerBox)
        listBoxItem.noteEventBar:SetSize(300, 20)
        listBoxItem.noteEventBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        listBoxItem.noteEventBar:SetPosition(0, itemHeight)
        if string.find(triggerType, "HealthThreshold") then
            listBoxItem.noteEventBar:SetText(value.Event)
        elseif value.Event then
            listBoxItem.noteEventBar:SetText(value.Event)
        elseif value.Note_Name then
            listBoxItem.noteEventBar:SetText(value.Note_Name)
        else
            listBoxItem.noteEventBar:SetText(value)
        end

        listBoxItem.noteEventBar.TextChanged = function()
            listBoxItem.ChangeFunction()
        end

        itemHeight = itemHeight + 25
    elseif UIType == "Sound" then
        listBoxItem.soundButton = Turbine.UI.Lotro.Button()
        listBoxItem.soundButton:SetParent(listBoxItem.InnerBox)
        listBoxItem.soundButton:SetSize(100, 20)
        listBoxItem.soundButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        listBoxItem.soundButton:SetPosition(0, itemHeight)
        if string.find(triggerType, "HealthThreshold") then
            listBoxItem.soundButton:SetText(value.Sound)
        else
            listBoxItem.soundButton:SetText(value)
        end
    
    
        listBoxItem.soundMenu = Turbine.UI.ContextMenu()
        listBoxItem.soundMenuItems = listBoxItem.soundMenu :GetItems()
        for key, value in spairs(SoundEffects, function(t, a, b) return a < b end) do
            local menuItem = Turbine.UI.MenuItem( key )
            listBoxItem.soundMenuItems:Add(menuItem)
            menuItem.Click = function()
                listBoxItem.soundButton:SetText(key)
                listBoxItem.ChangeFunction()
            end
        end
    
        listBoxItem.soundButton.Click = function()
            listBoxItem.soundMenu:ShowMenu()
        end

        itemHeight = itemHeight + 25
    elseif UIType == "Countdown" or UIType == "SkillLabel" or UIType == "TimerIcon" or UIType == "ValueBar" or value.Time or value.Countdown then
        if (UIType == "Countdown" or UIType == "SkillLabel" or UIType == "TimerIcon" or UIType == "ValueBar") and (type(value) == "number" or type(value) == "boolean") then
            listBoxItem.countdownTypeInfoLabel = Turbine.UI.Label()
            listBoxItem.countdownTypeInfoLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.countdownTypeInfoLabel:SetSize(50, 20)
            listBoxItem.countdownTypeInfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.countdownTypeInfoLabel:SetPosition(0, itemHeight)
            listBoxItem.countdownTypeInfoLabel:SetText("Time:")

            listBoxItem.countdownTypeBar = Turbine.UI.Lotro.TextBox()
            listBoxItem.countdownTypeBar:SetParent(listBoxItem.InnerBox)
            listBoxItem.countdownTypeBar:SetSize(50, 20)
            listBoxItem.countdownTypeBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.countdownTypeBar:SetPosition(40, itemHeight)
            if type(value) == "number" then
                listBoxItem.countdownTypeBar:SetText(tonumber(value))
            else
                --listBoxItem.countdownTypeBar:SetText("Time from trigger")
            end

            listBoxItem.countdownTypeBar.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        elseif value.Time then
            listBoxItem.timeInfoLabel = Turbine.UI.Label()
            listBoxItem.timeInfoLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.timeInfoLabel:SetSize(50, 20)
            listBoxItem.timeInfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.timeInfoLabel:SetPosition(0, itemHeight)
            listBoxItem.timeInfoLabel:SetText("Time:")

            listBoxItem.timeBar = Turbine.UI.Lotro.TextBox()
            listBoxItem.timeBar:SetParent(listBoxItem.InnerBox)
            listBoxItem.timeBar:SetSize(50, 20)
            listBoxItem.timeBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.timeBar:SetPosition(40, itemHeight)
            listBoxItem.timeBar:SetText(tonumber(value.Time))

            listBoxItem.timeBar.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        elseif value.Countdown then
            listBoxItem.countdownInfoLabel = Turbine.UI.Label()
            listBoxItem.countdownInfoLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.countdownInfoLabel:SetSize(50, 20)
            listBoxItem.countdownInfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.countdownInfoLabel:SetPosition(0, itemHeight)
            listBoxItem.countdownInfoLabel:SetText("Time:")

            listBoxItem.countdownBar = Turbine.UI.Lotro.TextBox()
            listBoxItem.countdownBar:SetParent(listBoxItem.InnerBox)
            listBoxItem.countdownBar:SetSize(50, 20)
            listBoxItem.countdownBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.countdownBar:SetPosition(40, itemHeight)
            listBoxItem.countdownBar:SetText(tonumber(value.Countdown))

            listBoxItem.countdownBar.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        if (string.find(triggerType, "Effect") and not(string.find(triggerType, "Highlight"))) or string.find(triggerType, "Skill") or string.find(triggerType, "DNF") then
            listBoxItem.timerCheckBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.timerCheckBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.timerCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            if UIType == "SkillLabel" or UIType == "ValueBar" then
                listBoxItem.timerCheckBox:SetChecked(value == true)
            elseif  UIType == "TimerIcon" then
                if value.Countdown then
                    listBoxItem.timerCheckBox:SetChecked(value.Countdown == true)
                else
                    listBoxItem.timerCheckBox:SetChecked(value)
                end
            elseif UIType == "Countdown" then
                if value.Countdown then
                    listBoxItem.timerCheckBox:SetChecked(value.Countdown == true)
                else
                    listBoxItem.timerCheckBox:SetChecked(value)
                end
            else
                listBoxItem.timerCheckBox:SetChecked(value.Time == true)
            end
            if string.find(triggerType, "Skill") then
                listBoxItem.timerCheckBox:SetText("Use skill cooldown as time")
                listBoxItem.timerCheckBox:SetPosition(100, itemHeight)
                listBoxItem.timerCheckBox:SetSize(250, 20)
            else
                listBoxItem.timerCheckBox:SetText("Use duration as time")
                listBoxItem.timerCheckBox:SetPosition(100, itemHeight)
                listBoxItem.timerCheckBox:SetSize(200, 20)
            end  

            listBoxItem.timerCheckBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        itemHeight = itemHeight + 25
    end

    if type(value) == "table" then

        if value.Operator then
            listBoxItem.operatorLabel = Turbine.UI.Label()
            listBoxItem.operatorLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.operatorLabel:SetSize(100, 20)
            listBoxItem.operatorLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            if UIType == "Icon" or UIType == "Text" then 
                itemHeight = itemHeight + 25
            end
            listBoxItem.operatorLabel:SetPosition(innerWidth - 150, itemHeight - 25) 
            listBoxItem.operatorLabel:SetText(tostring(value.Operator))


        end

        if value.Operator and value.Number and UIType ~= "Sound" then
            listBoxItem.healthThresholdTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.healthThresholdTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.healthThresholdTextBox:SetSize(50, 20)
            listBoxItem.healthThresholdTextBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.healthThresholdTextBox:SetPosition(innerWidth - 50, itemHeight - 25)
            listBoxItem.healthThresholdTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
            listBoxItem.healthThresholdTextBox:SetText(tostring(value.Number))

            listBoxItem.healthThresholdTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        -- Handle text in trigger
        if value.Message then
            listBoxItem.messageTextLabel = Turbine.UI.Label()
            listBoxItem.messageTextLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.messageTextLabel:SetSize(80, 20)
            listBoxItem.messageTextLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.messageTextLabel:SetPosition(0, itemHeight)
            listBoxItem.messageTextLabel:SetText("Text shown: ")

            listBoxItem.messageTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.messageTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.messageTextBox:SetSize(innerWidth - 80, 20)
            listBoxItem.messageTextBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.messageTextBox:SetPosition(80, itemHeight)
            listBoxItem.messageTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
            listBoxItem.messageTextBox:SetText(tostring(value.Message))

            listBoxItem.messageTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        if value.Text then
            listBoxItem.textLabel = Turbine.UI.Label()
            listBoxItem.textLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.textLabel:SetSize(80, 20)
            listBoxItem.textLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.textLabel:SetPosition(0, itemHeight)
            listBoxItem.textLabel:SetText("Text shown: ")

            listBoxItem.textBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.textBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.textBox:SetSize(innerWidth - 80, 20)
            listBoxItem.textBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.textBox:SetPosition(80, itemHeight)
            listBoxItem.textBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
            listBoxItem.textBox:SetText(tostring(value.Text))

            listBoxItem.textBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        -- Handle Unique value
        if value.Unique ~= nil then
            listBoxItem.uniqueCheckBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.uniqueCheckBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.uniqueCheckBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.uniqueCheckBox:SetChecked(value.Unique)
            listBoxItem.uniqueCheckBox:SetPosition(0, itemHeight)
            listBoxItem.uniqueCheckBox:SetSize(100, 20)
            listBoxItem.uniqueCheckBox:SetText("Unique")

            listBoxItem.uniqueCheckBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        if value.Override ~= nil then
            listBoxItem.overrideCheckBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.overrideCheckBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.overrideCheckBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.overrideCheckBox:SetChecked(value.Override)
            listBoxItem.overrideCheckBox:SetPosition(200, itemHeight)
            listBoxItem.overrideCheckBox:SetSize(100, 20)
            listBoxItem.overrideCheckBox:SetText("Override")

            listBoxItem.overrideCheckBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        -- Handle Highlight value
        if value.Highlight ~= nil then
            listBoxItem.highlightCheckbox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.highlightCheckbox:SetParent(listBoxItem.InnerBox)
            listBoxItem.highlightCheckbox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.highlightCheckbox:SetChecked(value.Highlight)
            listBoxItem.highlightCheckbox:SetPosition(100, itemHeight)
            listBoxItem.highlightCheckbox:SetSize(100, 20)
            listBoxItem.highlightCheckbox:SetText("Highlight")

            listBoxItem.highlightCheckbox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        if value.Highlight_Value ~= nil then
            listBoxItem.skillLabelhighlightCheckbox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.skillLabelhighlightCheckbox:SetParent(listBoxItem.InnerBox)
            listBoxItem.skillLabelhighlightCheckbox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.skillLabelhighlightCheckbox:SetChecked(value.Highlight_Value)
            listBoxItem.skillLabelhighlightCheckbox:SetPosition(100, itemHeight)
            listBoxItem.skillLabelhighlightCheckbox:SetSize(100, 20)
            listBoxItem.skillLabelhighlightCheckbox:SetText("Invert")

            listBoxItem.skillLabelhighlightCheckbox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        if value.Unique ~= nil or value.Highlight ~= nil or value.Highlight_Value ~= nil then
            itemHeight = itemHeight + 25
        end

        if value.Icon then
            listBoxItem.iconLabel = Turbine.UI.Label()
            listBoxItem.iconLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.iconLabel:SetSize(innerWidth - 100, 20)
            listBoxItem.iconLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.iconLabel:SetPosition(0, itemHeight)
            if value.Icon == true then
                if string.find(triggerType, "Effect") then
                    listBoxItem.iconLabel:SetText("Icon: Taken from Effect")
                else
                    listBoxItem.iconLabel:SetText("Icon: Taken from Skill")
                end
            else
                listBoxItem.iconLabel:SetText("Icon: " .. tostring(value.Icon))
            end

            if value.Match_icon ~= nil then
                listBoxItem.matchiconBox = Turbine.UI.Lotro.CheckBox()
                listBoxItem.matchiconBox:SetParent(listBoxItem.InnerBox)
                listBoxItem.matchiconBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
                listBoxItem.matchiconBox:SetChecked(value.Match_icon)
                listBoxItem.matchiconBox:SetPosition(innerWidth - 100, itemHeight)
                listBoxItem.matchiconBox:SetSize(100, 20)
                listBoxItem.matchiconBox:SetText("Match Icon")

                listBoxItem.matchiconBox.CheckedChanged = function()
                    listBoxItem.ChangeFunction()
                end
            end 

            if value.Match_Icon ~= nil then
                listBoxItem.matchIconBox = Turbine.UI.Lotro.CheckBox()
                listBoxItem.matchIconBox:SetParent(listBoxItem.InnerBox)
                listBoxItem.matchIconBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
                listBoxItem.matchIconBox:SetChecked(value.Match_Icon)
                listBoxItem.matchIconBox:SetPosition(innerWidth - 100, itemHeight)
                listBoxItem.matchIconBox:SetSize(100, 20)
                listBoxItem.matchIconBox:SetText("Match Icon")

                listBoxItem.matchIconBox.CheckedChanged = function()
                    listBoxItem.ChangeFunction()
                end
            end

            if value.Fit_Icon ~= nil then
                listBoxItem.fitIconBox = Turbine.UI.Lotro.CheckBox()
                listBoxItem.fitIconBox:SetParent(listBoxItem.InnerBox)
                listBoxItem.fitIconBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
                listBoxItem.fitIconBox:SetChecked(value.Fit_Icon)
                listBoxItem.fitIconBox:SetPosition(innerWidth - 100, itemHeight)
                listBoxItem.fitIconBox:SetSize(100, 20)
                listBoxItem.fitIconBox:SetText("Match Icon")

                listBoxItem.fitIconBox.CheckedChanged = function()
                    listBoxItem.ChangeFunction()
                end
            end

            if value.Show_Icon ~= nil then
                listBoxItem.showIconBox = Turbine.UI.Lotro.CheckBox()
                listBoxItem.showIconBox:SetParent(listBoxItem.InnerBox)
                listBoxItem.showIconBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
                listBoxItem.showIconBox:SetChecked(value.Show_Icon)
                listBoxItem.showIconBox:SetPosition(innerWidth - 200, itemHeight)
                listBoxItem.showIconBox:SetSize(100, 20)
                listBoxItem.showIconBox:SetText("Show Icon")

                listBoxItem.showIconBox.CheckedChanged = function()
                    listBoxItem.ChangeFunction()
                end
            end

            itemHeight = itemHeight + 25
        end

        if value.Tier_Info then
            listBoxItem.fightTierBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.fightTierBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.fightTierBox:SetSize(100, 20)
            listBoxItem.fightTierBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
            listBoxItem.fightTierBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.fightTierBox:SetMouseVisible(false)
            listBoxItem.fightTierBox:SetPosition(200, itemHeight)
            listBoxItem.fightTierBox:SetMultiline(false)
            if type(value.Tier_Info) == "number" then
                listBoxItem.fightTierBox:SetText(tostring(value.Tier_Info))
            end

            listBoxItem.fightTierBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
    
            listBoxItem.fightTierOverrideBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.fightTierOverrideBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.fightTierOverrideBox:SetSize(100, 20)
            listBoxItem.fightTierOverrideBox:SetPosition(320, itemHeight)
            listBoxItem.fightTierOverrideBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.fightTierOverrideBox:SetChecked(value.Tier_Info == true)
            listBoxItem.fightTierOverrideBox:SetText("All tiers")

            listBoxItem.fightTierOverrideBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        if value.CCType then
            listBoxItem.ccTypeTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.ccTypeTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.ccTypeTextBox:SetSize(100, 20)
            listBoxItem.ccTypeTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
            listBoxItem.ccTypeTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.ccTypeTextBox:SetMouseVisible(false)
            listBoxItem.ccTypeTextBox:SetPosition(0, itemHeight)
            listBoxItem.ccTypeTextBox:SetMultiline(false)
            if type(value.CCType) == "string" then
                listBoxItem.ccTypeTextBox:SetText(tostring(value.CCType))
            end

            listBoxItem.ccTypeTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
    
            listBoxItem.ccTypeOverrideBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.ccTypeOverrideBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.ccTypeOverrideBox:SetSize(120, 20)
            listBoxItem.ccTypeOverrideBox:SetPosition(100, itemHeight)
            listBoxItem.ccTypeOverrideBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.ccTypeOverrideBox:SetChecked(value.CCType == true)
            listBoxItem.ccTypeOverrideBox:SetText("All CC Types")

            listBoxItem.ccTypeOverrideBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        if  UIType == "TimerGroup" or UIType == "Timer" or UIType == "Countdown" or UIType == "Alert" or UIType == "AlertGroup" or UIType == "Circle Timer" then
            listBoxItem.eventTriggerLabel = Turbine.UI.Label()
            listBoxItem.eventTriggerLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.eventTriggerLabel:SetSize(120, 20)
            listBoxItem.eventTriggerLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.eventTriggerLabel:SetPosition(0, itemHeight)
            listBoxItem.eventTriggerLabel:SetText("Event Keyword: ")

            listBoxItem.eventTriggerTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.eventTriggerTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.eventTriggerTextBox:SetSize(200, 20)
            listBoxItem.eventTriggerTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
            listBoxItem.eventTriggerTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.eventTriggerTextBox:SetMouseVisible(false)
            listBoxItem.eventTriggerTextBox:SetPosition(120, itemHeight)
            listBoxItem.eventTriggerTextBox:SetMultiline(false)
            listBoxItem.eventTriggerTextBox:SetText(value.Event_Keyword or "")

            listBoxItem.eventTriggerTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end
    end



    listBoxItem.InnerBox:SetSize(innerWidth, itemHeight)
    listBoxItem:SetSize(width, itemHeight + 2)

    listBoxItem.ChangeFunction = function()
        func(key, nil)

        -- CHeck special case for countdown
        if listBoxItem.countdownTypeBar and not(string.find(triggerType, "Target_HealthThreshold")) then
            local time = tonumber(listBoxItem.countdownTypeBar:GetText()) or 0
            if listBoxItem.timerCheckBox and listBoxItem.timerCheckBox:IsChecked() then time = listBoxItem.timerCheckBox:IsChecked() end
            func(key, tonumber(time))
            return
        end

        -- Handle Icon case
        if listBoxItem.iconShowBox then
            func(key, listBoxItem.iconShowBox:IsChecked())
            return
        end

        -- Hanlde special note case
        if UIType == "Note Event" and not(string.find(triggerType, "HealthThreshold")) then
            func(key, tostring(listBoxItem.noteEventBar:GetText()))
        end

        -- Handle special sound case
        if UIType == "Sound" and not(string.find(triggerType, "HealthThreshold")) then
            func(key, tostring(listBoxItem.soundButton:GetText()))
        end


        local rewrittenValue = {}
        for valueKey, valueValue in pairs(value) do
            rewrittenValue[valueKey] = valueValue
        end
        
        -- Check for timer value
        if listBoxItem.timeBar then 
            rewrittenValue.Time = tonumber(listBoxItem.timeBar:GetText()) or 0
            if listBoxItem.timerCheckBox and listBoxItem.timerCheckBox:IsChecked() then rewrittenValue.Time = listBoxItem.timerCheckBox:IsChecked() end
        end

        if listBoxItem.countdownBar then 
            rewrittenValue.Countdown = tonumber(listBoxItem.countdownBar:GetText()) or 0
            if listBoxItem.timerCheckBox and listBoxItem.timerCheckBox:IsChecked() then rewrittenValue.Countdown = listBoxItem.timerCheckBox:IsChecked() end
        end

        -- Check health threshold value
        if listBoxItem.healthThresholdTextBox then
            rewrittenValue.Number = tonumber(listBoxItem.healthThresholdTextBox:GetText())
        end

        -- Check text for UI element
        if listBoxItem.messageTextBox then
            rewrittenValue.Message = tostring(listBoxItem.messageTextBox:GetText())
        end

        if listBoxItem.textBox then
            rewrittenValue.Text = tostring(listBoxItem.textBox:GetText())
        end

        -- Check unique value
        if listBoxItem.uniqueCheckBox then
            rewrittenValue.Unique = listBoxItem.uniqueCheckBox:IsChecked()
        end

        -- Check override value
        if listBoxItem.overrideCheckBox then
            rewrittenValue.Override = listBoxItem.overrideCheckBox:IsChecked()
        end

        -- Highlight
        if listBoxItem.highlightCheckbox then
            rewrittenValue.Highlight = listBoxItem.highlightCheckbox:IsChecked()
        end

        -- Match Icon
        if listBoxItem.matchiconBox then
            rewrittenValue.Match_icon = listBoxItem.matchiconBox:IsChecked()
        end

        if listBoxItem.matchIconBox then
            rewrittenValue.Match_Icon = listBoxItem.matchIconBox:IsChecked()
        end

        if listBoxItem.fitIconBox then
            rewrittenValue.Fit_Icon = listBoxItem.fitIconBox:IsChecked()
        end

        -- Show Icon
        if listBoxItem.showIconBox then
            rewrittenValue.Show_Icon = listBoxItem.showIconBox:IsChecked()
        end

        -- Hanlde normal event
        if listBoxItem.noteEventBar then
            rewrittenValue.Event = tostring(listBoxItem.noteEventBar:GetText())
        end

        -- Handle threshold sound case
        if listBoxItem.soundButton then
            rewrittenValue.Sound =  tostring(listBoxItem.soundButton:GetText())
        end

        if listBoxItem.skillLabelhighlightCheckbox then
            rewrittenValue.Highlight_Value = listBoxItem.skillLabelhighlightCheckbox:IsChecked()
        end

        -- Trigger keyword
        if listBoxItem.eventTriggerTextBox then
            if listBoxItem.eventTriggerTextBox:GetText() == "" then
                rewrittenValue.Event_Keyword = nil
            else
                rewrittenValue.Event_Keyword = tostring(listBoxItem.eventTriggerTextBox:GetText())
            end
        end

        if listBoxItem.fightTierBox then
            local tierInfo = tonumber(listBoxItem.fightTierBox:GetText()) or 1
            if listBoxItem.fightTierOverrideBox and listBoxItem.fightTierOverrideBox:IsChecked() then
                tierInfo = listBoxItem.fightTierOverrideBox:IsChecked()
            end

            rewrittenValue.Tier_Info = tierInfo
        end

        if listBoxItem.ccTypeTextBox then
            local ccTypeInfo = tostring(listBoxItem.ccTypeTextBox:GetText())
            if listBoxItem.ccTypeOverrideBox and listBoxItem.ccTypeOverrideBox:IsChecked() then
                ccTypeInfo = listBoxItem.ccTypeOverrideBox:IsChecked()
            end

            rewrittenValue.CCType = ccTypeInfo
        end

        func(key, rewrittenValue)
    end

    return listBoxItem
end